c     This program inputs the number of coincidences (n), the amplitude
c     of each pulse, p(jp), each peak separation in ns dt(lp), the pulse
c     risetime in ns (rise), the pulse falltime (fall).
c
c     This program outputs a yes or no for the trigger (t_flag), the time
c     of the trigger (thresh), and the integral of the superposition of the 
c     coincident pulses (if triggered) from time = thresh-rise through
c     time = 100 ns. (ADC)
c
      program coinc
c
c   Assume threshold level at 1.1 max peak value of each pulse
c
        real p(240), dt(239)
c
        print *, 'Enter pulse risetime (ns): '
        read *, rise
        print *, 'Enter pulse falltime (ns): '
        read *, fall
        print *, 'Enter number of peaks: '
        read *, n
c
        do 3 jp=1,n
           print *,'Enter peak amp.'
           read *, p(jp)
 3      continue
c       
        do 4 lp=2,n
           print *, 'Enter peak separation.'
           read *, dt(lp)
 4      continue
c
c
            ADC=0.
            thresh=0.
            t_flag=0.
            time=-1.
 2          time=time+1.
            pulse=0.
c
c Check whether peaks ever trigger 1.1 threshold****************************   
            do 9 mp=1,n
               pulse=pulse+pulse_h(rise,fall,p(mp),time-dt(mp))
 9          continue
c
            if(pulse.ge.1.1) then
               if(t_flag.eq.0.) then
                   t_flag=1.
                   thresh=time
               endif
            endif
c *************************************************************************
c
            if(time.gt.99.) then
               if(t_flag.eq.1.) then
c
c integrate *******************************************************
                  do 5 kp=1,200
                     m=real(kp)
c                     
                   do 7 ip=1,n
                   ADC=ADC + pulse_h(rise,fall,p(ip),(thresh-rise-
     1                 dt(ip)-1.+ m))
 7                 continue
                     if((thresh-rise-1.+ m).gt.99.) go to 6
 5                continue
c *****************************************************************
c
 6                print *, t_flag, thresh, ADC 
               endif
               goto 8
              endif
            go to 2
 8          stop
      end
c
c   A function to produce a simple PMT lineshape: linear rise + exp. fall
c
      function pulse_h(rise,fall,peak,t)
c
      if(t.lt.0.) then
         pulse_h=0.
         return
      endif
c
      if(t.lt.rise) then
         pulse_h=peak*t/rise
      else
         pulse_h=peak/exp((t-rise)/fall)
      endif
      return
      end
