************************************************************************    
*
       SUBROUTINE CALO_FILL
*
*      History
*      -------
*
*      102596 EF created
*      
*      ASSIGN NP_CSI_S, A1T_CSI_S AND A2T_CSI_S TO CRYSTALS THAT ARE NOT 
*      TOMOGRAPHED
*
************************************************************************    
*
      IMPLICIT NONE
      REAL NP_CSI_S_AV,A1T_CSI_S_AV,A2T_CSI_S_AV
      INTEGER I,IPARAM

      INCLUDE '../common.inc'

c--   Define year-specific CsI crystal set-up
      DO I=1,240
         IF     (IYEAR.EQ.1993) THEN
            ON_CSI_G(I)=ON_1993CSI_G(I)
         ELSEIF (IYEAR.EQ.1994) THEN
            ON_CSI_G(I)=ON_1994CSI_G(I)
         ELSEIF (IYEAR.EQ.1995) THEN
            ON_CSI_G(I)=ON_1995CSI_G(I)
         ELSEIF (IYEAR.EQ.1996) THEN
            ON_CSI_G(I)=ON_1996CSI_G(I)
         ELSEIF (IYEAR.EQ.1997) THEN
            ON_CSI_G(I)=ON_1997CSI_G(I)
         ELSEIF (IYEAR.EQ.1998) THEN
            ON_CSI_G(I)=ON_1998CSI_G(I)
         ELSEIF (IYEAR.EQ.1999) THEN
            ON_CSI_G(I)=I
         ELSEIF (IYEAR.EQ.2000) THEN
            ON_CSI_G(I)=ON_2000CSI_G(I)
            print *, 'on_csi_g',i,'is',on_csi_g(i)
         ELSE
            PAUSE
         ENDIF
      ENDDO

C--   Make up the non-exsisting crystals
      CALL RLUXGO(ILUX,778888,0,0)

      DO I=1,10
 1111   IF (NP_CSI_S(I).LT.10..OR.
     +    A1T_CSI_S(I).GE.10..OR.A2T_CSI_S(I).GE.10..or.
     +    on_csi_g(i).eq.888)THEN
          CALL RANLUX(RVEC,ILEN)
          IPARAM=NINT(10*RVEC(1))
          NP_CSI_S(I)=NP_CSI_S(IPARAM)
          A1T_CSI_S(I)=A1T_CSI_S(IPARAM)
          A2T_CSI_S(I)=A2T_CSI_S(IPARAM)
        ENDIF
      IF (NP_CSI_S(I).LT.10..OR.
     +    A1T_CSI_S(I).GE.10..OR.A2T_CSI_S(I).GE.10.)GOTO 1111
      ENDDO

      DO I=11,200
 1112    IF (NP_CSI_S(I).LT.10..OR.
     +    A1T_CSI_S(I).GE.10..OR.A2T_CSI_S(I).GE.10..or.
     +    on_csi_g(i).eq.888)THEN
          CALL RANLUX(RVEC,ILEN)
          IPARAM=11+NINT(190*RVEC(1))
          NP_CSI_S(I)=NP_CSI_S(IPARAM)
          A1T_CSI_S(I)=A1T_CSI_S(IPARAM)
          A2T_CSI_S(I)=A2T_CSI_S(IPARAM)
        ENDIF
      IF (NP_CSI_S(I).LT.10..OR.
     +    A1T_CSI_S(I).GE.10..OR.A2T_CSI_S(I).GE.10.)GOTO 1112
      ENDDO

      DO I=201,220
 1113    IF (NP_CSI_S(I).LT.10..OR.
     +    A1T_CSI_S(I).GE.10..OR.A2T_CSI_S(I).GE.10..or.
     +    on_csi_g(i).eq.888)THEN
          CALL RANLUX(RVEC,ILEN)
          IPARAM=201+NINT(20*RVEC(1))
          NP_CSI_S(I)=NP_CSI_S(IPARAM)
          A1T_CSI_S(I)=A1T_CSI_S(IPARAM)
          A2T_CSI_S(I)=A2T_CSI_S(IPARAM)
        ENDIF
      IF (NP_CSI_S(I).LT.10..OR.
     +    A1T_CSI_S(I).GE.10..OR.A2T_CSI_S(I).GE.10.)GOTO 1113
      ENDDO

      DO I=221,250
 1114    IF (NP_CSI_S(I).LT.10..OR.
     +    A1T_CSI_S(I).GE.10..OR.A2T_CSI_S(I).GE.10..or.
     +    on_csi_g(i).eq.888)THEN
          CALL RANLUX(RVEC,ILEN)
          IPARAM=221+NINT(30*RVEC(1))
          NP_CSI_S(I)=NP_CSI_S(IPARAM)
          A1T_CSI_S(I)=A1T_CSI_S(IPARAM)
          A2T_CSI_S(I)=A2T_CSI_S(IPARAM)
        ENDIF
      IF (NP_CSI_S(I).LT.10..OR.
     +    A1T_CSI_S(I).GE.10..OR.A2T_CSI_S(I).GE.10.)GOTO 1114
      ENDDO

      np_CSI_S_av=0.
      a1t_CSI_S_av=0.
      a2t_CSI_S_av=0.
      do i=1,200
        np_CSI_S_av=np_CSI_S_av+np_CSI_S(i)/200.
        a1t_CSI_S_av=a1t_CSI_S_av+a1t_CSI_S(i)/200.
        a2t_CSI_S_av=a2t_CSI_S_av+a2t_CSI_S(i)/200.
      enddo
      write(6,666) np_CSI_S_av,a1t_CSI_S_av,a2t_CSI_S_av
      write(6,*) ' '

      np_CSI_S_av=0.
      a1t_CSI_S_av=0.
      a2t_CSI_S_av=0.
      do i=201,240
        np_CSI_S_av=np_CSI_S_av+np_CSI_S(i)/40.
        a1t_CSI_S_av=a1t_CSI_S_av+a1t_CSI_S(i)/40.
        a2t_CSI_S_av=a2t_CSI_S_av+a2t_CSI_S(i)/40.
      enddo
      write(6,666) np_CSI_S_av,a1t_CSI_S_av,a2t_CSI_S_av
      write(6,*) ' '

 666  format(3f8.3)

      DO I=1,240
        IF   (IGCALO.EQ.1) THEN
             NP_CSI_G(I) = NP_CSI_S(I)
             A1T_CSI_G(I)=A1T_CSI_S(I)
             A2T_CSI_G(I)=A2T_CSI_S(I)
        ELSEIF (IGCALO.EQ.2) THEN
             IF (ON_CSI_G(I).GE.1.AND.ON_CSI_G(I).LE.250) THEN 
               NP_CSI_G(I) = NP_CSI_S(ON_CSI_G(I))
               A1T_CSI_G(I)=A1T_CSI_S(ON_CSI_G(I))
               A2T_CSI_G(I)=A2T_CSI_S(ON_CSI_G(I))
               print *, 'a1t_csi_g',i,'is',a1t_csi_g(i)
             ELSEIF (ON_CSI_G(I).EQ.888) THEN
               NP_CSI_G(I) = NP_CSI_S(I)
               A1T_CSI_G(I)=A1T_CSI_S(I)
               A2T_CSI_G(I)=A2T_CSI_S(I)
               print *, 'a1t_csi_g',i,'is',a1t_csi_g(i)
             ENDIF
        ENDIF
      ENDDO

      RETURN
      END   
