************************************************************************    
*
       SUBROUTINE ADC1
*
*      History
*      -------
*
*      101095 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'

      REAL AMVEC(1),DESSTEP
      INTEGER NPVEC(1)

C--   No summing after ADC gate closes
      IF(1.E9*TOFG.gt.110.) RETURN   

C--   Do only if we are in sensitive detector and energy is deposited
      IF (ISVOL.NE.0.AND.DESTEP.GT.0.) THEN
      
C--   smeared energy step (nonuniformity+photoelectron statistics) DESSTEP
      DESSTEP=DESTEP

C--   transformation to daughter coordinate system
      CALL GMTOD(VECT(1),CSIVECT,1)

C--   CsI modules
      IF (IDTYPE.GE.1.AND.IDTYPE.LE.240) THEN

C--    Total energy deposited in calorimeter, MeV
        EDEPCAL=EDEPCAL+1000.*DESTEP
        write (66,66) IDTYPE,DESTEP,EDEPCAL
 66     FORMAT ('IDTYPE =',I4,T25,'DESTEP =',F12.5,
     +           T50,'EDEPCAL =',F12.5)

C--     z=0 at front CsI detector face
        CSIVECT(3)=CSIVECT(3)+11.

C--     Take into account the optical nonuniformity of CsI detector response
C--     UNIFORMITY(1), and photoelectron statistics PHOTOELECTRON(1)

        AMVEC(1)=1000.*DESTEP*PHOTOELECTRON(1) ! average number of phel created
        CALL GPOISS(AMVEC,NPVEC,1)             ! Poisson number of phel created
 
        DESSTEP=( 1.-UNIFORMITY(1)*CSIVECT(3)/(22.*100.) ) * DESTEP 
c     +         * (AMVEC(1)-NPVEC(1))/AMVEC(1)
        IF (DESSTEP.LT.0.) DESSTEP=0.
        EDEP(IDTYPE)=EDEP(IDTYPE)+1000.*DESSTEP
      ENDIF

C--   Plastic veto staves 
      IF (IDTYPE.GE.241.AND.IDTYPE.LE.260) THEN
        AMVEC(1)=1000.*DESTEP*50.              ! average number of phel created
        CALL GPOISS(AMVEC,NPVEC,1)             ! Poisson number of phel created
        DESSTEP=DESTEP*(AMVEC(1)-NPVEC(1))/AMVEC(1)
        IF (DESSTEP.LT.0.) DESSTEP=0.
        EDEP(IDTYPE)=EDEP(IDTYPE)+1000.*DESTEP
      ENDIF

C--   Target 
      IF (IDTYPE.GE.261.AND.IDTYPE.LE.329) THEN
        EDEP(IDTYPE)=EDEP(IDTYPE)+1000.*DESTEP
      ENDIF        

C--   Cosmic Veto 
      IF (IDTYPE.GE.331.AND.IDTYPE.LE.335) THEN
        EDEP(IDTYPE)=EDEP(IDTYPE)+1000.*DESTEP
      ENDIF        

C--   Degrader 
      IF (IDTYPE.EQ.330) THEN
        EDEP(IDTYPE)=EDEP(IDTYPE)+1000.*DESTEP
      ENDIF        

      ENDIF

      RETURN
      END   
