************************************************************************    
*
       SUBROUTINE MWPC_TRACK
*
*      History
*      -------
*
*      102395 EF created
*
************************************************************************    
*
      IMPLICIT NONE
      INCLUDE '../common.inc'

      REAL MW11(6),MW12(6),XINT(6),PZINT(4)
      INTEGER I,J,MWFLAG,NM1,NM2
      REAL RHOMW1,SINT

C--   Handles up to NCHPART in MWPCs
      IF(ISTAK.GE.NCHPART)GOTO 9999

      RHOMW1=SQRT(VECT(1)**2+VECT(2)**2) ! axial distance from z-axis
      NM1=NMWPC1+1   ! MWPC1 hit index
      NM2=NMWPC2+1   ! MWPC2 hit index

C--   Tracking in FIRST MWPC, new particle ISTAK
      IF(ABS(VECT(3)).LE.17.5.AND.ABS(RHOMW1-6.015).LE.0.275
     +.AND.DESTEP.GT.0..AND.IMWPC1(NM1).EQ.0.AND.NEWP1.NE.ISTAK)THEN 
         DO I=1,6
            J=I+3
            IF (I.LE.3) THEN
              MW11(I)=0.1*VECT(I)           ! first point inside cylinder
              MW12(I)=10.*(VECT(I)+VECT(J)) ! second point outside cylinder
            ELSE
              MW11(I)=1.          ! track curvature
              MW12(I)=1.
            ENDIF
         ENDDO
C--      track-cylinder intersection MWFLAG=1, GEANT routine HITS400-1
         CALL GICYL(6.015,MW11,MW12,0.1,0.1,2,XINT,SINT,
     +              PZINT,MWFLAG)
         CALL RANLUX(RVEC,ILEN)
         IF(MWFLAG.EQ.1.AND.RVEC(1).LT.EMWPC(1).AND. ! EMWPC(1)=MWPC1 effic
     +      ABS(XINT(3)).LT.17.5)THEN 
            CALL RNORMX(RVEC,ILEN,RANLUX)           ! rms dx,dy,dz=0.085 cm
            WPC1(1,NM1)=XINT(1)*(1.+0.085*RVEC(1))  ! reconstructed x1
            CALL RNORMX(RVEC,ILEN,RANLUX)
            WPC1(2,NM1)=XINT(2)*(1.+0.085*RVEC(1))  ! reconstructed y1
            CALL RNORMX(RVEC,ILEN,RANLUX)
            WPC1(3,NM1)=XINT(3)*(1.+0.085*RVEC(1))  ! reconstructed z1
            IMWPC1(NM1)=1                           ! NM1 hit in 1. chamber
            NMWPC1=NMWPC1+1
            NEWP1=ISTAK
         ENDIF
      ENDIF
*
C--   Tracking in SECOND MWPC, new particle ISTAK
      IF(ABS(VECT(3)).LE.27..AND.ABS(RHOMW1-12.0).LE.0.275
     +.AND.DESTEP.GT.0..AND.IMWPC2(NM2).EQ.0.AND.NEWP2.NE.ISTAK)THEN
         DO I=1,6
            J=I+3
            IF (I.LE.3) THEN
              MW11(I)=0.1*VECT(I)           ! first point inside cylinder
              MW12(I)=10.*(VECT(I)+VECT(J)) ! second point outside cylinder
            ELSE
              MW11(I)=1.
              MW12(I)=1.
            ENDIF
         ENDDO
C--      track-cylinder intersection MWFLAG=1, GEANT routine HITS400-1
         CALL GICYL(12.01,MW11,MW12,0.1,0.1,2,XINT,SINT,
     +              PZINT,MWFLAG)
         CALL RANLUX(RVEC,ILEN)
         IF(MWFLAG.EQ.1.AND.RVEC(1).LT.EMWPC(2).AND. ! EMWPC(2)=MWPC2 effic
     +   ABS(XINT(3)).LT.27.)THEN
            CALL RNORMX(RVEC,ILEN,RANLUX)           ! rms dx,dy,dz=0.085 cm
            WPC2(1,NM2)=XINT(1)*(1.+0.085*RVEC(1))  ! reconstructed x2
            CALL RNORMX(RVEC,ILEN,RANLUX)
            WPC2(2,NM2)=XINT(2)*(1.+0.085*RVEC(1))  ! reconstructed y2
            CALL RNORMX(RVEC,ILEN,RANLUX)
            WPC2(3,NM2)=XINT(3)*(1.+0.085*RVEC(1))  ! reconstructed z2
            IMWPC2(NM2)=1                           ! NM2 hit in 2. chamber
            NMWPC2=NMWPC2+1
            NEWP2=ISTAK
         ENDIF
      ENDIF

 9999 CONTINUE

      RETURN
      END   
