

#include "placement.h"


void LoadCoordinates(void)
{
	FILE *file=NULL;
	char buff[30000];
	char *pos,*tmp_pos,*end_pos;
	long bytesRead;
	char str1[256],str2[256];
	short i,j,k;


	file=fopen("module.def","r");
	if(!file){printf("\n Error opening \"module.def\"\n");exit(1);};
	
	bytesRead=fread(buff,1,30000,file);
	if(file)fclose(file);
	printf("%ld bytes read from \"module.def\".\n",bytesRead);
	buff[bytesRead]=0;

	pos=strstr(buff,"P01");
	if(!pos){printf("Couldn't find \"P01\"\n");exit(2);};
//printf("Found \P01\" at:%ld\n",(long)pos);
	/* make pos point to "1" (index of first crystal) */
	while(isspace(*(--pos)));	
	//Replace all carriage returns with terminating nulls
	end_pos=pos;
	while(end_pos=strstr(end_pos,"\n"))*(end_pos++)=0;


	for(i=0;i<220;i++){
		while(!isspace(*(++pos)));	//move to first whitespace
		while(isspace(*(++pos)));	//move to crystal name
		while(!isspace(*(++pos)));	//move to second whitespace
		while(isspace(*(++pos)));	//move to number of points column
		while(!isspace(*(++pos)));	//move to third whitespace
		while(isspace(*(++pos)));	//move to theta coordinate
		crystal_y[i]=atof(pos);

		while(!isspace(*(++pos)));	//move to fourth whitespace
		while(isspace(*(++pos)));	//move to phi coordinate

		crystal_x[i]=atof(pos);

	//	printf("Crystal#%d:   theta:%5.2f  phi:%f\n",i+1,crystal_y[i],crystal_x[i]);

		// Make pos point to next row.
		pos+=strlen(pos);
		pos++;
	};
	printf("Found coordinates for %d crystals\n",i);
	
}


void ReadClusters(void)
{
	FILE *file=NULL;
	short i,j,k,clus,crystal;
	long bytesRead;
	char buff[20000];
	char *pos,*tmp_pos;
	
	file=fopen("clusters.f","r");
	if(!file){
		printf("couldn't open file!\n");
		exit(1);
	};
	
	bytesRead=fread(buff,1,20000,file);
	if(file)fclose(file);
	printf("%ld bytes read from \"clusters.f\"\n",bytesRead);

	buff[bytesRead]=0;

	pos=strstr(buff,"DATA CC/");
	if(!pos){printf("Couldn't find start of table.exiting...\n");exit(2);};
	pos+=strlen("DATA CC/");
	
	tmp_pos=strstr(pos,"CLUSTER 60");
	if(!tmp_pos){printf("Couldn't find end of table. exiting...\n");exit(3);};
	tmp_pos+=strlen("CLUSTER 60");
	*tmp_pos=0;

	//replace final "/" with comma
	tmp_pos=strstr(pos,"/");
	*tmp_pos=',';
	tmp_pos++;*tmp_pos='!';
	tmp_pos++;*tmp_pos=0;

	//replace all commas with x's (commas may be percieved as part of a number)
	while(tmp_pos=strstr(pos,","))*tmp_pos='x';


	for(clus=1;clus<=60;clus++){
		tmp_pos=strstr(pos,"!");
		*tmp_pos=0;
		k=0;
		while(tmp_pos=strstr(pos,"x")){
			while(!isspace(*(--tmp_pos)) && *tmp_pos!='x');
			tmp_pos++;
			crystal=atoi(tmp_pos)-1;
			clusters[clus-1][k++]=crystal;
			pos=strstr(pos,"x");
			pos++;
		};
		if(clus<60){
			pos+=strlen(pos);
			pos++;
			pos=strstr(pos,"x");
			while(!isspace(*(--pos)));
		};
	};
	printf("%d clusters defined.\n",clus-1);
//	printf("Cluster 1:%d,%d,%d,%d\n",clusters[0][0],clusters[0][1],clusters[0][2],clusters[0][3]);
}
