/********************************/
/*     Ignore this file         */
/********************************/
#include "xwin.h" 

Display *dpy=0;
Screen *screen=0;
WindowPtr thePort;


WindowPtr NewWindow(Rect *bounds,char* windName)
{
	int window1W = bounds->right-bounds->left;
	int window1H = bounds->bottom-bounds->top;
	int window1X = bounds->left;
	int window1Y = bounds->top;
	XSetWindowAttributes xswa;
	XGCValues xgcv;
	unsigned long gcMask=0;
	Font font;
	WindowPtr temp=0;

	temp=(WindowPtr)malloc(sizeof(WindowRec));
	if(temp==0)return 0;

	if(!dpy)
	{
		dpy = XOpenDisplay(0);
         	if (!dpy)
		{
			printf("Display not opened!\n");
			exit(-1);
         	};
		screen = XDefaultScreenOfDisplay(dpy);
		XSynchronize(dpy,1);
	};

         /* Create the window */

	xswa.event_mask = 	ExposureMask | StructureNotifyMask |
				KeyPressMask | KeyReleaseMask |
				ButtonPressMask | ButtonReleaseMask |
				ButtonMotionMask;

	xswa.background_pixel = doDefineColor(whiteColor);

	temp->window = XCreateWindow(dpy, XRootWindowOfScreen(screen),
		window1X, window1Y, window1W, window1H, 0,
		XDefaultDepthOfScreen(screen), InputOutput,
		XDefaultVisualOfScreen(screen), 
		CWEventMask | CWBackPixel,
		&xswa);
	
	XStoreName(dpy,temp->window, windName);

	/* Create graphics context. */

	xgcv.foreground = doDefineColor(blackColor);
	xgcv.background = doDefineColor(whiteColor);

	temp->gc = XCreateGC(dpy,temp->window,gcMask,&xgcv);

	font = XLoadFont(dpy, FontName);
	XSetFont(dpy, temp->gc, font);

	XMapWindow(dpy,temp->window);

	SetRect(&temp->portRect,0,0,bounds->right-bounds->left,
		bounds->bottom-bounds->top);
	thePort=temp;

	return temp;
}

void DisposeWindow(WindowPtr wind)
{
	XDestroyWindow(dpy, wind->window);
	cfree((char*)wind);
}

void SetPort(WindowPtr newPort)
{
	thePort=newPort;
}

void ForeColor(int color)
{
	color=doDefineColor(color);
	XSetForeground(dpy,thePort->gc,(unsigned long)color);
}

void BackColor(int color)
{
	color=doDefineColor(color);
	XSetBackground(dpy,thePort->gc,(unsigned long)color);
}


int doDefineColor(int n)
{
	int pixel;
	XColor exact_color,screen_color;
	char *colors[] = {
		"black",
		"white",
		"cyan",
		"magenta",
		"red",
		"blue",
		"green",
		"yellow",
		};
	if(n==blackColor)return XBlackPixel(dpy,XDefaultScreen(dpy));
	if(n==whiteColor)return XWhitePixel(dpy,XDefaultScreen(dpy));


	if ((XDefaultVisualOfScreen(screen))->class == TrueColor
		|| (XDefaultVisualOfScreen(screen))->class == PseudoColor
		|| (XDefaultVisualOfScreen(screen))->class == DirectColor
		|| (XDefaultVisualOfScreen(screen))->class == StaticColor)

		if (XAllocNamedColor(dpy, XDefaultColormapOfScreen(screen),
			colors[n], &screen_color, &exact_color))

			return screen_color.pixel;
	else

		switch (n)
		{
			case blackColor:                   
				return XBlackPixel(dpy,XDefaultScreen(dpy));
				break;
			default:
				return XWhitePixel(dpy,XDefaultScreen(dpy));
				break;
		};

}

void ShowCursor(void)
{
	/* This here for compatibility with mac */
}

void HideCursor(void)
{
	/* This here for compatibility with mac */
}


