************************************************************************    
*
       SUBROUTINE TDC2
*
*      History
*      -------
*      101095 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'

      REAL DIST,TPMT,TACT
      INTEGER IBIN
*
*-----------------------------------------------------------------------
* 
*  EDEP(IDTYPE): Energy deposition in specific detector. IDTYPEs are
*                defined in README.TXT
*  ITDEP(IDTYPE):Flag =1 if specific detector triggerd its TDC
*  CSIVECT:      Actual position in CsI body system z=0 at front
*
*-----------------------------------------------------------------------

C--   Do only if we are in sensitive detector and energy is deposited
      IF (ISVOL.EQ.0.OR.DESTEP.EQ.0.) RETURN

C--   Calculate distance between actual position and PMT
C--   in 22 cm long CsI Modules
      DIST = 0.
      IF (IDTYPE.GE.1.AND.IDTYPE.LE.240) DIST =
     +   SQRT(CSIVECT(1)**2+CSIVECT(2)**2+(CSIVECT(3)-22.)**2)

c       if(idtype.gt.200.and.idtype.lt.221.and.itdep(idtype).eq.0) 
c     +   print *, ' '
c       if(idtype.gt.200.and.idtype.lt.221.and.itdep(idtype).eq.0)
c     + print *,idtype,
c     + acosd(vect(3)/sqrt(vect(1)**2+vect(2)**2+vect(3)**2)), 
c     + atan2d(vect(2),vect(1))+180.

C--   Old method: Check if TDC not fired and energy deposition above thr.
C--   Return if TDC already fired or energy deposition below threshold
      IF(EDEP(IDTYPE).GT.THRESHOLD(1)) THEN

C--   TDEP in nanoseconds
        TACT = 1.E9*TOFG + DIST/(29.9792/1.8)
        IF (ITDEP(IDTYPE) .EQ. 1) THEN
          TDEP(IDTYPE) = MIN(TDEP(IDTYPE), TACT)
        ELSE
          TDEP(IDTYPE) = TACT
        ENDIF

C--   Mark TDC as fired
        ITDEP(IDTYPE)=1
      ENDIF

C--   New method: store energy deposition in TOF array

      IF (IDTYPE.GE.1.AND.IDTYPE.LE.240) THEN

C--   Calculate time when light reaches PM [in ns]

        TPMT = 1.E9*TOFG + DIST/(29.9792/1.8)

        IBIN = TPMT / 0.010 + 1      ! binning is 10 ns

        IF (IBIN.GT.500) IBIN = 500

C--   Increment time bin by deposited energy

        THISTO(IDTYPE,IBIN) = THISTO(IDTYPE,IBIN) + 1000.*DESTEP
        
      ENDIF

Ctemporary code-EF--------------------------------------------------------
c       IF (IDTYPE.GE.1.AND.IDTYPE.LE.240.AND.ITDEP(IDTYPE).EQ.0
c     +                .AND.EDEPTOT.EQ.0.) THEN
c       CSITHT(IDTYPE)=CSITHT(IDTYPE) + ACOSD( VECT(3)/
c     +               SQRT(VECT(1)**2+VECT(2)**2+VECT(3)**2) )
c       CSIPHI(IDTYPE)=CSIPHI(IDTYPE) + ATAN2D(VECT(2),VECT(1))
c       CSIANG(IDTYPE)=CSIANG(IDTYPE) + 1.
c
c       ENDIF
C-----------------------------------------------------------------------

      RETURN
      END   
