************************************************************************
*
      SUBROUTINE UNIF_TABLE
*
*     History
*     -------
*
*     020796 EF created
*
*     PURPOSE: Reads in the values of non-uniformity function
*     for 1x1x1 cm CsI volume bins and stores it in array UNIF_VAL(I,J,K)
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'

      REAL X,Y,Z,UNIF_V,UNIF_SUM,UNIF_NUM
      INTEGER I,J,K,N

      OPEN (UNIT=87,
     +FILE='/fs24/pibeta/geant/electronics/unif10_val.dat',
     +STATUS='OLD')

C*-   Read in the values of non-uniformity function and
C*-   normalize to 80 phel/MeV

      UNIF_SUM=0.
      UNIF_NUM=0.
 19   READ (87,*,END=91) X,Y,Z,UNIF_V

C*- Calorimeter is calibrated with e+ that shower in first 3 cm of CsI

      IF(UNIF_V.GT.0..AND.Z.LE.2.5) UNIF_SUM=UNIF_SUM+UNIF_V
      IF(UNIF_V.GT.0..AND.Z.LE.2.5) UNIF_NUM=UNIF_NUM+1.
      I=X-5.+0.5
      J=Y-4.+0.5
      K=Z+0.5
c      write (6,66) i,j,k,x,y,z
c 66   format(3i10,3f10.2)
      UNIF_VAL(I,J,K)=0.
      UNIF_VAL(I,J,K)=UNIF_V
      GOTO 19

 91   CLOSE (87)

      DO 22 I=-8,8
        DO 22 J=-8,8
          DO 22 K=1,24
          IF (UNIF_VAL(I,J,K).GT.0.)
     +    UNIF_VAL(I,J,K)=UNIF_VAL(I,J,K)*1./(UNIF_SUM/UNIF_NUM)
 22   CONTINUE

      N=0
      DO 23 I=-8,8
        DO 23 J=-8,8
          DO 23 K=1,24      
 24       N=N+1
          IF (UNIF_VAL(I,J,K).LE.0..AND.ABS(I-SIGN(N,I)).LE.8.AND.
     +    ABS(J-SIGN(N,J)).LE.8.AND.ABS(K-SIGN(N,K-12)).LE.11.)
     +    UNIF_VAL(I,J,K)=
     +    UNIF_VAL(I-SIGN(N,I),J-SIGN(N,J),K-SIGN(N,K-12))
c          write (6,67) i,j,k,I-SIGN(N,I),J-SIGN(N,J),K-SIGN(N,K-12)
c 67       format(6i10)
          IF (UNIF_VAL(I,J,K).LE.0.) UNIF_VAL(I,J,K)=1.
 23   CONTINUE

      RETURN
      END   
