      SUBROUTINE GEN_COSMIC

*     04OCT95 EF

      IMPLICIT NONE
*      
*     ----------------------------------------------------------------- 

      INCLUDE '../common.inc'
*WL
      INCLUDE '../dtor.inc'
*     ----------------------------------------------------------------- 
      
      REAL HRNDM1
      REAL XEMU,P_MU,ENE_MU,ELAB,THETA,PHI,X0,Y0,Z0,R0,
     +     PMU,CHINT,CHWEIGHT,CH_MU,PLAB(3),UBUF(10),HR
      REAL RAD,PERPOFF,XX,YY,XRAND,YRAND
      INTEGER INDEX,NSIDE,NVERT,NT,EMIL

*     HARD COSMIC RAY COMPONENT - MUONS - 1.3E2 m^-2 s^-1
*     REFERENCES: ROSSI: REV. MOD. PHYS. 20, 537 (1948)
*                 PDG:   PRD50, 1269 (1994) 

*     REACTION INDEX

      NR=1
      NP=1
      SQME=1.0
      EMIL=0
      RAD=48.2
      PERPOFF=125.0

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(11004,'COSMICS ENERGY SPECTRUM',10001,50.,10051.,0.)
        DO INDEX=1,10000
           XEMU=INDEX+49.5
           WT=10**(-3.5875+4.4694*LOG10(XEMU)-0.82604*
     +     (LOG10(XEMU)**2))
           IF(IHISTO.EQ.1) CALL HFILL(11004,XEMU,0.,WT)
        ENDDO
      ENDIF

*     GENERATE THE ENERGY ACCORDING TO COSMICS MUON SPECTRUM
*     IMATRIX=1, OR USE FLAT SPECTRUM, IMATRIX=0

      IF(IMATRIX(NR).EQ.0) THEN
      CALL RANLUX(RVEC,ILEN)
        P_MU=0.050+5.*RVEC(1) 
      ELSEIF(IMATRIX(NR).EQ.1) THEN
        P_MU=HRNDM1(11004)/1000.
      ELSE
        PAUSE
      ENDIF

      ENE_MU=SQRT(P_MU**2+MMU**2)

*     TAKE INTO ACCOUNT POSITIVE EXCESS MU+/MU- AS FUNCTION OF ENERGY AT SEA
*     LEVEL

      PMU=1000.*P_MU
      CHWEIGHT=1.0133+9.8626E-5*PMU-7.5847E-9*PMU*PMU
      CALL RANLUX(RVEC,ILEN)
      CHINT= -1.+(1.+CHWEIGHT)*RVEC(1)

*     SELECT PARTICLE CHARGE (5=POSITIVE MUON, 6=NEGATIVE MUON)

      IPARTICLE(1)=5                 
      IF(CHINT.LT.0.) IPARTICLE(1)=6 
      IF(IPARTICLE(1).EQ.5) THEN
        CH_MU=1.
      ELSE
        CH_MU=-1.
      ENDIF

*     COS(ZENITH_ANGLE)**2 RANDOM GENERATOR, ANGULAR DISTRIBUTIONS

      CALL RANLUX(RVEC,ILEN)
*WL ACOSD->ACOS
      THETA=(1/dtor)*ACOS(SQRT(RVEC(1)))  
      CALL RANLUX(RVEC,ILEN)
      PHI=360.*RVEC(1)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(11009,'COSMICS COS**2 POL ANG', 400,-0.1,1.1,0.)
        CALL HBOOK1(11010,'COSMICS AZIMUTHAL ANGLE',360,0.,360.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
*WL COSD->COS
        CALL HFILL(11009,((COS(dtor*THETA))**2),0.,SQME)
        CALL HFILL(11010,PHI,0.,SQME)
      ENDIF

*     Y-up, Z-along beam, X-beam left
*WL SIND COSD -> SIN COS
      PLAB(1)= P_MU*SIN(dtor*THETA)*COS(dtor*PHI)
      PLAB(3)=-P_MU*SIN(dtor*THETA)*SIN(dtor*PHI)
      PLAB(2)=-P_MU*COS(dtor*THETA)
      ELAB=SQRT(PCM(1,1)**2+pcm(2,1)**2+pcm(3,1)**2+P_MU**2)

      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(4,1,NR)=ELAB
      PART(5,1,NR)=SQRT(PLAB(1)**2+PLAB(2)**2+PLAB(3)**2)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(11001,'COSMICS PX',121,-10051.,10051.,0.)
        CALL HBOOK1(11002,'COSMICS PY',121,-10051.,10051.,0.)
        CALL HBOOK1(11003,'COSMICS PZ',121,-10051.,0.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(11001,1000.*PLAB(1),0.,SQME)
        CALL HFILL(11002,1000.*PLAB(2),0.,SQME)
        CALL HFILL(11003,1000.*PLAB(3),0.,SQME)
      ENDIF

C--   MAMA Size -116 -> +167, -129 -> +129, 135 -> 135 cm
*     GENERATE THE STARTING POINT AND TRAGECTORY OF THE COSMIC
*     IF EMIL=1 THEN USE EMIL'S METHOD, OTHERWISE USE JASON'S METHOD 

      IF (EMIL .EQ. 1) THEN
        CALL RANLUX(RVEC,ILEN)
        NSIDE=3*RVEC(1)
        NSIDE=NSIDE+1              ! select the side (1-3)
        IF (NSIDE.EQ.1) THEN       ! top side
          Y0=129.
          CALL RANLUX(RVEC,ILEN)
          X0=25.5+141.5*(1.-2.*RVEC(1))
          CALL RANLUX(RVEC,ILEN)
          Z0=135.*(1.-2.*RVEC(1))
        ELSEIF (NSIDE.EQ.2) THEN   ! front-back side
          IF (PLAB(1).GT.0.) THEN
            X0=-116.
          ELSE
            X0= 167.
          ENDIF
          CALL RANLUX(RVEC,ILEN)
          Y0=129.0*(1.-2.*RVEC(1))
          CALL RANLUX(RVEC,ILEN)
          Z0=135.0*(1.-2.*RVEC(1))          
        ELSE                       ! left-right side
          IF (PLAB(3).GT.0.) THEN
            Z0=-135.0
          ELSE
            Z0= 135.0
          ENDIF
          CALL RANLUX(RVEC,ILEN)
          X0=25.5+141.5*(1.-2.*RVEC(1))
          CALL RANLUX(RVEC,ILEN)
          Y0=129.0*(1.-2.*RVEC(1))          
        ENDIF
      ELSE
 10     CALL RANLUX(RVEC,ILEN)
*        XRAND=ASIND(2*RVEC(1)-1)
        XX=RAD*(2*RVEC(1)-1)
        CALL RANLUX(RVEC,ILEN)
*        YRAND=ASIND(SIND(SQRT(90**2-XRAND**2))*(2*RVEC(1)-1))
*        XX=RAD/90*XRAND
*        YY=RAD/90*YRAND
        YY=RAD*(2*RVEC(1)-1)
        IF (RAD**2 .LE. (XX**2+YY**2)) THEN 
          GOTO 10
        ENDIF
*WL SIND COSD->SIN COS
        X0=-(PERPOFF*SIN(dtor*THETA)*COS(dtor*PHI)
     +    +XX*COS(dtor*PHI)*COS(dtor*THETA)-YY*SIN(dtor*PHI))
        Z0=PERPOFF*SIN(dtor*THETA)*SIN(dtor*PHI)
     +    +XX*SIN(dtor*PHI)*COS(dtor*THETA)+YY*COS(dtor*PHI)
        Y0=PERPOFF*COS(dtor*THETA)-XX*SIN(dtor*THETA)
      ENDIF

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(11005,'COSMICS X0 COORDINATE',600,0.,1000.,0.)
        CALL HBOOK1(11006,'COSMICS Y0 COORDINATE',600,0.,1000.,0.)
        CALL HBOOK1(11007,'COSMICS Z0 COORDINATE',600,0.,1000.,0.)
        CALL HBOOK2(11008,'COSMIC Z0-X0 COORDINATES',
     +              50,-1000.,1000.,50,-1000.,1000.,0.)
        CALL HBOOK1(11101,'COSMIC XX COORDINATE',600,0.,1000.,0.)
        CALL HBOOK1(11102,'COSMIC YY COORDINATE',600,0.,1000.,0.)
        CALL HBOOK2(11103,'COSMIC XX-YY COORDINATES',
     +              50,-1000.,1000.,50,-1000.,1000.,0.)

      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(11005,X0,0.,SQME)
        CALL HFILL(11006,Y0,0.,SQME)
        CALL HFILL(11007,Z0,0.,SQME)
        CALL HFILL(11008,Z0,X0,SQME)
        CALL HFILL(11101,XX,0.,SQME)
        CALL HFILL(11102,YY,0.,SQME)
        CALL HFILL(11103,XX,YY,SQME)
      ENDIF

*     CSI BALL HIT?

      ICALHIT(1)=0

      IHCALL(NR)=0

*     EVENT TYPE, EVENT WEIGHT, MATRIX ELEMENT

      UBUF(1)=NR
      UBUF(2)=1.
      UBUF(3)=1.

      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      
      UBUF(1)=ELAB

      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      RETURN
      END   
