      SUBROUTINE GEN_DALITZ

*     26NOV95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10),
     +     COSRA,RELANG,WT1,BX,BY,BZ,GAM
      INTEGER NVERT,NT
*yw4f add parameter anum
      real anum
      parameter (anum=180.0/3.14159)
*yw4f end
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI+ -> PI0 E+ NU -> E2+ E3+ G E1+ NU (JUST DALITZ Decays!)
*     REFERENCE: KALLEN, G.: ELEMENTARY PARTICLE PHYSICS, ADDISON-WESLEY,
*                400 (1964)
      NR=11

      NP=3
      TECM=0.13956995
      MPP=0.13956995
      KGENEV=1
      AMASS(1)=0.1349764
      AMASS(2)=0.000510999
      AMASS(3)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
*     MATRIX ELEMENT SQUARED (KALLEN)
      SQME=2.0*(-MPP*PCM(4,2)+PCM(1,1)*PCM(1,2)+PCM(2,1)*PCM(2,2)+
     +     PCM(3,1)*PCM(3,2)-PCM(4,1)*PCM(4,2))*
     +     (-MPP*PCM(4,3)+PCM(1,1)*PCM(1,3)+PCM(2,1)*PCM(2,3)+
     +     PCM(3,1)*PCM(3,3)-PCM(4,1)*PCM(4,3))-
     +     (PCM(1,1)*PCM(1,1)+PCM(2,1)*PCM(2,1)+PCM(3,1)*PCM(3,1)-
     +     (MPP+PCM(4,1))*(MPP+PCM(4,1)))*
     +     (PCM(1,2)*PCM(1,3)+PCM(2,2)*PCM(2,3)+
     +     PCM(3,2)*PCM(3,3)-PCM(4,2)*PCM(4,3))
      SQME=SQME/2.200374E-7

C--   Store temporarily first Phase Space Weigth
      WT1=WT

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(111001,'E1+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(111002,'E1+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(111003,'E1+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(111004,'E1+ EN',100,  0.0,80.0,0.)
        CALL HBOOK1(112001,'E2+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(112002,'E2+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(112003,'E2+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(112004,'E2+ EN',100,  0.0,80.0,0.)
        CALL HBOOK1(113001,'E3- PX',100,-80.0,80.0,0.)
        CALL HBOOK1(113002,'E3- PY',100,-80.0,80.0,0.)
        CALL HBOOK1(113003,'E3- PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(113004,'E3- EN',100,  0.0,80.0,0.)
        CALL HBOOK1(114001,'G   PX',100,-80.0,80.0,0.)
        CALL HBOOK1(114002,'G   PY',100,-80.0,80.0,0.)
        CALL HBOOK1(114003,'G   PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(114004,'G   EN',100,  0.0,80.0,0.)
        CALL HBOOK1(111011,'G G REL ANG',400,0.0,200.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(111001,1000*PCM(1,2),0.,SQME*WT1)
        CALL HFILL(111002,1000*PCM(2,2),0.,SQME*WT1)
        CALL HFILL(111003,1000*PCM(3,2),0.,SQME*WT1)
        CALL HFILL(111004,1000*PCM(4,2),0.,SQME*WT1)
      ENDIF

C--   Follow first positron E1+
      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,2)
      IPARTICLE(1)=2
      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(4,1,NR)=ELAB
      PART(5,1,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(1)=WT
      UBUF(1)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

C--   Calculate parameters for PI0 boost
      BX=PCM(1,1)/PCM(4,1)
      BY=PCM(2,1)/PCM(4,1)
      BZ=PCM(3,1)/PCM(4,1)
      GAM=1./SQRT(1.-BX*BX-BY*BY-BZ*BZ)

C--   Generate PI0 -> E1+ E2- G in PI0 rest frame
      NP=3
      TECM=0.1349764
      AMASS(1)=0.000510999
      AMASS(2)=0.000510999
      AMASS(3)=0.0
      CALL GENBOD
C--   Calculate combined phase space probability
      WT=WT*WT1

C--   Do boost
      CALL GBOOST(GAM,BX,BY,BZ,PCM(4,1),PCM(1,1),PCM(2,1),PCM(3,1))
      CALL GBOOST(GAM,BX,BY,BZ,PCM(4,2),PCM(1,2),PCM(2,2),PCM(3,2))
      CALL GBOOST(GAM,BX,BY,BZ,PCM(4,3),PCM(1,3),PCM(2,3),PCM(3,3))

C--   calculate opening angle between E2+ and E3-
      COSRA=(PCM(1,1)*PCM(1,2)+PCM(2,1)*PCM(2,2)+PCM(3,1)*PCM(3,2))/
     +  (SQRT(PCM(1,1)**2+PCM(2,1)**2+PCM(3,1)**2)*
     +   SQRT(PCM(1,2)**2+PCM(2,2)**2+PCM(3,2)**2))
      IF(ABS(COSRA).LE.1.) THEN
*yw4f ommit D and add anum
*         RELANG=ACOSD(COSRA)
         RELANG=anum*ACOS(COSRA)
*yw4f end
      ELSEIF(COSRA.GT.1.) THEN
         RELANG=0.
      ELSEIF(COSRA.LT.-1.) THEN
         RELANG=180.
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(112001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(112002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(112003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(112004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(113001,1000*PCM(1,2),0.,SQME*WT)
        CALL HFILL(113002,1000*PCM(2,2),0.,SQME*WT)
        CALL HFILL(113003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(113004,1000*PCM(4,2),0.,SQME*WT)
        CALL HFILL(114001,1000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(114002,1000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(114003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(114004,1000*PCM(4,3),0.,SQME*WT)
        CALL HFILL(111011,RELANG,0.,SQME*WT)
      ENDIF

C--   Follow second positron E2+
      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=2
      PART(1,2,NR)=PLAB(1)
      PART(2,2,NR)=PLAB(2)
      PART(3,2,NR)=PLAB(3)
      PART(4,2,NR)=ELAB
      PART(5,2,NR)=ELAB

      UBUF(1)=NR
      UBUF(1)=WT
      UBUF(1)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

C--   Follow third electron E3-
      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,2)
      IPARTICLE(1)=3
      PART(1,3,NR)=PLAB(1)
      PART(2,3,NR)=PLAB(2)
      PART(3,3,NR)=PLAB(3)
      PART(4,3,NR)=ELAB
      PART(5,3,NR)=PCM(4,2)

      UBUF(1)=NR
      UBUF(1)=WT
      UBUF(1)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

C--   Follow gamma
      PLAB(1)=PCM(1,3)
      PLAB(2)=PCM(2,3)
      PLAB(3)=PCM(3,3)
      ELAB=PCM(4,3)
      IPARTICLE(1)=1
      PART(1,4,NR)=PLAB(1)
      PART(2,4,NR)=PLAB(2)
      PART(3,4,NR)=PLAB(3)
      PART(4,4,NR)=ELAB
      PART(5,4,NR)=ELAB

      UBUF(1)=NR
      UBUF(1)=WT
      UBUF(1)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(111005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(111006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(111007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (111008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(111005,X0,0.,SQME*WT)
        CALL HFILL(111006,Y0,0.,SQME*WT)
        CALL HFILL(111007,Z0,0.,SQME*WT)
        CALL HFILL(111008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   

