      SUBROUTINE GEN_GAMMA

*     04OCT95 EF

      IMPLICIT NONE
      REAL X0,Y0,Z0,PLAB(3),UBUF(10),ELAB,
     +     COSTH,THETA,PHI
      INTEGER NVERT,NT,i
*      
*     ----------------------------------------------------------------- 

      INCLUDE '../common.inc'
*WL common block for testing angular resolution, used in clump.f
      COMMON/GEOMTMP/THT_G_T,PHI_G_T
      REAL THT_G_T,PHI_G_T,AR
      

*WL
      INCLUDE '../dtor.inc'

*     ----------------------------------------------------------------- 
      
*     REACTION INDEX

      NR=2
      NP=1

      IPARTICLE(1)=1                 
      WT=1.0
      SQME=1.0

      IF(IPLANAR.EQ.1) THEN
        CALL RANLUX(RVEC,ILEN)
        COSTH=1.-2.*RVEC(1)
*WL ACOSD -> ACOS
        THETA=(1/dtor)*ACOS(COSTH)
        CALL RANLUX(RVEC,ILEN)
        IF (RVEC(1).LE.0.5) THEN
          PHI=90.
        ELSE
          PHI=180.
        ENDIF
      ELSE
        CALL RANLUX(RVEC,ILEN)
        COSTH=1.-2.*RVEC(1)
*WL ACOSD -> ACOS
        THETA=(1/dtor)*ACOS(COSTH)
        CALL RANLUX(RVEC,ILEN)
        PHI=360.*RVEC(1)
      ENDIF

*WL testing angular resolution
      THT_G_T=THETA
      PHI_G_T=PHI


      CALL RANLUX(RVEC,ILEN)
      ELAB=EGAMMA(1)+EGAMMA(2)*(1.-2.*RVEC(1))

*WL COSD SIND -> COS SIN
      PLAB(1)=ELAB*COS(dtor*PHI)*SIN(dtor*THETA)
      PLAB(2)=ELAB*SIN(dtor*PHI)*SIN(dtor*THETA)
      PLAB(3)=ELAB*COS(dtor*THETA)

      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(4,1,NR)=ELAB
      PART(5,1,NR)=SQRT(PLAB(1)**2+PLAB(2)**2+PLAB(3)**2)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(21001,'G PX',800,0.,200.,0.)
        CALL HBOOK1(21002,'G PY',800,0.,200.,0.)
        CALL HBOOK1(21003,'G PZ',800,0.,200.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(21001,1000.*PLAB(1),0.,WT)
        CALL HFILL(21002,1000.*PLAB(2),0.,WT)
        CALL HFILL(21003,1000.*PLAB(3),0.,WT)
      ENDIF

      X0=0.
      Y0=0.
      Z0=0.

      IF(IPLANAR.EQ.3) THEN
        CALL RNORMX(RVEC,ILEN,RANLUX)
        X0=BEAM(3)*RVEC(1)
        CALL RNORMX(RVEC,ILEN,RANLUX)
        Y0=BEAM(4)*RVEC(1)
        CALL RANLUX(RVEC,ILEN)
        Z0=BEAM(5)*RVEC(1)
      ENDIF

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(21005,'G X0 COORDINATE',600,0.,1000.,0.)
        CALL HBOOK1(21006,'G Y0 COORDINATE',600,0.,1000.,0.)
        CALL HBOOK1(21007,'G Z0 COORDINATE',600,0.,1000.,0.)
        CALL HBOOK2(21008,'G Z0-X0 COORDINATES',
     +              50,-1000.,1000.,50,-1000.,1000.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(21005,X0,0.,WT)
        CALL HFILL(21006,Y0,0.,WT)
        CALL HFILL(21007,Z0,0.,WT)
        CALL HFILL(21008,Z0,X0,WT)
      ENDIF

*     CSI BALL HIT?

      ICALHIT(1)=0

      IHCALL(NR)=0

*     EVENT TYPE, EVENT WEIGHT, MATRIX ELEMENT

      UBUF(1)=2.
      UBUF(2)=1.
      UBUF(3)=1.

      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      
      UBUF(1)=ELAB

      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      RETURN
      END   
