      SUBROUTINE GEN_MU_ENUNU

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE MU+ -> E+ NU NU (MICHEL DECAY)
*     REFERENCES: OKUN, L. B.: LEPTONS AND QUARKS, ELSEVIER, (1982)  
*
      NR=13

      NP=3
      TECM=0.105658389
      MMU=0.105658389
      MEP=0.000510999
      KGENEV=1
      AMASS(1)=0.000510999
      AMASS(2)=0.0
      AMASS(3)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
*     MATRIX ELEMENT SQUARED
      CALL MATRIX_MU_ENUNU
*      SQME=MMU*PCM(4,1)*(3.*MMU*MMU-4.*MMU*PCM(4,1))*PCM(4,1)
*      SQME=SQME/1.267060E-06

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB   =PCM(4,1)
      IPARTICLE(1)=2
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(131001,'E+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(131002,'E+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(131003,'E+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(131004,'E+ EN', 100,  0.0,80.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(131001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(131002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(131003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(131004,1000*PCM(4,1),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(131005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(131006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(131007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (131008,'X0-Y0 COORDINATE',50,-5.0,5.0,50,-5.0,5.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(131005,X0,0.,SQME*WT)
        CALL HFILL(131006,Y0,0.,SQME*WT)
        CALL HFILL(131007,Z0,0.,SQME*WT)
        CALL HFILL(131008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      IHCALL(NR)=0

      RETURN
      END   

      INCLUDE 'matrix_mu_enunu.f'












