      SUBROUTINE GEN_MU_ENUNUEE

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
C--   Common Block for mu->eeenunu matrix element squared
      COMMON/MUDEC/Y(6)
      DOUBLE PRECISION Y
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      DOUBLE PRECISION M11, M12, M13, MM(3,2), MM1, MM2
      DOUBLE PRECISION RCM(4,3)
      INTEGER I,J,NVERT,NT
      DOUBLE PRECISION MATRIX_MU_ENUNUEE,ZDUM 
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE MU+ -> E+ E- E+ NU NU
*
      NR=15

      NP=5
      TECM=0.105658389
      MPP= 0.105658389
      KGENEV=1
      AMASS(1)=0.000510999
      AMASS(2)=0.000510999
      AMASS(3)=0.000510999
      AMASS(4)=0.0
      AMASS(5)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
      DO I=1,4 
        DO J=1,3
           RCM(I,J)=DBLE(PCM(I,J))
         ENDDO
      ENDDO                 
*     MATRIX ELEMENT SQUARED
C--   Input to matrix element function, energies of e+e-e+ over muon mass

      Y(1)=RCM(4,1)/0.105658389D0
      Y(2)=RCM(4,2)/0.105658389D0
      Y(3)=RCM(4,3)/0.105658389D0

C--   cos(e+e-)   
      Y(4)= ( (RCM(1,1)*RCM(1,2)+RCM(2,1)*RCM(2,2)+RCM(3,1)*
     +              RCM(3,2))/
     +     (SQRT(RCM(1,1)**2+RCM(2,1)**2+RCM(3,1)**2)*
     +      SQRT(RCM(1,2)**2+RCM(2,2)**2+RCM(3,2)**2) ) )

C--   cos(e+e+)
      Y(5)=( (RCM(1,1)*RCM(1,3)+RCM(2,1)*RCM(2,3)+RCM(3,1)*
     +        RCM(3,3))/
     +     (SQRT(RCM(1,1)**2+RCM(2,1)**2+RCM(3,1)**2)*
     +      SQRT(RCM(1,3)**2+RCM(2,3)**2+RCM(3,3)**2) ) )

      M11=RCM(1,1)*RCM(1,1)+RCM(2,1)*RCM(2,1)+RCM(3,1)*RCM(3,1)
      M12=RCM(1,1)*RCM(1,2)+RCM(2,1)*RCM(2,2)+RCM(3,1)*RCM(3,2)
      M13=RCM(1,1)*RCM(1,3)+RCM(2,1)*RCM(2,3)+RCM(3,1)*RCM(3,3)

      MM(1,1)=RCM(1,2)-M12*RCM(1,1)/M11
      MM(2,1)=RCM(2,2)-M12*RCM(2,1)/M11
      MM(3,1)=RCM(3,2)-M12*RCM(3,1)/M11
      MM(1,2)=RCM(1,3)-M13*RCM(1,1)/M11
      MM(2,2)=RCM(2,3)-M13*RCM(2,1)/M11
      MM(3,2)=RCM(3,3)-M13*RCM(3,1)/M11

      MM1 = MM(1,1)**2 + MM(2,1)**2 + MM(3,1)**2
      MM2 = MM(1,2)**2 + MM(2,2)**2 + MM(3,2)**2

C--   cos(2,3) projected to the plane perpendicular to 1
      Y(6)=   ( (MM(1,1)*MM(1,2)+MM(2,1)*MM(2,2)+MM(3,1)*MM(3,2))/
     +            SQRT(MM1*MM2) )

C      SQME=1./1.8316771835E-2
      SQME=1.E6*REAL(MATRIX_MU_ENUNUEE(ZDUM))

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=2
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,4)
      IPARTICLE(2)=3      
      PART(1,2,NR)=PCM(1,2)
      PART(2,2,NR)=PCM(2,2)
      PART(3,2,NR)=PCM(3,2)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,3)
      PLAB(2)=PCM(2,3)
      PLAB(3)=PCM(3,3)
      ELAB=PCM(4,3)
      IPARTICLE(3)=2
      PART(1,3,NR)=PCM(1,3)
      PART(2,3,NR)=PCM(2,3)
      PART(3,3,NR)=PCM(3,3)
      PART(4,3,NR)=PCM(4,3)
      PART(5,3,NR)=PCM(5,3)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(3),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(151001,'E1+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(151002,'E1+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(151003,'E1+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(151004,'E1+ EN', 100,0.0,80.0,0.)
        CALL HBOOK1(152001,'E2+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(152002,'E2+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(152003,'E2+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(152004,'E2+ EN', 100,0.0,80.0,0.)
        CALL HBOOK1(153001,'E3- PX',100,-80.0,80.0,0.)
        CALL HBOOK1(153002,'E3- PY',100,-80.0,80.0,0.)
        CALL HBOOK1(153003,'E3- PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(153004,'E3- EN', 100,0.0,80.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(151001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(151002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(151003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(151004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(152001,1000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(152002,1000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(152003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(152004,1000*PCM(4,3),0.,SQME*WT)
        CALL HFILL(153001,1000*PCM(1,4),0.,SQME*WT)
        CALL HFILL(153002,1000*PCM(2,4),0.,SQME*WT)
        CALL HFILL(153003,1000*PCM(3,4),0.,SQME*WT)
        CALL HFILL(153004,1000*PCM(4,4),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(151005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(151006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(151007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (151008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(151005,X0,0.,SQME*WT)
        CALL HFILL(151006,Y0,0.,SQME*WT)
        CALL HFILL(151007,Z0,0.,SQME*WT)
        CALL HFILL(151008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   

      include 'matrix_mu_enunuee.f'

