      SUBROUTINE GEN_MU_ENUNUG

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG
      INTEGER ZEROFLAG
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10),
     +     COSRA,RELANG
      INTEGER NVERT,NT
*yw4f add parameter anum
      real anum
      parameter (anum=180.0/3.14159)
*yw4f end
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE MU+ -> E+ NU NU G
*     REFERENCES: ECKSTEIN AND PRATT, ANN. OF PHYS. 8, 297 (1959)   
*                 BEHRENDS, FINKELSTEIN AND SIRLIN, PHYS. REV. 101, 886 (1956)
      NR=14

      NP=4
      TECM=0.105658389
      MMU=0.105658389
      KGENEV=1
      AMASS(1)=0.000510999
      AMASS(2)=0.0
      AMASS(3)=0.0
      AMASS(4)=0.0
*
*     SELECT THE PION (MUON!) STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

 1111 CALL GENBOD

      IF(ABS(PCM(1,1)).LT.1.E-10.OR.ABS(PCM(2,1)).LT.1.E-10.OR.
     .   ABS(PCM(3,1)).LT.1.E-10.OR.
     .   ABS(PCM(1,4)).LT.1.E-10.OR.ABS(PCM(2,4)).LT.1.E-10.OR.
     .   ABS(PCM(3,4)).LT.1.E-10) GOTO 1111

*     MATRIX ELEMENT SQUARED
      CALL MATRIX_MU_ENUNUG
C      IF (ZEROFLAG.EQ.1) GOTO 1111

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=2
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,4)
      PLAB(2)=PCM(2,4)
      PLAB(3)=PCM(3,4)
      ELAB=PCM(4,4)
      IPARTICLE(2)=1
      PART(1,2,NR)=PCM(1,4)
      PART(2,2,NR)=PCM(2,4)
      PART(3,2,NR)=PCM(3,4)
      PART(4,2,NR)=PCM(4,4)
      PART(5,2,NR)=PCM(5,4)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      COSRA=(PCM(1,1)*PCM(1,4)+PCM(2,1)*PCM(2,4)+
     +  PCM(3,1)*PCM(3,4))/(SQRT(PCM(1,1)**2+PCM(2,1)**2+PCM(3,1)**2)*
     +                     SQRT(PCM(1,4)**2+PCM(2,4)**2+PCM(3,4)**2))
      IF(ABS(COSRA).LE.1.) THEN
*yw4f ommit D and add anum
*        RELANG=ACOSD(COSRA)
        RELANG=anum*ACOS(COSRA)
*yw4f end
      ELSEIF(COSRA.GT.1.) THEN
        RELANG=0.
      ELSEIF(COSRA.LT.-1.) THEN
        RELANG=180.
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(141001,'E+ PX', 100,-80.0,80.0,0.)
        CALL HBOOK1(141002,'E+ PY', 100,-80.0,80.0,0.)
        CALL HBOOK1(141003,'E+ PZ', 100,-80.0,80.0,0.)
        CALL HBOOK1(141004,'E+ EN', 100,  0.0,80.0,0.)
        CALL HBOOK1(142001,'G  PX', 100,-80.0,80.0,0.)
        CALL HBOOK1(142002,'G  PY', 100,-80.0,80.0,0.)
        CALL HBOOK1(142003,'G  PZ', 100,-80.0,80.0,0.)
        CALL HBOOK1(142004,'G  EN', 100,  0.0,80.0,0.)
        CALL HBOOK1(141011,'E+ G REL ANG',400,0.0,200.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(141001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(141002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(141003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(141004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(142001,1000*PCM(1,4),0.,SQME*WT)
        CALL HFILL(142002,1000*PCM(2,4),0.,SQME*WT)
        CALL HFILL(142003,1000*PCM(3,4),0.,SQME*WT)
        CALL HFILL(142004,1000*PCM(4,4),0.,SQME*WT)
        CALL HFILL(141011,RELANG,0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(141005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(141006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(141007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (141008,'X0-Y0 COORDINATES',100,-5.0,5.0,100,-5.0,5.0,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(141005,X0,0.,SQME*WT)
        CALL HFILL(114006,Y0,0.,SQME*WT)
        CALL HFILL(141007,Z0,0.,SQME*WT)
        CALL HFILL(141008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0

      IHCALL(NR)=0

      RETURN
      END   

      SUBROUTINE MATRIX_MU_ENUNUG

C     W. Eichenberger, R. Engfer & A. van der Schaaf
C     Nucl. Phys. A412 (1984) 523.

      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG
      INTEGER ZEROFLAG
      INCLUDE '../common.inc'

      REAL EB,RHO,M_MU,M_E,GMUENU,x1,x2,y1,y2,c1,c2
      REAL RDAL,E_E,P_E,B,DEL,GM1,G0,G1,G2,NV,F1V,F2V,F3V,RM
      REAL PI,AL
      REAL X,Y,C,CMIN
      REAL COSRA,RELANG
*yw4f add parameter anum
      real anum
      parameter (anum=180.0/3.14159)
*yw4f end

      REAL N_SVT1,N_SVT2

      X=2.*PCM(4,1)/0.105658389
      Y=2.*PCM(4,4)/0.105658389

      COSRA=(PCM(1,1)*PCM(1,4)+PCM(2,1)*PCM(2,4)+
     +  PCM(3,1)*PCM(3,4))/(SQRT(PCM(1,1)**2+PCM(2,1)**2+PCM(3,1)**2)*
     +                     SQRT(PCM(1,4)**2+PCM(2,4)**2+PCM(3,4)**2))
      IF(ABS(COSRA).LE.1.) THEN
*yw4f ommit D and add anum
*        RELANG=ACOSD(COSRA)
        RELANG=anum*ACOS(COSRA)
*yw4f end
      ELSEIF(COSRA.GT.1.) THEN
        RELANG=0.
      ELSEIF(COSRA.LT.-1.) THEN
        RELANG=180.
      ENDIF

      C=COSRA

      EB=0.
      RHO=3./4.

c muon and electron mass in MeV
      M_MU=0.105658389
      M_E=0.000510999

      AL=1./137.036
      PI=3.1415927

c totla branching ratio
      GMUENU=1.0

c integration limits, x=2E_E/M_MU, y=2E_G/M_MU
c minimum x=2*M_E/M_MU, minimum y=0

c R_Dalitz function
      RDAL=((2.*AL)/(3.*PI))*
     .     ( log( ((y*M_MU)/(2.*M_E)) )-(19./12.) ) 

      E_E=M_MU*x/2.
      P_E=SQRT((E_E**2)-(M_E**2))
      B=P_E/E_E
      DEL=1.-B*C

c G-functions
      GM1=8.*((y**2)*(3.-2.*y)+6.*x*y*(1.-y)
     .        +2.*(x**2)*(3.-4.*y)-4.*(x**3))
      G0=8.*((-1.)*x*y*(3.-y-(y**2))-(x**2)*(3.-y-4.*(y**2))
     .        +2.*(x**3)*(1.+2.*y))
      G1=2.*((x**2)*y*(6.-5.*y-2.*(y**2))-2.*(x**3)*y*(4.+3.*y))
      G2=2.*(x**3)*(y**2)*(2.+y)

      NV=4.*(1-(B**2))*( 2.*(DEL**(-2))*x*(x+y)*(2.*(x+y)-3.)
     . +(DEL**(-1))*(x**2)*y*(3.-4.*(x+y))+(x**3)*(y**2) )
     . +(DEL**(-1))*GM1+G0+DEL*G1+(DEL**2)*G2

      N_SVT1=-8.*x*(y**2)*( (DEL**(-1))*x*(1.-(B**2))
     . +2.*(1.-y-2.*x)+DEL*x*(1.+y) )

      N_SVT2=4.*( (DEL**(-1))*2.* ( (y**2)*(3.-4.*y)
     . +6.*x*y*(1.-2.*y)+2.*(x**2)*(3.-8.*y)-8.*(x**3) )
     . +2.*x*( (-1.)*y*(3.-y-6.*(y**2))-x*(3.-5.*y-10.*(y**2))
     . +4.*(x**2)*(1.+2.*y) )
     . +DEL*(x**2)*y*( 1.5*(2.-3.*y-4.*(y**2))-2.*x*(4.+3.*y) )
     . +(DEL**2)*(x**3)*(y**2)*(2.+y)
     . -(1.-(B**2))*( (DEL**(-2))*2.*x*(x+y)*(3.-4.*(x+y))
     . +(DEL**(-1))*(x**2)*y*(2.*(4.*x+5.*y)-3.)-2.*(x**3)*
     . (y**2) ) )

c      IF(RDAL.LT.0.) RDAL=0.

c f-functions
      F1V=(AL/(16.*(PI**2)*y))*(1.-RDAL)*NV

      F2V=(AL/(16.*(PI**2)*y))*(1.-RDAL)*N_SVT1
      F3V=(AL/(16.*(PI**2)*y))*(1.-RDAL)*N_SVT2

c      F2V=0.
c      F3V=0.

c radiative Michel decay probability
      RM=(F1V+EB*F2V+(1.-4.*RHO/3)*F3V)
      RM=RM*2.*PI

      SQME1=F1V
      SQME2=F2V
      SQME3=F3V

      IF(SQME1.LE.0.) SQME1=0.
      IF(SQME2.LE.0.) SQME2=0.
      IF(SQME3.LE.0.) SQME3=0.

      SQME=SQME1+SQME2+SQME3

      RETURN
      END
