      SUBROUTINE GEN_PHOTONUCLEAR

*     06NOV95 EF

      IMPLICIT NONE
*      
*     ----------------------------------------------------------------- 

      INCLUDE '../common.inc'
      COMMON/PHOTONUC_BLOCK/ITNUMED,TGEKIN,SIGMAPN

*     ----------------------------------------------------------------- 

C--   REFERENCES: H. FESEFELDT: THE SIMULATION OF HADRONIC SHOWERS,
C--               PITHA 85/02, P.48 
C--   EXP:        B.L. BERMAN, PHYS. REV. 177 (1969) 177 (133Cs THR-30 MEV)
C--   EXP:        R.L. BRAMBLETT, PHYS. REV. 148 (1966) 1198 (127I THR-30 MeV) 
C--   THEO:       H. HEBACH, NUCL. PHYS. A267 (1976) 425 (12C, 16O 40-120 MEV)

      REAL PROB,XLAMBDA0,A,RHO,SIGMAPN,TGEKIN
      INTEGER I,ITNUMED

C--   Extract the parameters of the tracking medium from JTMED
*      CALL GFTMED(ITMED,NATMED,ISVOL,IFIELD,FIELDM,TMAXFD,
*     +            STEMAX,DEEMAX,EPSIL,STMIN,UBUF,NWBUF)

      IF (NUMED.EQ.3.OR.NUMED.EQ.10) THEN
        CONTINUE
      ELSE
        RETURN
      ENDIF

c      IF (ISTAK.EQ.0.AND.IPART.EQ.1.AND.EDEPTOT.EQ.0.) THEN
c        CONTINUE
c      ELSE
c        RETURN
c      ENDIF

C--   Check the thresholds
      IF ((NUMED.EQ.10.AND.(1000.*GEKIN).LT. 9.04).OR.       ! CsI
     +    (NUMED.EQ. 3.AND.(1000.*GEKIN).LT.10.00)) RETURN   ! Plastic

      IF (NUMED.EQ. 3) THEN
        A=6.55
        RHO=1.033
      ELSEIF (NUMED.EQ.10) THEN
        A=130.
        RHO=4.53
      ENDIF

      ITNUMED=NUMED
      TGEKIN=GEKIN
      CALL PHOTONUC_SEC
      XLAMBDA0=1.E4*A/(6.022045*RHO*SIGMAPN)

C--   Probability of photonuclear interaction in current step
      PROB=1.-EXP(-STEP/XLAMBDA0)

      CALL RANLUX(RVEC,ILEN)         
      IF (RVEC(1).LT.PROB) THEN
C        IEOTRI=1
        COUNTER(NUMED)=1.
        RETURN
C__________________________________________________________________________
 
       ISTOP=1                      ! Original photon disappears
        CALL RANLUX(RVEC,ILEN)
        NGKINE=5.*RVEC(1)+1          ! Multiplicity of final state
        DO I=1,NGKINE                ! Put generated particles on stack
          CALL RANLUX(RVEC,ILEN)
          GKIN(1,I)=0.010*(1.-2.*RVEC(1))
          CALL RANLUX(RVEC,ILEN)
          GKIN(2,I)=0.010*(1.-2.*RVEC(1))
          CALL RANLUX(RVEC,ILEN)
          GKIN(3,I)=0.010*(1.-2.*RVEC(1))
          GKIN(4,I)=SQRT(GKIN(1,I)**2+GKIN(2,I)**2+GKIN(3,I)**2+
     +                   MNE**2)
          GKIN(5,I)=13
          IFLGK(I) =1
          GPOS(1,I)=VECT(1)
          GPOS(2,I)=VECT(2)
          GPOS(3,I)=VECT(3)
        ENDDO
      ENDIF

      RETURN
      END   

      SUBROUTINE PHOTONUC_SEC
      
      IMPLICIT NONE

      INCLUDE '../common.inc'
      COMMON/PHOTONUC_BLOCK/ITNUMED,TGEKIN,SIGMAPN
      
      REAL X,TGEKIN,SIGMAPN
      INTEGER ITNUMED

      X=1000.*TGEKIN
      
      IF(ITNUMED.EQ.10) THEN

      if (x.le.9.04) then
        sigmapn=0.
      elseif(x.le.30) then
        sigmapn=287./(1+(x**2-15.25**2)**2/((X**2)*(5.05**2)))
      else
        sigmapn=exp(3.0267-0.13988E-1*x)+
     +            exp(-0.19195+0.12539E-1*x)
      endif

      if (x.le.9.04) then
        sigmapn=0.
      elseif (x.le.30.) then
        sigmapn=sigmapn+180./(1+(x**2-15.21**2)**2/((X**2)*(4.1**2)))+
     +        50./(1+(x**2-15.82**2)**2/((X**2)*(7.90**2)))
      else
        sigmapn=sigmapn+exp(2.6276-0.60262E-2*x)+
     +          exp(-0.24834E-2-0.59803E-2*x)
      endif
      sigmapn=sigmapn/2.
      
      ENDIF

      IF(ITNUMED.EQ.3) THEN

      if (x.le.10.) then
        sigmapn=0.
      elseif (x.le.20.) then
        sigmapn=0.292*x-2.92
      elseif (x.le.25.) then
        sigmapn=20.698*exp(-0.5*((x-23.201)/1.5580)**2)
      elseif(x.gt.25.) then
        sigmapn=exp(3.825-0.63688E-1*x)+
     +    exp(-0.48475+0.35678E-2*x)
      endif
      sigmapn=sigmapn*0.586

      ENDIF

      RETURN
      END
