      SUBROUTINE GEN_PIMP_NEE

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,P0,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI- P -> N E+ E-
*     REFERENCES: 
*
      NR=24

      NP=3
      P0=SQRT(TINC(1)*TINC(1)+2.*TINC(1)*MPR)

      TECM=SQRT(MPP*MPP+MPR*MPR+2.*(MPP+TINC(1))*MPR)
      KGENEV=1
      AMASS(1)=0.93956563
      AMASS(2)=0.000510999
      AMASS(3)=0.000510999
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
*     MATRIX ELEMENT SQUARED = CONSTANT
      SQME=1.

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB   =PCM(4,1)
      IPARTICLE(1)=13
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=   PCM(4,2)
      IPARTICLE(2)=2
      PART(1,2,NR)=PCM(1,2)
      PART(2,2,NR)=PCM(2,2)
      PART(3,2,NR)=PCM(3,2)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,3)
      PLAB(2)=PCM(2,3)
      PLAB(3)=PCM(3,3)
      ELAB=   PCM(4,3)
      IPARTICLE(3)=3
      PART(1,3,NR)=PCM(1,3)
      PART(2,3,NR)=PCM(2,3)
      PART(3,3,NR)=PCM(3,3)
      PART(4,3,NR)=PCM(4,3)
      PART(5,3,NR)=PCM(5,3)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(3),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(211001,'N  PX',100,-80.0,80.0,0.)
        CALL HBOOK1(211002,'N  PY',100,-80.0,80.0,0.)
        CALL HBOOK1(211003,'N  PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(211004,'N  EN',100,  0.0,80.0,0.)
        CALL HBOOK1(212001,'E+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(212002,'E+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(212003,'E+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(212004,'E+ EN',100,  0.0,80.0,0.)
        CALL HBOOK1(213001,'E- PX',100,-80.0,80.0,0.)
        CALL HBOOK1(213002,'E- PY',100,-80.0,80.0,0.)
        CALL HBOOK1(213003,'E- PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(213004,'E- EN',100,  0.0,80.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(1001,211000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(1002,211000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(1003,211000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(1004,211000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(2001,211000*PCM(1,2),0.,SQME*WT)
        CALL HFILL(2002,211000*PCM(2,2),0.,SQME*WT)
        CALL HFILL(2003,211000*PCM(3,2),0.,SQME*WT)
        CALL HFILL(2004,211000*PCM(4,2),0.,SQME*WT)
        CALL HFILL(3001,211000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(3002,211000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(3003,211000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(3004,211000*PCM(4,3),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1) THEN
        CALL HBOOK1(211005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(211006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(211007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (211008,'X0-Y0 COORDINATE',50,-5.0,5.0,50,-5.0,5.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(211005,X0,0.,SQME*WT)
        CALL HFILL(211006,Y0,0.,SQME*WT)
        CALL HFILL(211007,Z0,0.,SQME*WT)
        CALL HFILL(211008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   
