      SUBROUTINE GEN_PIMP_NG

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,P0,X0,Y0,Z0,R0,PLAB(3),UBUF(10),
     +     COSRA,RELANG
      INTEGER NVERT,NT
*yw4f add parameter anum
      real anum
      parameter (anum=180.0/3.14159)
*yw4f end
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI- P -> N G
*     REFERENCE: 
*                
      NR=23

      NP=2

      P0=SQRT(TINC(1)*TINC(1)+2.*TINC(1)*MPR)

      TECM=SQRT(MPP*MPP+MPR*MPR+2.*(MPP+TINC(1))*MPR)
      KGENEV=1
      AMASS(1)=0.93956563
      AMASS(2)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
*     MATRIX ELEMENT SQUARED
      SQME=1.

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=13
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,2)
      IPARTICLE(2)=1
      PART(1,2,NR)=PCM(1,2)
      PART(2,2,NR)=PCM(2,2)
      PART(3,2,NR)=PCM(3,2)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)
 
      COSRA=(PCM(1,1)*PCM(1,2)+PCM(2,1)*PCM(2,2)+
     +  PCM(3,1)*PCM(3,2))/(SQRT(PCM(1,1)**2+PCM(2,1)**2+PCM(3,1)**2)*
     +  SQRT(PCM(1,2)**2+PCM(2,2)**2+PCM(3,2)**2)) 
      IF(ABS(COSRA).LE.1.) THEN
*yw4f ommit D and add anum
*         RELANG=ACOSD(COSRA)
         RELANG=anum*ACOS(COSRA)
*yw4f end
      ELSEIF(COSRA.GT.1.) THEN
         RELANG=0.
      ELSEIF(COSRA.LT.-1.) THEN
         RELANG=180.
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(201001,'N PX',100,-80.0,80.0,0.)
        CALL HBOOK1(201002,'N PY',100,-80.0,80.0,0.)
        CALL HBOOK1(201003,'N PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(201004,'N EN',100,  0.0,80.0,0.)
        CALL HBOOK1(202001,'G PX',100,-80.0,80.0,0.)
        CALL HBOOK1(202002,'G PY',100,-80.0,80.0,0.)
        CALL HBOOK1(202003,'G PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(202004,'G EN',100,  0.0,80.0,0.)
        CALL HBOOK1(202011,'N G REL ANG',400,0.0,200.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(201001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(201002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(201003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(201004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(202001,1000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(202002,1000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(202003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(202004,1000*PCM(4,3),0.,SQME*WT)
        CALL HFILL(202011,RELANG,0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(201005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(201006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(201007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (201008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(201005,X0,0.,SQME*WT)
        CALL HFILL(201006,Y0,0.,SQME*WT)
        CALL HFILL(201007,Z0,0.,SQME*WT)
        CALL HFILL(201008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0

      IHCALL(NR)=0

      RETURN
      END   
