      SUBROUTINE GEN_PIMP_PI0N

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,P0,X0,Y0,Z0,R0,PLAB(3),UBUF(10),
     +     COSRA,RELANG,G1CTH,G1TH,G1PHI,
     +     G2CTH,G2TH,G2PHI,BX,BY,BZ,GAM
      REAL GAMMA_X, GAMMA_Y, GAMMA_Z,
     +     check_theta,check_phi,check_theta2,check_phi2,rel_ang
      INTEGER NVERT,NT
*yw4f add parameter anum
      real anum
      parameter (anum=180.0/3.14159)
*yw4f end
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI- P -> PI0 N 
*     REFERENCE: 
*                
      NR=25

      NP=2

      P0=SQRT(TINC(1)*TINC(1)+2.*TINC(1)*MPP)

      IF (TINC(1).GT.0.) THEN
         TECM=SQRT(MPP*MPP+MPR*MPR+2.*(MPP+TINC(1))*MPR)
      ELSE
         TECM=MPP+MPR
      ENDIF

      KGENEV=1
      AMASS(1)=0.1349764
      AMASS(2)=0.93956563
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RANLUX(RVEC,ILEN)
      X0=BEAM(3)*(1-2*RVEC(1))
      CALL RANLUX(RVEC,ILEN)
      Y0=BEAM(4)*(1-2*RVEC(1))
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD

*     MATRIX ELEMENT SQUARED - CONSTANT
      SQME=1.

      CALL RANLUX(RVEC,ILEN)
      G1CTH=1.-2.*RVEC(1)
*yw4f ommit D and add anum
*      G1TH=ACOSD(G1CTH)
      G1TH=anum*ACOS(G1CTH)
*yw4f end
      CALL RANLUX(RVEC,ILEN)
      G1PHI=360.*RVEC(1)

      G1E=0.5*0.1349734
*yw4f ommit D and add anum
*      G1X=G1E*SIND(G1TH)*COSD(G1PHI)
*      G1Y=G1E*SIND(G1TH)*SIND(G1PHI)
*      G1Z=G1E*COSD(G1TH)

      G1X=G1E*SIN(G1TH/anum)*COS(G1PHI/anum)
      G1Y=G1E*SIN(G1TH/anum)*SIN(G1PHI/anum)
      G1Z=G1E*COS(G1TH/anum)
*yw4f end
      BX=-PCM(1,1)/PCM(4,1)
      BY=-PCM(2,1)/PCM(4,1)
      BZ=-PCM(3,1)/PCM(4,1)

      GAM=1./SQRT(1.-BX*BX-BY*BY-BZ*BZ)
      CALL GBOOST(GAM,BX,BY,BZ,G1E,G1X,G1Y,G1Z)

      IF (TINC(1).NE.0.) ! pion beam in z-direction
     +   CALL BOOST(TECM,0.,0.,P0,G1E,G1X,G1Y,G1Z)

      PLAB(1)=G1X
      PLAB(2)=G1Y
      PLAB(3)=G1Z

      ELAB=G1E
      IPARTICLE(1)=1
      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(4,1,NR)=ELAB
      PART(5,1,NR)=ELAB

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      G2E=0.5*0.1349764
*yw4f ommit D and add anum
*      G2X=G2E*SIND(180.-G1TH)*COSD(180.+G1PHI)
*      G2Y=G2E*SIND(180.-G1TH)*SIND(180.+G1PHI)
*      G2Z=G2E*COSD(180.-G1TH)

      G2X=G2E*SIN((180.-G1TH)/anum)*COS((180.+G1PHI)/anum)
      G2Y=G2E*SIN((180.-G1TH)/anum)*SIN((180.+G1PHI)/anum)
      G2Z=G2E*COS((180.-G1TH)/anum)
*yw4f end
      BX=-PCM(1,1)/PCM(4,1)
      BY=-PCM(2,1)/PCM(4,1)
      BZ=-PCM(3,1)/PCM(4,1)
      GAM=1./SQRT(1.-BX*BX-BY*BY-BZ*BZ)
      CALL GBOOST(GAM,BX,BY,BZ,G2E,G2X,G2Y,G2Z)

      IF (TINC(1).NE.0.) ! pion beam in z-direction
     +   CALL BOOST(TECM,0.,0.,P0,G2E,G2X,G2Y,G2Z)

      PLAB(1)=G2X
      PLAB(2)=G2Y
      PLAB(3)=G2Z
      ELAB=G2E

      IPARTICLE(2)=1
      PART(1,2,NR)=PLAB(1)
      PART(2,2,NR)=PLAB(2)
      PART(3,2,NR)=PLAB(3)
      PART(4,2,NR)=ELAB
      PART(5,2,NR)=ELAB

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      G1X=PCM(1,2)
      G1Y=PCM(2,2)
      G1Z=PCM(3,2)
      G1E=PCM(4,2)

      IF (TINC(1).NE.0.) THEN ! pion beam in z-direction
         CALL BOOST(TECM,0.,0.,P0,G1E,G1X,G1Y,G1Z)
         PLAB(1)=G1X
         PLAB(2)=G1Y
         PLAB(3)=G1Z
         ELAB=G1E
      ELSE
         PLAB(1)=PCM(1,2)
         PLAB(2)=PCM(2,2)
         PLAB(3)=PCM(3,2)
         ELAB=   PCM(4,2)
      ENDIF
*
      IPARTICLE(3)=13
      PART(1,3,NR)=PLAB(1)
      PART(2,3,NR)=PLAB(2)
      PART(3,3,NR)=PLAB(3)
      PART(4,3,NR)=ELAB
      PART(5,3,NR)=SQRT(PLAB(1)**2+PLAB(2)**2+PLAB(3)**2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(3),NVERT,UBUF,1,NT)


      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(221001,'G1 PX',100,-80.0,80.0,0.)
        CALL HBOOK1(221002,'G1 PY',100,-80.0,80.0,0.)
        CALL HBOOK1(221003,'G1 PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(221004,'G1 EN',100, 0.0, 80.0,0.)
        CALL HBOOK1(222001,'G2 PX',100,-80.0,80.0,0.)
        CALL HBOOK1(222002,'G2 PY',100,-80.0,80.0,0.)
        CALL HBOOK1(222003,'G2 PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(222004,'G2 EN',100, 0.0, 80.0,0.)
        CALL HBOOK1(223001,'NE PX',100,-5.,5.,0.)
        CALL HBOOK1(223002,'NE PY',100,-5.,5.,0.)
        CALL HBOOK1(223003,'NE PZ',100,-5.,5.,0.)
        CALL HBOOK1(223004,'NE EN',100,0.,5.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(221001,1000*G1X,0.,SQME*WT)
        CALL HFILL(221002,1000*G1Y,0.,SQME*WT)
        CALL HFILL(221003,1000*G1Z,0.,SQME*WT)
        CALL HFILL(221004,1000*G1E,0.,SQME*WT)
        CALL HFILL(222001,1000*G2X,0.,SQME*WT)
        CALL HFILL(222002,1000*G2Y,0.,SQME*WT)
        CALL HFILL(222003,1000*G2Z,0.,SQME*WT)
        CALL HFILL(222004,1000*G2E,0.,SQME*WT)
        CALL HFILL(223001,1000*PCM(1,2),0.,SQME*WT)
        CALL HFILL(223002,1000*PCM(2,2),0.,SQME*WT)
        CALL HFILL(223003,1000*PCM(3,2),0.,SQME*WT)
        CALL HFILL(223004,1000*PCM(4,2),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(221005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(221006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(221007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (221008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
        CALL HBOOK1(55555,'phi pi0',100,0.,7.,0.)
        CALL HBOOK1(55556,'theta pi0',100,-1.,1.,0.)
        CALL HBOOK1(55557,'theta g1',100,0.,360.,0.)
        CALL HBOOK1(55558,'phi g1',100,0.,360.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(221005,X0,0.,SQME*WT)
        CALL HFILL(221006,Y0,0.,SQME*WT)
        CALL HFILL(221007,Z0,0.,SQME*WT)
        CALL HFILL(221008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   

