      SUBROUTINE GEN_PI02GG

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI0 -> GGG
*     REFERENCES: 
*
      NR=16

      NP=2
      TECM=0.1349764
      KGENEV=1
      AMASS(1)=0.0
      AMASS(2)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
*     MATRIX ELEMENT SQUARED = CONSTANT
c     CALL MATRIX_PI02GG
      SQME=1.

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=1
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,2)
      IPARTICLE(2)=1
      PART(1,2,NR)=PCM(1,2)
      PART(2,2,NR)=PCM(2,2)
      PART(3,2,NR)=PCM(3,2)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)


      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(161001,'E1+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(161002,'E1+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(161003,'E1+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(161004,'E1+ E ',100,  0.0,80.0,0.)
        CALL HBOOK1(162001,'E2- PX',100,-80.0,80.0,0.)
        CALL HBOOK1(162002,'E2- PY',100,-80.0,80.0,0.)
        CALL HBOOK1(162003,'E2- PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(162004,'E2- E ',100,  0.0,80.0,0.)
        CALL HBOOK1(163001,'E3+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(163002,'E3+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(163003,'E3+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(163004,'E3+ E ',100,  0.0,80.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(116001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(161002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(161003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(161004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(162001,1000*PCM(1,2),0.,SQME*WT)
        CALL HFILL(162002,1000*PCM(2,2),0.,SQME*WT)
        CALL HFILL(162003,1000*PCM(3,2),0.,SQME*WT)
        CALL HFILL(162004,1000*PCM(4,2),0.,SQME*WT)
        CALL HFILL(163001,1000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(163002,1000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(163003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(163004,1000*PCM(4,3),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(161005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(161006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(161007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (161008,'X0-Y0 COORDINATE',50,-5.0,5.0,50,-5.0,5.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(161005,X0,0.,SQME*WT)
        CALL HFILL(161006,Y0,0.,SQME*WT)
        CALL HFILL(161007,Z0,0.,SQME*WT)
        CALL HFILL(161008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   



