      SUBROUTINE GEN_PI0_EEG

*     121800 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,P0,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI+ N -> E+ E- G P
*     REFERENCES: 
*     GEANT PARTICLES: E+E-G

      NR=39

      NP=4
      P0=SQRT(TINC(1)*TINC(1)+2.*TINC(1)*MNE)

      TECM=SQRT(MPP*MPP+MNE*MNE+2.*(MPP+TINC(1))*MNE)
      KGENEV=1
      AMASS(1)=0.000510999
      AMASS(2)=0.000510999
      AMASS(3)=0.0
      AMASS(4)=0.93827231
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
*     MATRIX ELEMENT SQUARED = CONSTANT
      SQME=1.

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB   =PCM(4,1)
      IPARTICLE(1)=2
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=   PCM(4,2)
      IPARTICLE(2)=3
      PART(1,2,NR)=PCM(1,2)
      PART(2,2,NR)=PCM(2,2)
      PART(3,2,NR)=PCM(3,2)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,3)
      PLAB(2)=PCM(2,3)
      PLAB(3)=PCM(3,3)
      ELAB=   PCM(4,3)
      IPARTICLE(3)=1
      PART(1,3,NR)=PCM(1,3)
      PART(2,3,NR)=PCM(2,3)
      PART(3,3,NR)=PCM(3,3)
      PART(4,3,NR)=PCM(4,3)
      PART(5,3,NR)=PCM(5,3)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(3),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(391001,'N  PX',100,-80.0,80.0,0.)
        CALL HBOOK1(391002,'N  PY',100,-80.0,80.0,0.)
        CALL HBOOK1(391003,'N  PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(391004,'N  EN',100,  0.0,80.0,0.)
        CALL HBOOK1(392001,'E+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(392002,'E+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(392003,'E+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(392004,'E+ EN',100,  0.0,80.0,0.)
        CALL HBOOK1(393001,'E- PX',100,-80.0,80.0,0.)
        CALL HBOOK1(393002,'E- PY',100,-80.0,80.0,0.)
        CALL HBOOK1(393003,'E- PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(393004,'E- EN',100,  0.0,80.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(391001,211000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(391002,211000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(391003,211000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(391004,211000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(392001,211000*PCM(1,2),0.,SQME*WT)
        CALL HFILL(392002,211000*PCM(2,2),0.,SQME*WT)
        CALL HFILL(392003,211000*PCM(3,2),0.,SQME*WT)
        CALL HFILL(392004,211000*PCM(4,2),0.,SQME*WT)
        CALL HFILL(393001,211000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(393002,211000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(393003,211000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(393004,211000*PCM(4,3),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1) THEN
        CALL HBOOK1(391005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(391006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(391007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (391008,'X0-Y0 COORDINATE',50,-5.0,5.0,50,-5.0,5.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(391005,X0,0.,SQME*WT)
        CALL HFILL(391006,Y0,0.,SQME*WT)
        CALL HFILL(391007,Z0,0.,SQME*WT)
        CALL HFILL(391008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   
