      SUBROUTINE GEN_PI_ENU

*     04OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,C,D,E,PLAB(3),UBUF(10)
      INTEGER NVERT,NT,ILEN3,ILEN4

      REAL SXL,SXR,SYL,SYR,XO,YO
      REAL RVEC3(3),RVEC4(4)
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI+ -> E+ NU EVENT
*
      NR=7

      NP=2
      KGENEV=1
      TECM=0.13956995
      AMASS(1)=0.000510999
      AMASS(2)=0.0

      CALL GENBOD
      WT=1.
      SQME=1.0

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)
      IPARTICLE(1)=2

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(71001,'E+ PX',200,-80.,80.0,0.)
        CALL HBOOK1(71002,'E+ PY',200,-80.,80.0,0.)
        CALL HBOOK1(71003,'E+ PZ',200,-80.,80.0,0.)
        CALL HBOOK1(71004,'E+ EN',200,-10.,80.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(71001,1000.*PCM(1,1),0.,WT)
        CALL HFILL(71002,1000.*PCM(2,1),0.,WT)
        CALL HFILL(71003,1000.*PCM(3,1),0.,WT)
        CALL HFILL(71004,1000.*PCM(4,1),0.,WT)
      ENDIF
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM

c 1111 CALL RNORMX(RVEC,ILEN,RANLUX)
c      X0=BEAM(3)*RVEC(1)
c      X0=X0+1.00
c      CALL RNORMX(RVEC,ILEN,RANLUX)
c      Y0=BEAM(4)*RVEC(1)

*
*     SELECT THE PION Beam Profile
      ILEN3=3
      ILEN4=4
*
*     SELECT THE PION STOPPING POINT
*     runs 21100-22407, 30030-31760, and 35020-37067 have PI0 yields
*     in ratio 0.2208:0.3724:0.4069
*     AREA of Gaussian is proportional to sigma
* select run number
 1111 CALL RANLUX(RVEC3,ILEN3)
      C=RVEC3(1)
      D=RVEC3(2)
      E=RVEC3(3)

c      IF(C.LT.0.2208) THEN ! run21100-22407
         SXL=-0.841
         SXR= 1.012
         SYL=-0.701
         SYR= 0.707
         XO= -0.143
         YO= -0.138
c      ELSEIF(C.GT.5931) THEN ! run35020-37068
c         SXL=-0.908
c         SXR= 1.030
c         SYL=-0.780
c         SYR= 0.738
c         XO= -0.002
c         YO= -0.0092
c      ELSE ! run30030-31760
c         SXL=-0.845
c         SXR= 0.876
c         SYL=-0.884
c         SYR= 0.902
c         XO= -0.0342
c         YO=  0.0108
c      ENDIF

      CALL RNORMX(RVEC4,ILEN4,RANLUX)
      IF(D.LT.(-SXL/(-SXL+SXR))) THEN
        X0=1.02*SXL*ABS(RVEC4(1))+XO
      ELSE
        X0=1.02*SXR*ABS(RVEC4(1))+XO
      ENDIF
      IF(E.LT.(-SYL/(-SYL+SYR)) ) THEN
        Y0=1.02*SYL*ABS(RVEC4(2))+YO
      ELSE
        Y0=1.02*SYR*ABS(RVEC4(2))+YO
      ENDIF

c      CALL RNORMX(RVEC,ILEN,RANLUX)
c      Z0=BEAM(5)*RVEC(1)
      CALL RANLUX(RVEC,ILEN) ! 0.918, 0.841, ave=0.887
      C=RVEC(1)
      IF(C.gt.0.98) THEN
        CALL RANLUX(RVEC,ILEN)
        Z0=3.0*(1.-RVEC(1))-2.0
      ELSEIF(C.gt.0.6872.AND.C.LT.0.98) THEN
        CALL RNORMX(RVEC,ILEN,RANLUX)
        Z0=0.022*RVEC(1)+0.841
      ELSE
         CALL RNORMX(RVEC,ILEN,RANLUX)
         Z0=0.022*RVEC(1)+0.918
      ENDIF  

      IF (SQRT(X0*X0+Y0*Y0).GT.2.1.OR.ABS(Z0).GT.2.5) 
     +   GOTO 1111

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0
      R0=SQRT(X0*X0+Y0*Y0)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(71005,'X0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK1(71006,'Y0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK1(71007,'Z0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK2(71008,'X0-Y0 STOPPING COORDINATES',
     +              100,-5.,5.,100,-5.,5.,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(71005,X0,0.,WT)
        CALL HFILL(71006,Y0,0.,WT)
        CALL HFILL(71007,Z0,0.,WT)
        CALL HFILL(71008,X0,Y0,WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0

      IHCALL(NR)=0

      RETURN
      END   

