      SUBROUTINE GEN_PI_ENUEE

*      06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      REAL RCM(5,18)
      REAL MATRIX_PI_ENUEE,FIN,AIN,RIN
      INTEGER NVERT,NT,I,J
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI+ -> E+ E+ E- NU
*
      NR=9

      NP=4
      TECM=0.13956995
      MPP=0.13956995
      KGENEV=1
      AMASS(1)=0.000510999
      AMASS(2)=0.000510999
      AMASS(3)=0.000510999
      AMASS(4)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM

      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD

      DO I=1,5
         DO J=1,18
            RCM(I,J)=1000.*PCM(I,J)
         ENDDO
      ENDDO

*     MATRIX ELEMENT SQUARED
C      SQME=1./9.727798E-02
C     Form-Factors from PDG
      FIN=0.017
      AIN=0.0116
      RIN=0.059
      SQME=MATRIX_PI_ENUEE(RCM,FIN,AIN,RIN)
C      print *, sqme

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=2
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=PART(4,1,NR)
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,2)
      IPARTICLE(2)=2      
      PART(1,2,NR)=PCM(1,2)
      PART(2,2,NR)=PCM(2,2)
      PART(3,2,NR)=PCM(3,2)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=PART(4,2,NR)
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,3)
      PLAB(2)=PCM(2,3)
      PLAB(3)=PCM(3,3)
      ELAB=PCM(4,3)
      IPARTICLE(3)=3      
      PART(1,3,NR)=PCM(1,3)
      PART(2,3,NR)=PCM(2,3)
      PART(3,3,NR)=PCM(3,3)
      PART(4,3,NR)=PCM(4,3)
      PART(5,3,NR)=PCM(5,3)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=PART(4,3,NR)
      CALL GSKINE(PLAB,IPARTICLE(3),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(91001,'E1+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(91002,'E1+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(91003,'E1+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(91004,'E1+ EN', 100,0.0,80.0,0.)
        CALL HBOOK1(92001,'E2+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(92002,'E2+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(92003,'E2+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(92004,'E2+ EN', 100,0.0,80.0,0.)
        CALL HBOOK1(93001,'E3- PX',100,-80.0,80.0,0.)
        CALL HBOOK1(93002,'E3- PY',100,-80.0,80.0,0.)
        CALL HBOOK1(93003,'E3- PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(93004,'E3- EN', 100,0.0,80.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(91001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(91002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(91003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(91004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(92001,1000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(92002,1000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(92003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(92004,1000*PCM(4,3),0.,SQME*WT)
        CALL HFILL(93001,1000*PCM(1,4),0.,SQME*WT)
        CALL HFILL(93002,1000*PCM(2,4),0.,SQME*WT)
        CALL HFILL(93003,1000*PCM(3,4),0.,SQME*WT)
        CALL HFILL(93004,1000*PCM(4,4),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(91005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(91006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(91007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (91008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(91005,X0,0.,SQME*WT)
        CALL HFILL(91006,Y0,0.,SQME*WT)
        CALL HFILL(91007,Z0,0.,SQME*WT)
        CALL HFILL(91008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   

      INCLUDE 'matrix_pi_enuee.f'
