      SUBROUTINE GEN_PI_ENUG

*     04OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG
      INTEGER ZEROFLAG
      INCLUDE '../common.inc'
*WL
      INCLUDE '../dtor.inc'
      REAL ELAB,X0,Y0,Z0,R0,C,D,E,PLAB(3),UBUF(10),
     +     COSRA,RELANG
      INTEGER NVERT,NT,ILEN3,ILEN4

      REAL SXL,SXR,SYL,SYR,XO,YO
      REAL RVEC3(3),RVEC4(4)

      REAL HRNDM1
*
*     ----------------------------------------------------------------- 
*
*     GENERATE PI + -> E+ NU G
*     REFERENCE: BRYMAN,D.A., DEPOMMIER,P., LEROY,C.: PHYS. REP. 88, 3 (1982)
*                BROWN,S.G., BLUDMAN,S.A.: PHYS. REV. 136B, 1160 (1964)

      NR=8

      NP=3
      TECM=0.13956995
      MPP= 0.13956995
      KGENEV=1
c      AMASS(1)=0.1056584 ! for radiative decay pi+ -> mu+ nu g
      AMASS(1)=0.000510999  ! for radiative decay pi+ -> e+ nu g
      AMASS(2)=0.0
      AMASS(3)=0.0

 1111 CALL GENBOD
*     MATRIX ELEMENT SQUARED
      CALL MATRIX_PI_ENUG
      IF(ZEROFLAG.EQ.1) GOTO 1111

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=2
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)
*
*     SELECT THE PION Beam Profile
      ILEN3=3
      ILEN4=4
*
*     SELECT THE PION STOPPING POINT
*     runs 21100-22407, 30030-31760, and 35020-37067 have PI0 yields
*     in ratio 0.2208:0.3724:0.4069
*     AREA of Gaussian is proportional to sigma
* select run number
 3333 CALL RANLUX(RVEC3,ILEN3)
      C=RVEC3(1)
      D=RVEC3(2)
      E=RVEC3(3)

      IF(C.LT.0.2208) THEN ! run21100-22407
         SXL=-0.841
         SXR= 1.012
         SYL=-0.701
         SYR= 0.707
         XO= -0.143
         YO= -0.138
      ELSEIF(C.GT.5931) THEN ! run35020-37068
         SXL=-0.908
         SXR= 1.030
         SYL=-0.780
         SYR= 0.738
         XO= -0.002
         YO= -0.0092
      ELSE ! run30030-31760
         SXL=-0.845
         SXR= 0.876
         SYL=-0.884
         SYR= 0.902
         XO= -0.0342
         YO=  0.0108
      ENDIF

      CALL RNORMX(RVEC4,ILEN4,RANLUX)
      IF(D.LT.(-SXL/(-SXL+SXR))) THEN
        X0=1.02*SXL*ABS(RVEC4(1))+XO
      ELSE
        X0=1.02*SXR*ABS(RVEC4(1))+XO
      ENDIF
      IF(E.LT.(-SYL/(-SYL+SYR)) ) THEN
        Y0=1.02*SYL*ABS(RVEC4(2))+YO
      ELSE
        Y0=1.02*SYR*ABS(RVEC4(2))+YO
      ENDIF

c      CALL RNORMX(RVEC,ILEN,RANLUX)
c      Z0=BEAM(5)*RVEC(1)
      CALL RANLUX(RVEC,ILEN) ! 0.918, 0.841, ave=0.887
      C=RVEC(1)
      IF(C.gt.0.98) THEN
        CALL RANLUX(RVEC,ILEN)
        Z0=3.0*(1.-RVEC(1))-2.0
      ELSEIF(C.gt.0.6872.AND.C.LT.0.98) THEN
        CALL RNORMX(RVEC,ILEN,RANLUX)
        Z0=0.022*RVEC(1)+0.841
      ELSE
         CALL RNORMX(RVEC,ILEN,RANLUX)
         Z0=0.022*RVEC(1)+0.918
      ENDIF  

      IF (SQRT(X0*X0+Y0*Y0).GT.2.1.OR.ABS(Z0).GT.2.5) 
     +   GOTO 3333                  

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,2)
      IPARTICLE(2)=1
      PART(1,2,NR)=PCM(1,2)
      PART(2,2,NR)=PCM(2,2)
      PART(3,2,NR)=PCM(3,2)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      COSRA=(PCM(1,1)*PCM(1,2)+PCM(2,1)*PCM(2,2)+
     +  PCM(3,1)*PCM(3,2))/(SQRT(PCM(1,1)**2+PCM(2,1)**2+PCM(3,1)**2)*
     +  SQRT(PCM(1,2)**2+PCM(2,2)**2+PCM(3,3)**2)) 
      IF(ABS(COSRA).LE.1.) THEN
*WL ACOSD > ACOS
         RELANG=(1/dtor)*ACOS(COSRA)
      ELSEIF(COSRA.GE.1.) THEN
         RELANG=0.
      ELSEIF(COSRA.LE.-1.)THEN
         RELANG=180.
      ENDIF

C-- Addition for cluster finding (set PLANAR 5)
      IF (IPLANAR.EQ.5.AND.RELANG.LE.30.) GOTO 1111
     
      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(81001,'E+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(81002,'E+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(81003,'E+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(81004,'E+ EN',100,  0.0,80.0,0.)
        CALL HBOOK1(82001,'G  PX',100,-80.0,80.0,0.)
        CALL HBOOK1(82002,'G  PY',100,-80.0,80.0,0.)
        CALL HBOOK1(82003,'G  PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(82004,'G  EN',100,  0.0,80.0,0.)
        CALL HBOOK1(82011,'E+ G REL ANG',400,0.0,200.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(81001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(81002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(81003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(81004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(82001,1000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(82002,1000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(82003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(82004,1000*PCM(4,3),0.,SQME*WT)
        CALL HFILL(82011,RELANG,0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(81005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(81006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(81007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (81008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(81005,X0,0.,SQME*WT)
        CALL HFILL(81006,Y0,0.,SQME*WT)
        CALL HFILL(81007,Z0,0.,SQME*WT)
        CALL HFILL(81008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0

      IHCALL(NR)=0

      RETURN
      END   

      SUBROUTINE MATRIX_PI_ENUG

      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG      
      INTEGER ZEROFLAG
      COMMON/TENSOR/IB,SDP,SDM,T1,T2
      REAL*8 IB,SDP,SDM,T1,T2
      INCLUDE '../common.inc'
      REAL*8 R,R2,OMR2,ASD,AIB,AINT,OPG,OMG,OPG2,OMG2,X1,X2,X3,
     +       Y1,Y2,Y3,Z1,Z2,Z3,E1,E2,E3,X,Y,COSTH_EGA,TH_EGA,
     +       OMX,OMY,OMZ,Z,ZM,OMYM,P1,P2,P3,
     +       GAMTOT,GIB,GSD,GINT,SD,INTP,INTM,INTPM
      REAL*8 LAM,F_PI,F_A,F_V,GAMMA,F_T

C Constants are calculated from the 1990 Review of
C Particle properties

      MPP=0.13956995
c      MEP=0.1056584 ! for radiative decay pi+ -> mu+ nu g
      MEP=0.000510999 ! for radiative decay pi+ -> e+ nu g
      R=MEP/MPP ! 3.66124E-3
      R2=R*R
      OMR2=1.-R2
*
      F_PI=0.1307

      ASD=1.              
      AIB=9.03113E-2
      AINT=2.20058E-3
      OPG=1.38
      OMG=0.62
      OPG2=1.9044
      OMG2=0.3844

      X1=PCM(1,1)
      X2=PCM(1,2)
      X3=PCM(1,3)
      Y1=PCM(2,1)
      Y2=PCM(2,2)
      Y3=PCM(2,3)
      Z1=PCM(3,1)
      Z2=PCM(3,2)
      Z3=PCM(3,3)
      E1=PCM(4,1)
      E2=PCM(4,2)
      E3=PCM(4,3)

      X=2.*PCM(4,2)/MPP
      Y=2.*PCM(4,1)/MPP

C     Test all denominators, skip event if division by ZERO

      ZEROFLAG=0
      IF (X.EQ.0..OR.(X+Y-1.-R2).EQ.0..OR.(X+Y-1.).EQ.0.)THEN
        ZEROFLAG=1
        RETURN
      ENDIF

      LAM=(X+Y-1)/X

      Z   = X+Y-1.

C    Proceed to calculate probabilities following S. G. Brown and
C    S. A. Bludman, Phys. Rev. Vol. 136, B1160, (1964), eq(2.10)

      P1=SQRT(E1*E1-MEP*MEP)
      P2=E2
      P3=E3

C--   R=0 approximation, Bryman et al. PHYS. REP. 88 (1982) 151

C--   Matrix element with Tensor force,
C--   A. V. Chernyshev et al., Modern Physics Letters A, Vol. 12, 1669
C--   (1997)

      SQME1=((1.-LAM)/LAM)*((1.+(1.-X)**2)/X)
      IB=SQME1

      SDP  =(LAM**2)*(X**3)*(1.-X)
      SDM  =((1.-LAM)**2)*(X**3)*(1.-X)
      F_V=0.0259     ! PGP Values
      F_A=0.01295
      F_T=0.0       ! ISTRA Value=-0.0056 or F_T=0.0
      GAMMA=F_A/F_V

      SDP=( ( (F_V*(MPP**2))/(2.*F_PI*MEP) )**2 ) *
     +      ( ((1.+GAMMA)**2)*SDP )

      SDM=( ( (F_V*(MPP**2))/(2.*F_PI*MEP) )**2 ) *
     +      ( ((1.-GAMMA)**2)*SDM )

      SQME2=SDP+SDM

      T1=( (2.*F_T*(MPP**2))/(F_PI*MEP) ) *
     +      (1.-LAM)*X

      T2=( ( (F_T*(MPP**2))/(F_PI*MEP) )**2 )*
     +      LAM*(1-LAM)*(X**3)

      SQME3=T1+T2

**********

      SQME1=( (1.-y+R2)/((x**2)*(x+y-1.-R2)) )*
     . ( (x**2)+2.*(1.-x)*(1.-R2)+
     . (2.*x*R*(1.-R2))/(x+y-1.-R2) )
      IB=SQME1

      SDP= (x+y-1.-R2)*((x+y-1.)*(1.-x)-R2)
      SDM= (1.-y+R2)*((1.-x)*(1.-y)+R2)

      SD= ((1.+GAMMA)**2)*SDP+((1.-GAMMA)**2)*SDM
      SD= ( ((F_V*MPP**2)/(2.*F_PI*MEP))**2 )*SD

      SQME2=SD

      INTP= ((1.-y+R2)/(x*(x+y-1.-R2)))*
     . ((1.-x)*(1.-x-y)+R2)

      INTM= ((1.-y+R2)/(x*(x+y-1.-R2)))*
     . ((x**2)-(1.-x)*(1.-x-y)-R2)

      INTPM=(1.+GAMMA)*INTP+(1.-GAMMA)*INTM
      INTPM=(F_V*MPP/F_PI)*INTPM

      T1= (1.-y)/x
      T1= ((2.*F_T*MPP**2)/(F_PI*MEP))*T1

      T2= (1.-y)*(x+y-1.)
      T2= ( ((F_T*MPP**2)/(F_PI*MEP))**2 )*T2

      SQME3=T1+T2
 
*****************************************************

      SQME=SQME1+SQME2

      RETURN
      END











