      SUBROUTINE GEN_PI_ENUNUNU

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI+ -> E+ NU NU NU
*     REFERENCES: 
*                 
      NR=10

      NP=4
      TECM=0.13956995
      MMU=0.13956995
      KGENEV=1
      AMASS(1)=0.000510999
      AMASS(2)=0.0
      AMASS(3)=0.0
      AMASS(4)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM

      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
*     MATRIX ELEMENT SQUARED
      SQME=1./9.622117E-02

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=2
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(101001,'E+ PX', 100,-80.0,80.0,0.)
        CALL HBOOK1(101002,'E+ PY', 100,-80.0,80.0,0.)
        CALL HBOOK1(101003,'E+ PZ', 100,-80.0,80.0,0.)
        CALL HBOOK1(101004,'E+ EN', 100,  0.0,80.0,0.)
        CALL HBOOK1(101011,'E+ G REL ANG',400,0.0,200.0,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(101001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(101002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(101003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(101004,1000*PCM(4,1),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(101005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(101006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(101007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (1008,'X0-Y0 COORDINATES',100,-5.0,5.0,100,-5.0,5.0,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(101005,X0,0.,SQME*WT)
        CALL HFILL(101006,Y0,0.,SQME*WT)
        CALL HFILL(101007,Z0,0.,SQME*WT)
        CALL HFILL(101008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      IHCALL(NR)=0

      RETURN
      END   

