      SUBROUTINE GEN_PI_MUEENU

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI+ -> MU- E+ E+ NU
*
      NR=12

      NP=4
      TECM=0.13956995
      MPP=0.13956995
      KGENEV=1
      AMASS(1)=0.105658389
      AMASS(2)=0.000510999
      AMASS(3)=0.000510999
      AMASS(4)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM
      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD
*     MATRIX ELEMENT SQUARED
      SQME=1./5.019367E-02

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      IPARTICLE(1)=6
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,2)
      IPARTICLE(2)=2
      PART(1,2,NR)=PCM(1,2)
      PART(2,2,NR)=PCM(2,2)
      PART(3,2,NR)=PCM(3,2)
      PART(4,2,NR)=PCM(4,2)
      PART(5,2,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,3)
      PLAB(2)=PCM(2,3)
      PLAB(3)=PCM(3,3)
      ELAB=PCM(4,3)
      IPARTICLE(3)=2      
      PART(1,3,NR)=PCM(1,3)
      PART(2,3,NR)=PCM(2,3)
      PART(3,3,NR)=PCM(3,3)
      PART(4,3,NR)=PCM(4,3)
      PART(5,3,NR)=PCM(5,3)

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(3),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(121001,'MU- PX',100,-80.0,80.0,0.)
        CALL HBOOK1(121002,'MU- PY',100,-80.0,80.0,0.)
        CALL HBOOK1(121003,'MU- PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(121004,'MU- EN', 100,0.0,80.0,0.)
        CALL HBOOK1(122001,'E1+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(122002,'E1+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(122003,'E1+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(122004,'E1+ EN', 100,0.0,80.0,0.)
        CALL HBOOK1(123001,'E2+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(123002,'E2+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(123003,'E2+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(123004,'E2+ EN', 100,0.0,80.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(121001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(121002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(121003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(121004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(122001,1000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(122002,1000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(122003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(122004,1000*PCM(4,3),0.,SQME*WT)
        CALL HFILL(123001,1000*PCM(1,4),0.,SQME*WT)
        CALL HFILL(123002,1000*PCM(2,4),0.,SQME*WT)
        CALL HFILL(123003,1000*PCM(3,4),0.,SQME*WT)
        CALL HFILL(123004,1000*PCM(4,4),0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(121005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(121006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(121007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (121008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(121005,X0,0.,SQME*WT)
        CALL HFILL(121006,Y0,0.,SQME*WT)
        CALL HFILL(121007,Z0,0.,SQME*WT)
        CALL HFILL(121008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   

