      SUBROUTINE GEN_PI_MUNU

*     04OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10)
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI+ -> MU+ NU EVENT
*
      NR=5

      NP=2
      KGENEV=1
      TECM=0.13956995
      AMASS(1)=0.105658389
      AMASS(2)=0.0

      CALL GENBOD
      WT=1.
      SQME=1.0

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=   PCM(4,1)
      IPARTICLE(1)=5

      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(4,1,NR)=ELAB
      PART(5,1,NR)=SQRT(PLAB(1)**2+PLAB(2)**2+PLAB(3)**2)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(51001,'MU+ PX',100,-80.,80.,0.)
        CALL HBOOK1(51002,'MU+ PY',100,-80.,80.,0.)
        CALL HBOOK1(51003,'MU+ PZ',100,-80.,80.,0.)
        CALL HBOOK1(51004,'MU+ EN',140,0.,140.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(51001,1000.*PCM(1,1),0.,WT)
        CALL HFILL(51002,1000.*PCM(2,1),0.,WT)
        CALL HFILL(51003,1000.*PCM(3,1),0.,WT)
        CALL HFILL(51004,1000.*PCM(4,1),0.,WT)
      ENDIF
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM

      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0
      R0=SQRT(X0*X0+Y0*Y0)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(51005,'X0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK1(51006,'Y0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK1(51007,'Z0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK2
     +  (51008,'X0-Y0 STOPPING COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(51005,X0,0.,WT)
        CALL HFILL(51006,Y0,0.,WT)
        CALL HFILL(51007,Z0,0.,WT)
        CALL HFILL(51008,X0,Y0,WT)
      ENDIF

*     CSI BALL HIT BY MUON?

      IHCALL(NR)=0

      ICALHIT(1)=0

      UBUF(1)=NR
      UBUF(2)=1.
      UBUF(3)=SQME

      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)

      UBUF(1)=ELAB

      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      RETURN
      END   

