      SUBROUTINE GEN_PI_MUNUG

*     04OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG
      INTEGER ZEROFLAG
      INCLUDE '../common.inc'
*WL
      INCLUDE '../dtor.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10),COSRA,RELANG
      INTEGER NVERT,NT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI + -> MU+ NU G

*     REFERENCE: S. G. BROWN, S. A. BLUDMAN, PHYS. REV. VOL. 136, 
*                (1964), B1160, EQ(2.10)
*     SCHECK, F: LEPTONS, HADRONS AND NUCLEI, NORTH-HOLLAND
*                (1983), P.344 
*                
      NR=6

      NP=3
      TECM=0.13956995
      MPP= 0.13956995
      KGENEV=1
      AMASS(1)=0.105658389
      AMASS(2)=0.0
      AMASS(3)=0.0
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM

      CALL RNORMX(RVEC,ILEN,RANLUX)
      X0=BEAM(3)*RVEC(1)
      CALL RNORMX(RVEC,ILEN,RANLUX)
      Y0=BEAM(4)*RVEC(1)
      CALL RANLUX(RVEC,ILEN)
      Z0=BEAM(5)*RVEC(1)

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      CALL GENBOD

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
      PART(1,1,NR)=PCM(1,1)
      PART(2,1,NR)=PCM(2,1)
      PART(3,1,NR)=PCM(3,1)
      PART(4,1,NR)=PCM(4,1)
      PART(5,1,NR)=PCM(5,1)
      IPARTICLE(1)=5

*     MATRIX ELEMENT SQUARED
      CALL MATRIX_PI_MUNUG

c take off mu+ from stack
c     UBUF(1)=NR
c     UBUF(2)=WT
c     UBUF(3)=SQME
c     CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
c     UBUF(1)=ELAB
c     CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      PLAB(1)=PCM(1,3)
      PLAB(2)=PCM(2,3)
      PLAB(3)=PCM(3,3)
      ELAB=PCM(4,3)
      PART(1,2,NR)=PCM(1,3)
      PART(2,2,NR)=PCM(2,3)
      PART(3,2,NR)=PCM(3,3)
      PART(4,2,NR)=PCM(4,3)
      PART(5,2,NR)=PCM(5,3)
      IPARTICLE(2)=1

      COSRA= (PCM(1,1)*PCM(1,3)+PCM(2,1)*PCM(2,3)+
     +  PCM(3,1)*PCM(3,3))/(SQRT(PCM(1,1)**2+PCM(2,1)**2+PCM(3,1)**2)*
     +  SQRT(PCM(1,3)**2+PCM(2,3)**2+PCM(3,3)**2)) 
      IF(ABS(COSRA).LT.1.) THEN
*WL ACOSD > ACOS
        RELANG=(1/dtor)*ACOS(COSRA)
      ELSEIF(COSRA.GE.1.) THEN
        RELANG=0.
      ELSEIF(COSRA.LE.-1.) THEN
        RELANG=-1.
      ENDIF

      UBUF(1)=NR
      UBUF(2)=WT
      UBUF(3)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(61001,'MU+ PX',100,-80.0,80.0,0.)
        CALL HBOOK1(61002,'MU+ PY',100,-80.0,80.0,0.)
        CALL HBOOK1(61003,'MU+ PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(61004,'MU+ EN',280,  0.0,140.0,0.)
        CALL HBOOK1(62001,'G  PX',100,-80.0,80.0,0.)
        CALL HBOOK1(62002,'G  PY',100,-80.0,80.0,0.)
        CALL HBOOK1(62003,'G  PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(62004,'G  EN',100,  0.0,80.0,0.)
        CALL HBOOK1(62011,'MU+ G REL ANG',400,0.0,200.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(61001,1000*PCM(1,1),0.,SQME*WT)
        CALL HFILL(61002,1000*PCM(2,1),0.,SQME*WT)
        CALL HFILL(61003,1000*PCM(3,1),0.,SQME*WT)
        CALL HFILL(61004,1000*PCM(4,1),0.,SQME*WT)
        CALL HFILL(62001,1000*PCM(1,3),0.,SQME*WT)
        CALL HFILL(62002,1000*PCM(2,3),0.,SQME*WT)
        CALL HFILL(62003,1000*PCM(3,3),0.,SQME*WT)
        CALL HFILL(62004,1000*PCM(4,3),0.,SQME*WT)
        CALL HFILL(62011,RELANG,0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(61005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(61006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(61007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (61008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(61005,X0,0.,SQME*WT)
        CALL HFILL(61006,Y0,0.,SQME*WT)
        CALL HFILL(61007,Z0,0.,SQME*WT)
        CALL HFILL(61008,X0,Y0,SQME*WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0

      IHCALL(NR)=0

      RETURN
      END   

      SUBROUTINE MATRIX_PI_MUNUG

      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG
      INTEGER ZEROFLAG
      INCLUDE '../common.inc'
      REAL*8 R,R2,OMR2,ASD,AIB,AINT,OPG,OMG,OPG2,OMG2,X1,X2,X3,
     +       Y1,Y2,Y3,Z1,Z2,Z3,E1,E2,E3,X,Y,COSTH_EGA,TH_EGA,
     +       OMX,OMY,Z,ZM,OMYM,P1,P2,P3,
     +       GAMTOT,GIB,GSD,GINT

C Constants are calculated from the 1990 Review of Particle properties 
C (see also Brown & Bludman, renormalize to MUON MASS!)

      R=(MEP/MPP)*(MMU/MEP)
      R2=R*R
      OMR2=1.-R2
*
      ASD=1.              
      AIB=9.03113E-2*((MMU/MEP)**2)
      AINT=2.20058E-3*((MMU/MEP)**2)

      OPG=1.38
      OMG=0.62
      OPG2=1.9044
      OMG2=0.3844

      X1=PCM(1,1)
      X2=PCM(1,2)
      X3=PCM(1,3)
      Y1=PCM(2,1)
      Y2=PCM(2,2)
      Y3=PCM(2,3)
      Z1=PCM(3,1)
      Z2=PCM(3,2)
      Z3=PCM(3,3)
      E1=PCM(4,1)
      E2=PCM(4,2)
      E3=PCM(4,3)

      COSTH_EGA=(X1*X3+Y1*Y3+Z1*Z3)/(SQRT
     +(X1*X1+Y1*Y1+Z1*Z1)*SQRT(X3*X3+Y3*Y3+Z3*Z3))

      X=2.*PCM(4,3)/MPP
      Y=2.*PCM(4,1)/MPP

C     Test all denominators, skip event if division by ZERO

      ZEROFLAG=0
      IF (X.EQ.0..OR.(X+Y-1.-R2).EQ.0..OR.(X+Y-1.).EQ.0.)THEN
        ZEROFLAG=1
        RETURN
      ENDIF

      OMX = 1.0 - X
      OMY = 1.0 - Y
      Z   = X+Y-1.
      ZM  = Z-R2
      OMYM= OMY+R2
      OMR2= 1.-R2

C    Proceed to calculate probabilities following S. G. Brown and
C    S. A. Bludman, Phys. Rev. Vol. 136, B1160, (1964), eq(2.10)

      GIB=AIB*(OMYM/(X*X*ZM))*(X*X+2.*OMX*OMR2+2.*X*R2*OMR2/ZM)

      GSD=ASD*(OPG2*ZM*(Z*OMX-R2)+OMG2*OMYM*(OMX*OMY+R2))

      GINT=AINT*(OMYM/(X*ZM))*(OPG*(OMX*Z+R2)+
     +          OMG*(X*X-OMX*Z-R2))

      GAMTOT=GIB+GSD+GINT
      SQME1=GIB
      SQME2=GSD
      SQME3=GINT

      GAMTOT=GIB+GSD+GINT
      SQME=GAMTOT/4.802999E9      ! NORM: MAX(WT*SQME)=1.

      P1=SQRT(E1*E1-MEP*MEP)
      P2=E2
      P3=E3

      RETURN
      END
