      SUBROUTINE GEN_PI_PI0ENU

*     06OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
*WL
      INCLUDE '../dtor.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10),
     +     COSRA,RELANG,G1CTH,G1TH,G1PHI,
     +     G2CTH,G2TH,G2PHI,BX,BY,BZ,GAM,C,D,E
      INTEGER NVERT,NT,ILEN3,ILEN4

      REAL SXL,SXR,SYL,SYR,XO,YO
      REAL RVEC3(3),RVEC4(4)
      REAL HRNDM1
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE PI+ -> PI0 E+ NU -> G1 G2 E+ NU (DALITZ Decays excluded!)
*     REFERENCE: KALLEN, G.: ELEMENTARY PARTICLE PHYSICS, ADDISON-WESLEY,
*                400 (1964)
      NR=11

      NP=3
      TECM=0.13956995
      MPP=0.13956995
      KGENEV=1
      AMASS(1)=0.1349764
      AMASS(2)=0.000510999
      AMASS(3)=0.0

      ILEN3=3
      ILEN4=4
*
*     SELECT THE PION STOPPING POINT
*     runs 21100-22407, 30030-31760, and 35020-37067 have PI0 yields
*     in ratio 0.2208:0.3724:0.4069
*     AREA of Gaussian is proportional to sigma
* select run number
 1111 CALL RANLUX(RVEC3,ILEN3)
      C=RVEC3(1)
      D=RVEC3(2)
      E=RVEC3(3)

      IF(C.LT.0.2208) THEN ! run21100-22407
         SXL=-0.841
         SXR= 1.012
         SYL=-0.701
         SYR= 0.707
         XO= -0.143
         YO= -0.138
      ELSEIF(C.GT.5931) THEN ! run35020-37068
         SXL=-0.908
         SXR= 1.030
         SYL=-0.780
         SYR= 0.738
         XO= -0.002
         YO= -0.0092
      ELSE ! run30030-31760
         SXL=-0.845
         SXR= 0.876
         SYL=-0.884
         SYR= 0.902
         XO= -0.0342
         YO=  0.0108
      ENDIF

      CALL RNORMX(RVEC4,ILEN4,RANLUX)
      IF(D.LT.(-SXL/(-SXL+SXR))) THEN
        X0=1.02*SXL*ABS(RVEC4(1))+XO
      ELSE
        X0=1.02*SXR*ABS(RVEC4(2))+XO
      ENDIF
      IF(E.LT.(-SYL/(-SYL+SYR)) ) THEN
        Y0=1.02*SYL*ABS(RVEC4(3))+YO
      ELSE
        Y0=1.02*SYR*ABS(RVEC4(4))+YO
      ENDIF

c realistic beam x-profile
c      X0=1.0*HRNDM1(750001)+BEAM(3)*RVEC(1) ! intrinsic x shape + x oscillation
c      X0=X0*41.5/40.0
c      X0=BEAM(3)*RVEC(1)
c      CALL RNORMX(RVEC,ILEN,RANLUX)
c      X0=X0-0.2*RVEC(1)

      CALL RNORMX(RVEC,ILEN,RANLUX)
c realistic beam y-profile
c      Y0=1.0*HRNDM1(750002)+BEAM(4)*RVEC(1) ! intrinsic y shape + y oscillation
c      Y0=Y0*41.5/40.0
c      Y0=BEAM(4)*RVEC(1)
c      CALL RNORMX(RVEC,ILEN,RANLUX)
c      Y0=Y0-0.07*RVEC(1)

c realistic beam z-profile
c      CALL RNORMX(RVEC,ILEN,RANLUX)
c      Z0=BEAM(5)*RVEC(1)
c      Z0=Z0+1.00

      CALL RANLUX(RVEC,ILEN) ! 0.918, 0.841, ave=0.887
      C=RVEC(1)
      IF(C.gt.0.98) THEN
        CALL RANLUX(RVEC,ILEN)
        Z0=3.0*(1.-RVEC(1))-2.0
      ELSEIF(C.gt.0.6872.AND.C.LT.0.98) THEN
        CALL RNORMX(RVEC,ILEN,RANLUX)
        Z0=0.022*RVEC(1)+0.841
      ELSE
         CALL RNORMX(RVEC,ILEN,RANLUX)
         Z0=0.022*RVEC(1)+0.918
      ENDIF  

      IF (SQRT(X0*X0+Y0*Y0).GT.2.1.OR.ABS(Z0).GT.2.6) 
     +   GOTO 1111
      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0
      CALL GENBOD
*     MATRIX ELEMENT SQUARED (KALLEN)
      SQME=2.0*(-MPP*PCM(4,2)+PCM(1,1)*PCM(1,2)+PCM(2,1)*PCM(2,2)+
     +     PCM(3,1)*PCM(3,2)-PCM(4,1)*PCM(4,2))*
     +     (-MPP*PCM(4,3)+PCM(1,1)*PCM(1,3)+PCM(2,1)*PCM(2,3)+
     +     PCM(3,1)*PCM(3,3)-PCM(4,1)*PCM(4,3))-
     +     (PCM(1,1)*PCM(1,1)+PCM(2,1)*PCM(2,1)+PCM(3,1)*PCM(3,1)-
     +     (MPP+PCM(4,1))*(MPP+PCM(4,1)))*
     +     (PCM(1,2)*PCM(1,3)+PCM(2,2)*PCM(2,3)+
     +     PCM(3,2)*PCM(3,3)-PCM(4,2)*PCM(4,3))

* Radiative correction from E. S. Ginsberg, Phys. Rev. 142 (1966) 1035
* Normalized so that maximal radiative correction at Etot_e+=1.75 MeV
* equals 0.02574*MAX(WT*SQME) (see Fig. 2. from Ref. above)

      SQME1=-0.18929E-02+0.72416E-03*1000.*PCM(4,2)+
     +0.11366E-01*1000.*PCM(4,2)**2-0.81469E-02*1000.*PCM(4,2)**3+
     +0.19148E-02*1000.*PCM(4,2)**4-0.14869E-03*1000.*PCM(4,2)**5
      SQME2=0.
      SQME3=0.

      CALL RANLUX(RVEC,ILEN)
      G1CTH=1.-2.*RVEC(1)
*WL ACOSD > ACOS
      G1TH=(1/dtor)*ACOS(G1CTH)
      CALL RANLUX(RVEC,ILEN)
      G1PHI=360.*RVEC(1)
      G1E=0.5*0.1349734
*WL COSD SIND > COS SIN
      G1X=G1E*SIN(dtor*G1TH)*COS(dtor*G1PHI)
      G1Y=G1E*SIN(dtor*G1TH)*SIN(dtor*G1PHI)
      G1Z=G1E*COS(dtor*G1TH)
      BX=PCM(1,1)/PCM(4,1)
      BY=PCM(2,1)/PCM(4,1)
      BZ=PCM(3,1)/PCM(4,1)
      GAM=1./SQRT(1.-BX*BX-BY*BY-BZ*BZ)
      CALL GBOOST(GAM,BX,BY,BZ,G1E,G1X,G1Y,G1Z)
      PLAB(1)=G1X
      PLAB(2)=G1Y
      PLAB(3)=G1Z
      ELAB=G1E
      IPARTICLE(1)=1
      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(4,1,NR)=ELAB
      PART(5,1,NR)=ELAB

      UBUF(1)=NR
      UBUF(1)=WT
      UBUF(1)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      G2E=0.5*0.1349764
*WL SIND COSD > SIN COS
      G2X=0.5*0.1349764*SIN(dtor*(180.-G1TH))*COS(dtor*(180.+G1PHI))
      G2Y=0.5*0.1349764*SIN(dtor*(180.-G1TH))*SIN(dtor*(180.+G1PHI))
      G2Z=0.5*0.1349764*COS(dtor*(180.-G1TH))
      CALL GBOOST(GAM,BX,BY,BZ,G2E,G2X,G2Y,G2Z)
      PLAB(1)=G2X
      PLAB(2)=G2Y
      PLAB(3)=G2Z
      ELAB=G2E
      IPARTICLE(2)=1
      PART(1,2,NR)=PLAB(1)
      PART(2,2,NR)=PLAB(2)
      PART(3,2,NR)=PLAB(3)
      PART(4,2,NR)=ELAB
      PART(5,2,NR)=ELAB

      UBUF(1)=NR
      UBUF(1)=WT
      UBUF(1)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(2),NVERT,UBUF,1,NT)

      COSRA=(G1X*G2X+G1Y*G2Y+G1Z*G2Z)/
     +  (SQRT(G1X**2+G1Y**2+G1Z**2)*SQRT(G2X**2+G2Y**2+G2Z**2))
      IF(ABS(COSRA).LE.1.) THEN
*WL ACOSD > ACOS
         RELANG=(1/dtor)*ACOS(COSRA)
      ELSEIF(COSRA.GT.1.) THEN
         RELANG=0.
      ELSEIF(COSRA.LT.-1.) THEN
         RELANG=180.
      ENDIF

      PLAB(1)=PCM(1,2)
      PLAB(2)=PCM(2,2)
      PLAB(3)=PCM(3,2)
      ELAB=PCM(4,2)
      IPARTICLE(3)=2
      PART(1,3,NR)=PLAB(1)
      PART(2,3,NR)=PLAB(2)
      PART(3,3,NR)=PLAB(3)
      PART(4,3,NR)=ELAB
      PART(5,3,NR)=PCM(5,2)

      UBUF(1)=NR
      UBUF(1)=WT
      UBUF(1)=SQME
      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      UBUF(1)=ELAB
      CALL GSKINE(PLAB,IPARTICLE(3),NVERT,UBUF,1,NT)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(111001,'G1 PX',100,-80.0,80.0,0.)
        CALL HBOOK1(111002,'G1 PY',100,-80.0,80.0,0.)
        CALL HBOOK1(111003,'G1 PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(111004,'G1 EN',100, 0.0, 80.0,0.)
        CALL HBOOK1(112001,'G2 PX',100,-80.0,80.0,0.)
        CALL HBOOK1(112002,'G2 PY',100,-80.0,80.0,0.)
        CALL HBOOK1(112003,'G2 PZ',100,-80.0,80.0,0.)
        CALL HBOOK1(112004,'G2 EN',100, 0.0, 80.0,0.)
        CALL HBOOK1(113001,'E+ PX',100,-5.,5.,0.)
        CALL HBOOK1(113002,'E+ PY',100,-5.,5.,0.)
        CALL HBOOK1(113003,'E+ PZ',100,-5.,5.,0.)
        CALL HBOOK1(113004,'E+ EN',100,0.,5.0,0.)
        CALL HBOOK1(111011,'G G REL ANG',400,0.0,200.0,0.)
      ENDIF

      IF(IHISTO.EQ.1) THEN
        CALL HFILL(111001,1000*G1X,0.,SQME*WT)
        CALL HFILL(111002,1000*G1Y,0.,SQME*WT)
        CALL HFILL(111003,1000*G1Z,0.,SQME*WT)
        CALL HFILL(111004,1000*G1E,0.,SQME*WT)
        CALL HFILL(112001,1000*G2X,0.,SQME*WT)
        CALL HFILL(112002,1000*G2Y,0.,SQME*WT)
        CALL HFILL(112003,1000*G2Z,0.,SQME*WT)
        CALL HFILL(112004,1000*G2E,0.,SQME*WT)
        CALL HFILL(113001,1000*PLAB(1),0.,SQME*WT)
        CALL HFILL(113002,1000*PLAB(2),0.,SQME*WT)
        CALL HFILL(113003,1000*PLAB(3),0.,SQME*WT)
        CALL HFILL(113004,1000*ELAB,0.,SQME*WT)
        CALL HFILL(111011,RELANG,0.,SQME*WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(111005,'X0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(111006,'Y0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK1(111007,'Z0 COORDINATE',100,-5.0,5.0,0.)
        CALL HBOOK2
     +  (111008,'X0-Y0 COORDINATES',50,-5.,5.,50,-5.,5.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(111005,X0,0.,1.0)
        CALL HFILL(111006,Y0,0.,1.0)
        CALL HFILL(111007,Z0,0.,1.0)
        CALL HFILL(111008,X0,Y0,1.0)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0
      ICALHIT(2)=0
      ICALHIT(3)=0

      IHCALL(NR)=0

      RETURN
      END   

