      SUBROUTINE GEN_PISTOP

*     04OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10),XP,YP,P,BEAM_P(30)
*
*     pi+ BEAM MOMENTUM PROFILE
      DATA BEAM_P/20.,25.,29.,35.,84.,118.,190.,320.,411.,430.,  
     +            510.,560.,585.,568.,560.,567.,570.,540.,490.,464., 
     +            390.,320.,220.,123.,44.,21.,0.,0.,0.,0./           
      REAL X,HRNDM1
      INTEGER I,NVERT,NT
*WL 
      EXTERNAL GRNDM
*       
*     ----------------------------------------------------------------- 
*
*     PION BEAM + CONTAMINATING POSITRONS AND MUONS
*
      NR=4
      WT=1.
      SQME=1.
      MMU=0.10566

*     INPUT TO Z-MOMENTUM FROM TURTLE
      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(11014,'BEAM MOMENTUM',30,0.112,0.115,0.)
        DO I=1,30
           X=(111.95+I*0.1)/1000.
           IF(IHISTO.EQ.1) CALL HFILL(11014,X,0.,BEAM_P(I))
        ENDDO
      ENDIF
*
*     PUT IN THE BEAM DIVERGENCES!
*     
 1111 IF (ILUX.GT.0) CALL RANLUX(RVEC,ILEN)
      IF (ILUX.EQ.0) CALL GRNDM(RVEC,ILEN)
      PLAB(1)=DIVBEAM(1)*(1.-2.*RVEC(1))
      IF (ILUX.GT.0) CALL RANLUX(RVEC,ILEN)
      IF (ILUX.EQ.0) CALL GRNDM(RVEC,ILEN)
      PLAB(2)=DIVBEAM(2)*(1.-2.*RVEC(1))
      PLAB(3)=(TINC(1)**2+2.*TINC(1)*MMU-PLAB(1)**2-PLAB(2)**2)
      PLAB(3)=(BEAM(1)**2-PLAB(1)**2-PLAB(2)**2)
      PLAB(3)=SQRT(PLAB(3))
c      PLAB(3)=HRNDM1(11014)   ! this is a pion beam momentum spectrum at DEG
      PLAB(3)=0.1134           ! this a central pion momentum
      IF (PLAB(3).GT.0.) THEN
        PLAB(3)=1.*(PLAB(3))
      ELSE
        GOTO 1111
      ENDIF

      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(5,1,NR)=SQRT(PLAB(1)**2+PLAB(2)**2+PLAB(3)**2)

*     SELECT PARTICLE (2=POSITRON, 5=POSITIVE MUON, 8=POSITIVE PION)
*     9=NEGATIVE PION, 7=NEUTRAL PION

c      IF (ILUX.GT.0) CALL RANLUX(RVEC,ILEN)
C      IF (ILUX.EQ.0) CALL GRNDM(RVEC,ILEN)
c      IF(RVEC(1).LE.POS_FRAC)THEN
c        IPARTICLE(1)=2                 
c        ELAB=SQRT(0.030**2+MEP**2)
c        PART(4,1,NR)=ELAB
c      ELSEIF(RVEC(1).GT.POS_FRAC.AND.
c     +   RVEC(1).LE.(POS_FRAC+MUO_FRAC))THEN
c        IPARTICLE(1)=5
c        ELAB=SQRT(0.030**2+MMU**2)                 
c        PART(4,1,NR)=ELAB
c      ELSE
        IPARTICLE(1)=8            ! 8=pi+, 5=mu+         
        PLAB(1)=0.
        PLAB(2)=0.
*        ELAB=(0.02195+MPP)     
        ELAB=(TINC(1)+MPP)     
        PART(4,1,NR)=ELAB
c      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(41001,'BEAM PX',100,-10.,10.,0.)
        CALL HBOOK1(41002,'BEAM PY',100,-10.,10.,0.)
        CALL HBOOK1(41003,'BEAM PZ',400,0.,200.,0.)
        CALL HBOOK1(41004,'BEAM EN',400,0.,200.,0.)
        CALL HBOOK1(41009,'pi+ z-STOP PROFILE',200,-3.0,1.0,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(41001,1000.*PLAB(1),0.,WT)
        CALL HFILL(41002,1000.*PLAB(2),0.,WT)
        CALL HFILL(41003,1000.*PLAB(3),0.,WT)
        CALL HFILL(41004,1000.*ELAB,0.,WT)
      ENDIF
*
*     SELECT THE PION STOPPING POINT
*     BEAM SPOT 1x1 CM, STOPPING RANGE 0.2 CM

 2222 IF (ILUX.GT.0) CALL RNORMX(RVEC,ILEN,RANLUX)
      IF (ILUX.EQ.0) CALL RNORMX(RVEC,ILEN,GRNDM)
      X0=BEAM(3)*RVEC(1)
      IF (ILUX.GT.0) CALL RNORMX(RVEC,ILEN,RANLUX)
      IF (ILUX.EQ.0) CALL RNORMX(RVEC,ILEN,GRNDM)
      Y0=BEAM(4)*RVEC(1)
      IF (ILUX.GT.0) CALL RANLUX(RVEC,ILEN)
      IF (ILUX.EQ.0) CALL GRNDM(RVEC,ILEN)
      Z0=ZBEAM      !   +BEAM(5)*(1.-2.*RVEC(1))
      IF (ABS(X0).GT.25.5.OR.ABS(Y0).GT.25..OR.ABS(Z0).GT.100.)GOTO 2222

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0
      R0=SQRT(X0*X0+Y0*Y0)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(41005,'X0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK1(41006,'Y0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK1(41007,'Z0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK2
     +  (41008,'X0-Y0 STOPPING COORDINATES',100,-5.,5.,100,-5.,5.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(41005,X0,0.,WT)
        CALL HFILL(41006,Y0,0.,WT)
        CALL HFILL(41007,Z0,0.,WT)
        CALL HFILL(41008,X0,Y0,WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0

      IHCALL(NR)=0

      UBUF(1)=NR
      UBUF(2)=1.
      UBUF(3)=SQME

C-- Code for /fs26/users/pocanic/nheavns/input_phase_space.dat 

      IF(IPLANAR.EQ.9) THEN
        IPARTICLE(1)=9           ! positive pion=8, negative pion=9
        READ (66,*) X0,Y0,XP,YP,P
        VERTEX(1)=X0
        VERTEX(2)=Y0
        VERTEX(3)=0.0
        PLAB(1)=0.0 !  XP, YP in ?
        PLAB(2)=0.0 !  PLAB in GeV
        IF (PLAB(1).NE.0..AND.PLAB(2).NE.0.) THEN
          PLAB(3)=SQRT(P*P-ABS(PLAB(1))**2-ABS(PLAB(2))**2)
        ELSE
         PLAB(3)=P
        ENDIF
      ENDIF

C code for Fe ion

      IF(IPLANAR.EQ.11) THEN
        IPARTICLE(1)=87
        VERTEX(1)=0.0
        VERTEX(2)=0.0
        VERTEX(3)=0.0
        PLAB(1)=0.0
        PLAB(2)=0.0
        PLAB(3)=33800.
      ENDIF

      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)

      UBUF(1)=ELAB

      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      IHCALL(NR)=0

      RETURN
      END   
