      SUBROUTINE GEN_PISTOP

*     04OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10),XP,YP,P,BEAM_P(30)
      REAL C,D,E
*
*     pi+ BEAM MOMENTUM PROFILE
      DATA BEAM_P/20.,25.,29.,35.,84.,118.,190.,320.,411.,430.,  
     +            510.,560.,585.,568.,560.,567.,570.,540.,490.,464., 
     +            390.,320.,220.,123.,44.,21.,0.,0.,0.,0./           
      REAL X,HRNDM1
      INTEGER I,NVERT,NT,ILEN3,ILEN4
      REAL SXL,SXR,SYL,SYR,XO,YO
      REAL RVEC3(3),RVEC4(4)


*WL 
      EXTERNAL GRNDM
*       
*     ----------------------------------------------------------------- 
*
*     PION BEAM + CONTAMINATING POSITRONS AND MUONS
*
      NR=4
      WT=1.
      SQME=1.
      MMU=0.10566

*     INPUT TO Z-MOMENTUM FROM TURTLE
      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(11014,'BEAM MOMENTUM',30,0.112,0.115,0.)
        DO I=1,30
           X=(111.95+I*0.1)/1000.
           IF(IHISTO.EQ.1) CALL HFILL(11014,X,0.,BEAM_P(I))
        ENDDO
      ENDIF
*
*     SELECT THE PION Beam Profile
      ILEN3=3
      ILEN4=4
*
*     SELECT THE PION STOPPING POINT
*     runs 21100-22407, 30030-31760, and 35020-37067 have PI0 yields
*     in ratio 0.2208:0.3724:0.4069
*     AREA of Gaussian is proportional to sigma
* select run number
 2222 CALL RANLUX(RVEC3,ILEN3)
      C=RVEC3(1)
      D=RVEC3(2)
      E=RVEC3(3)

c      IF(C.LT.0.2208) THEN ! run21100-22407
         SXL=-0.841
         SXR= 1.012
         SYL=-0.701
         SYR= 0.707
         XO= -0.143
         YO= -0.138
c      ELSEIF(C.GT.5931) THEN ! run35020-37068
c         SXL=-0.908
c         SXR= 1.030
c         SYL=-0.780
c         SYR= 0.738
c         XO= -0.002
c         YO= -0.0092
c      ELSE ! run30030-31760
c         SXL=-0.845
c         SXR= 0.876
c         SYL=-0.884
c         SYR= 0.902
c         XO= -0.0342
c         YO=  0.0108
c      ENDIF

      CALL RNORMX(RVEC4,ILEN4,RANLUX)
      IF(D.LT.(-SXL/(-SXL+SXR))) THEN
        X0=1.02*SXL*ABS(RVEC4(1))+XO
      ELSE
        X0=1.02*SXR*ABS(RVEC4(1))+XO
      ENDIF
      IF(E.LT.(-SYL/(-SYL+SYR)) ) THEN
        Y0=1.02*SYL*ABS(RVEC4(2))+YO
      ELSE
        Y0=1.02*SYR*ABS(RVEC4(2))+YO
      ENDIF
  
c 2222 CALL RNORMX(RVEC,ILEN,RANLUX)
c realistic beam x-profile
c      X0=1.0*HRNDM1(750001)+BEAM(3)*RVEC(1) ! + 0.001 intrinsic x shape + x oscillation
c      X0=BEAM(3)*RVEC(1)

c      CALL RNORMX(RVEC,ILEN,RANLUX)
c realistic beam y-profile
c      Y0=1.0*HRNDM1(750002)+BEAM(4)*RVEC(1) ! + 0.001 intrinsic y shape + y oscillation
c      Y0=BEAM(4)*RVEC(1)
c      Z0=ZBEAM

      CALL RANLUX(RVEC,ILEN) ! 0.918, 0.841, ave=0.887
      C=RVEC(1)
      IF(C.gt.0.98) THEN
        CALL RANLUX(RVEC,ILEN)
        Z0=3.0*(1.-RVEC(1))-2.0
      ELSEIF(C.gt.0.6872.AND.C.LT.0.98) THEN
        CALL RNORMX(RVEC,ILEN,RANLUX)
        Z0=0.022*RVEC(1)+0.841
      ELSE
         CALL RNORMX(RVEC,ILEN,RANLUX)
         Z0=0.022*RVEC(1)+0.918
      ENDIF  

      IF (SQRT(X0*X0+Y0*Y0).GT.2.1.OR.ABS(Z0).GT.2.5) 
     +   GOTO 2222

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0
      R0=SQRT(X0*X0+Y0*Y0)
*
*     PUT IN THE BEAM DIVERGENCES!
*     
 1111 PLAB(3)=HRNDM1(11014) 
c     PLAB(3)=((TINC(1)/1000.)**2+2.*TINC(1)*MPP/1000.)

c     CALL RANLUX(RVEC,ILEN)
      CALL GRNDM(RVEC,ILEN)
      PLAB(1)=(R0/2.5)*DIVBEAM(1)*(1.-2.*RVEC(1))*PLAB(3)
c     CALL RANLUX(RVEC,ILEN)
      CALL GRNDM(RVEC,ILEN)
      PLAB(2)=(R0/2.5)*DIVBEAM(2)*(1.-2.*RVEC(1))*PLAB(3)
      PLAB(3)=(PLAB(3)**2-PLAB(1)**2-PLAB(2)**2)
c     PLAB(3)=(BEAM(1)**2-PLAB(1)**2-PLAB(2)**2)
      PLAB(3)=SQRT(PLAB(3))
c     PLAB(3)=HRNDM1(11014)   ! this is a pion beam momentum spectrum at DEG
c      PLAB(3)=0.1134           ! this a central pion momentum
      IF (PLAB(3).GT.0.) THEN
        PLAB(3)=1.*(PLAB(3))
      ELSE
        GOTO 1111
      ENDIF

c or do stopped pions ****************
      PLAB(1)=0.
      PLAB(2)=0.
      PLAB(3)=0.
**************************************

      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(5,1,NR)=SQRT(PLAB(1)**2+PLAB(2)**2+PLAB(3)**2)

*     SELECT PARTICLE (2=POSITRON, 5=POSITIVE MUON, 8=POSITIVE PION)
*     9=NEGATIVE PION, 7=NEUTRAL PION

c      IF (ILUX.GT.0) CALL RANLUX(RVEC,ILEN)
C      IF (ILUX.EQ.0) CALL GRNDM(RVEC,ILEN)
c      IF(RVEC(1).LE.POS_FRAC)THEN
c        IPARTICLE(1)=2                 
c        ELAB=SQRT(0.030**2+MEP**2)
c        PART(4,1,NR)=ELAB
c      ELSEIF(RVEC(1).GT.POS_FRAC.AND.
c     +   RVEC(1).LE.(POS_FRAC+MUO_FRAC))THEN
c        IPARTICLE(1)=5
c        ELAB=SQRT(0.030**2+MMU**2)                 
c        PART(4,1,NR)=ELAB
c      ELSE
        IPARTICLE(1)=8            ! 8=pi+, 5=mu+         
c       PLAB(1)=0.
c       PLAB(2)=0.
*        ELAB=(0.02195+MPP)     
        ELAB=(TINC(1)+1000.*MPP)     
        PART(4,1,NR)=ELAB
c      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(41001,'BEAM PX',100,-10.,10.,0.)
        CALL HBOOK1(41002,'BEAM PY',100,-10.,10.,0.)
        CALL HBOOK1(41003,'BEAM PZ',400,0.,200.,0.)
        CALL HBOOK1(41004,'BEAM T_INC',400,0.,200.,0.)
        CALL HBOOK1(41009,'pi+ z-STOP PROFILE',200,-3.0,1.0,0.)

        CALL HBOOK1(41010,'TGT 00',9,-0.5,8.5,0.)
        CALL HBOOK1(41011,'TGT OUT1overCEN EN',300,0.,30.0,0.)
        CALL HBOOK1(41012,'TGT OUT2overOUT1 EN',300,0.,30.,0.)

      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(41001,1000.*PLAB(1),0.,WT)
        CALL HFILL(41002,1000.*PLAB(2),0.,WT)
        CALL HFILL(41003,1000.*PLAB(3),0.,WT)
        CALL HFILL(41004,TINC(1),0.,WT)
      ENDIF

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(41005,'X0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK1(41006,'Y0 STOPPING COORDINATE',100,-5.,5.,0.)
        CALL HBOOK1(41007,'Z0 STOPPING COORDINATE',200,-10.,10.,0.)
        CALL HBOOK2
     +  (41008,'X0-Y0 STOPPING COORDINATES',100,-5.,5.,100,-5.,5.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(41005,X0,0.,WT)
        CALL HFILL(41006,Y0,0.,WT)
        CALL HFILL(41007,Z0,0.,WT)
        CALL HFILL(41008,X0,Y0,WT)
      ENDIF

*     CSI BALL HIT BY ELECTRON?

      ICALHIT(1)=0

      IHCALL(NR)=0

      UBUF(1)=NR
      UBUF(2)=1.
      UBUF(3)=SQME

C-- Code for /fs26/users/pocanic/nheavns/input_phase_space.dat 

c     IF(IPLANAR.EQ.9) THEN
c       IPARTICLE(1)=9           ! positive pion=8, negative pion=9
c       READ (66,*) X0,Y0,XP,YP,P
c       VERTEX(1)=X0
c       VERTEX(2)=Y0
c       VERTEX(3)=0.0
c       PLAB(1)=0.0 !  XP, YP in ?
c       PLAB(2)=0.0 !  PLAB in GeV
c       IF (PLAB(1).NE.0..AND.PLAB(2).NE.0.) THEN
c         PLAB(3)=SQRT(P*P-ABS(PLAB(1))**2-ABS(PLAB(2))**2)
c       ELSE
c        PLAB(3)=P
c       ENDIF
c     ENDIF

C code for Fe ion

c     IF(IPLANAR.EQ.11) THEN
c       IPARTICLE(1)=87
c       VERTEX(1)=0.0
c       VERTEX(2)=0.0
c       VERTEX(3)=0.0
c       PLAB(1)=0.0
c       PLAB(2)=0.0
c       PLAB(3)=33800.
c     ENDIF

      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)

      UBUF(1)=ELAB

      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      IHCALL(NR)=0

      RETURN
      END   










