      SUBROUTINE GEN_POSITRON

*     04OCT95 EF

      IMPLICIT NONE
      REAL X0,Y0,Z0,PLAB(3),UBUF(10),ELAB,
     +     COSTH,THETA,PHI
      INTEGER NVERT,NT
*      
*     ----------------------------------------------------------------- 

      INCLUDE '../common.inc'
*WL
      INCLUDE '../dtor.inc'

*     ----------------------------------------------------------------- 
      
*     REACTION INDEX

      NR=3
      NP=1

      IPARTICLE(1)=2
      IF(IPLANAR.EQ.2) IPARTICLE(1)=3 ! electron
      WT=1.0
      SQME=1.0

      CALL RANLUX(RVEC,ILEN)

      IF(IPLANAR.EQ.1) THEN
        THETA=90.
        PHI=360.*RVEC(1)
      ELSE
        COSTH=1.-2.*RVEC(1)
        CALL RANLUX(RVEC,ILEN)
        PHI=360.*RVEC(1)
*WL ACOSD -> ACOS
        THETA=(1/dtor)*ACOS(COSTH)
      ENDIF

      IF(IPLANAR.EQ.2) THEN
        THETA=0.
        PHI=0.
      ENDIF

      X0=0.
      Y0=0.
      Z0=0.             

      CALL RANLUX(RVEC,ILEN)
      ELAB=EPOSITRON(1)+EPOSITRON(2)*(1.-2.*RVEC(1))

C positron beam along axis
      IF(IPLANAR.EQ.4) THEN
        CALL RANLUX(RVEC,ILEN) 
        COSTH=1.-0.00001**RVEC(1)    
*WL ACOSD -> ACOS
        THETA=(1/dtor)*ACOS(COSTH)  
        CALL RANLUX(RVEC,ILEN) 
        PHI=360.*RVEC(1)        
        Z0=-8.0
      ENDIF                         

*WL COSD SIND -> COS SIN
      PLAB(1)=ELAB*COS(dtor*PHI)*SIN(dtor*THETA)
      PLAB(2)=ELAB*SIN(dtor*PHI)*SIN(dtor*THETA)
      PLAB(3)=ELAB*COS(dtor*THETA)

      PART(1,1,NR)=PLAB(1)
      PART(2,1,NR)=PLAB(2)
      PART(3,1,NR)=PLAB(3)
      PART(4,1,NR)=ELAB
      PART(5,1,NR)=SQRT(PLAB(1)**2+PLAB(2)**2+PLAB(3)**2)

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(31001,'G PX',800,0.,200.,0.)
        CALL HBOOK1(31002,'G PY',800,0.,200.,0.)
        CALL HBOOK1(31003,'G PZ',800,0.,200.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(31001,1000.*PLAB(1),0.,WT)
        CALL HFILL(31002,1000.*PLAB(2),0.,WT)
        CALL HFILL(31003,1000.*PLAB(3),0.,WT)
      ENDIF

      IF(IPLANAR.EQ.2) THEN
        CALL RANLUX(RVEC,ILEN)
        X0=3.*(1.-2.*RVEC(1))
        CALL RANLUX(RVEC,ILEN)
        Y0=3.*(1.-2.*RVEC(1))
      ENDIF

      IF(IPLANAR.EQ.3) THEN
        CALL RNORMX(RVEC,ILEN,RANLUX)
        X0=BEAM(3)*RVEC(1)
        CALL RNORMX(RVEC,ILEN,RANLUX)
        Y0=BEAM(4)*RVEC(1)
        CALL RANLUX(RVEC,ILEN)
        Z0=BEAM(5)*RVEC(1)
      ENDIF

      VERTEX(1)=X0
      VERTEX(2)=Y0
      VERTEX(3)=Z0

      IF(IHCALL(NR).EQ.1.AND.IHISTO.EQ.1) THEN
        CALL HBOOK1(31005,'G X0 COORDINATE',600,0.,1000.,0.)
        CALL HBOOK1(31006,'G Y0 COORDINATE',600,0.,1000.,0.)
        CALL HBOOK1(31007,'G Z0 COORDINATE',600,0.,1000.,0.)
        CALL HBOOK2(31008,'G Z0-X0 COORDINATES',
     +              50,-1000.,1000.,50,-1000.,1000.,0.)
      ENDIF
      IF(IHISTO.EQ.1) THEN
        CALL HFILL(31005,X0,0.,WT)
        CALL HFILL(31006,Y0,0.,WT)
        CALL HFILL(31007,Z0,0.,WT)
        CALL HFILL(31008,Z0,X0,WT)
      ENDIF

*     CSI BALL HIT?

      ICALHIT(1)=0

      IHCALL(NR)=0

*     EVENT TYPE, EVENT WEIGHT, MATRIX ELEMENT

      UBUF(1)=3.
      UBUF(2)=1.
      UBUF(3)=1.

      CALL GSVERT(VERTEX,0,0,UBUF,3,NVERT)
      
      UBUF(1)=PART(4,1,3)

      CALL GSKINE(PLAB,IPARTICLE(1),NVERT,UBUF,1,NT)

      RETURN
      END   
