      SUBROUTINE MATRIX_MU_ENUNU
      implicit none
      INCLUDE '../common.inc'
      real mat,x,m_e,m_mu,e0,dist,alfa,pi,dx,phase,rho_michel
      integer i
      real frad,om,r,g,eta,f,beta

C Kallen, G.: Elementary Paeticle Physics, p. 387, Eq. (14.51)
C Notice that the phase space is already included in the calculation!

      alfa=1./137.
      pi=3.14159
      m_e=0.511
      m_mu=106.5
      rho_michel=(3./4.)
      e0=(m_mu**2+m_e**2)/(2.*m_mu)

      x=1000.*pcm(4,1)/e0
      if (x.ge.1.e-15) then
         continue
      else
         x=1.e-15
      endif

C Without radiative corrections (Kallen) 
      mat=1.-x+(2./3.)*rho_michel*((4./3.)*x-1.)

C with polarization POL, rho=3./4.
c      POL=0.0
c      mat=3.-2.*x+(1.-2.*x)*POL ! *cos(th)

C With radiative corrections
      CALL RANLUX(RVEC,ILEN)
      om=log(m_mu/m_e)
      eta=0.
      beta=pcm(5,1)/pcm(4,1)
      r=2.*(x+x**2/2.)-pi**2/3.-2.+om*( 3./2.+2.*log((1-x)/x) ) -
     .  (2.*log(x)-1.)*log(x)+(3.*log(x)-1.-1./x)*log(1.-x)
      g=(2.-4.*x)*r+(2.-6.*x)*log(x)
      f=(6.-4.*x)*r+(6.-6.*x)*log(x)+((1-x)/(3.*x**2))*
     .  ( (5.+17.*x-34.*x**2)*(om+log(x))-22.*x+34.*x**2 )
c      mat=3.-2.*x-(m_e**2/(e0*e0*x))+6.*eta*(m_e/e0)*((1.-x)/x)+
c     .    alfa*f/(2.*pi)+beta*(1.-2.*rvec(1))*(1.-2.*x+
c     .    (m_e**2/(m_mu*e0))+alfa*g/(2.*pi) )

      phase=x*x
c But this is N(x) and I need dN/dx
c d(x*x)=d(x^2)=2xdx

      sqme=mat*x

c But this is N(x) and I need dN/dx

      return
      end

C   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      real function frad(x)
      implicit none
      real*4 f1,f2,f3,x,pi,m_mu,m_e,omega,rad
      m_mu=106.5
      m_e=0.511
      omega=alog(m_mu/m_e)
      f1=(6.-4.*x)*rad(x)
      f2=6.*(1.-x)*alog(x)
      f3=(1.-x)/3./x**2*((5.+17.*x-34.*x**2)*(omega+alog(x))
     1 -22.*x+34.*x**2)
      frad=f1+f2+f3
      return
      end

C   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 

      real function rad(x)
      implicit none
      real*4 f1,f2,f3,x,pi,m_mu,m_e,omega
      pi=3.14159
      m_mu=106.5
      m_e=0.511
      omega=alog(m_mu/m_e)
      f1=x*(1.+x*(1./4.+x*(1./9.+x/16.)))
      f1=2.*f1-pi**2/3.-2.
      f2=omega*(1.5+2.*alog((1-x)/x))
      f3=-(2.*alog(x)-1.)*alog(x)+(3.*alog(x)-1.-1./x)*alog(1.-x)
      rad=f1+f2+f3
      return
      end




