C
C--   NaI CALORIMETER array for photon tagging, NIM A271 (1988) 497-506 
C

      DATA NAIC / 3.175, 3.175, 20.30/ ! NaI crystal block dx/2*dy/2*dz/2
      DATA NAIB1/27.10,27.10, 21.25/ ! NaI crystal box1  dx/2*dy/2*dz/2
      DATA NAIB2/27.10,27.10,300.00/ ! NaI crystal box2  dx/2*dy/2*dz/2
      DATA NAIFE/27.10,27.10,0.025/  ! Front steel plate
      DATA NAIAL/27.10,27.10,0.100/  ! Front aluminum foil
      DATA NAIVE/27.10,27.10,0.5/    ! 1 cm thick Plastic Veto
C
C--   Define the geometry
C     Lateral and rear wall of the air-tight NaI box: 1.9 cm aluminum
C     Front: 0.05 cm steel at NaI, out 2.0 cm styrofoam, 0.2 cm aluminum     

C-- summer 1997 geometry: NaI-CsI face-to-face distance 1821mm
C--                       NaI Al Plate to TGT Center Distance 100.2cm
C   
C   NaI                  TGT           CsI Center CsI
C   |++++++|             *****          *         |++++++|
C          |< 938mm     >|128|< 495mm  >|< 260mm >| 
C
C--   Lateral and rear plates
      CALL GSVOLU('NAI1','BOX ',17,NAIB1,3,ISTATUS) ! NaI CALORIMETER1 Al
C--   Front plates
      CALL GSVOLU('NAFE','BOX ',12,NAIFE,3,ISTATUS)  
      CALL GSVOLU('NAAL','BOX ',17,NAIAL,3,ISTATUS)
C
C--   Plastic veto
      CALL GSVOLU('NAIV','BOX ',3,NAIVE,3,ISTATUS)  
C
      CALL GSVOLU('NAI2','BOX ', 2,NAIB2,3,ISTATUS) ! NaI CALORIMETER2 Air
C
C--   64 NaI blocks
      DO I=1,64
        CALL GSVOLU('NA'//CDE(I),'BOX ',16,NAIC, 3,ISTATUS) ! NaI Block
      ENDDO
C
C--   Position the NaI counters (NaI ISVOL[401,464])
c
C     First Rotation of NAI2 then offsets of NAI1 & NAIC 100 cm 
c 
      CALL GSROTM(1001,26.56505,0.,90.,90.,63.43495,180.)

      X=0.0
      Y=0.0
      Z=0.0
      N=0

      CALL GSPOS ('NAI1',1,'NAI2',0.0,0.0,-124.65,0,'MANY') ! NAI1 in NAI2
      CALL GSPOS ('NAI2',1,'MAMA',0.0,0.0,0.0,1001,'MANY')

      CALL GSPOS ('NAFE',1,'NAI1',0.,0.,22.50,0,'ONLY') ! steel plate
      CALL GSPOS ('NAAL',1,'NAI1',0.,0.,23.00,0,'ONLY') ! aluminum plate
      CALL GSPOS ('NAIV',1,'NAI1',0.,0.,24.00,0,'ONLY') ! plastic veto
      CALL GSDETV('NAVE','NAIV',400,100,100,ISET,IDET)! SensDet 400
      CALL GSDETH('NAVE','NAIV',2,NAMESH,NBITSH,ORIG,FACT) 

      DO I=3,-4,-1
         DO J=3,-4,-1
           N=N+1
           X=3.175+6.35*I
           Y=3.175+6.35*J
           Z=0.95
           CALL GSPOS ('NA'//CDE(N),1,'NAI1',X,Y,Z,0,'ONLY')       ! Blocks in NAI1
           CALL GSDETV('NA','NA'//CDE(N),400+N,100,100,ISET,IDET)! SensDet 401-464
           CALL GSDETH('NA','NA'//CDE(N),2,NAMESH,NBITSH,ORIG,FACT) 
         ENDDO
      ENDDO


