************************************************************************    
*
       SUBROUTINE NTP101
*
*      History
*      -------
*
*      101195 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'
*yw4f add parameter anum
      real anum
      parameter (anum=180.0/3.14159)
*yw4f 

*     FINAL STATE:
*
*     IR -> REACTION NUMBER, TB -> BEAM ENERGY, IP1,IP2,IP3 -> PARTICLE 
*     INDICES, X0,Y0,Z0 -> BEAM STOP, PX1,PY1,PZ1,T1 -> PARTICLE 1 MOMENTUM
*     AND KINETIC ENERGY, PX2,PY2,PZ2,T2 ...
*
*     ENERGY DEPOSITIONS:
*
*     DETG -> DEP. EN. TARGET, DETG -> DEP. EN. DEGRADER
*
*     P01 -> P10: PENTA, A01 -> A50: HEX-A, B01 -> B50: HEX-B
*     C01 -> C50: HEX-B, D01 -> D40: HEX-D, H01 -> H20: HEX-D/2, ECAL
*     V01 -> V20: VETO, EVET 
*     PV01 -> PV20, DEPV: PLASTIC VETO,
*
*     CVFR,CVBA,CVTO,CVSL,CVSR,ECOS -> COSMIC VETO
*     
*     MWX1,MWX2,MWY1,MWY2,MWZ1,MWZ2 -> MWPC HITS
*
*     TMTG -> TARGET TDC, TMDG -> DEGRADER TDC, ...
*
*yw4f initialize TAG101 in another file ntp100.f
*      DATA TAG101/
*     +'IR','TB','IP1','IP2','IP3','X0','Y0','Z0','PX1','PY1','PZ1',     1-11
*     +'T1','PX2','PY2','PZ2','T2','PX3','PY3','PZ3','T3','ETAR','EDGD', 12-22  
*     +'PV01','PV02','PV03','PV04','PV05','PV06','PV07','PV08','PV09',   23-31
*     +'PV10','PV11','PV12','PV13','PV14','PV15','PV16','PV17','PV18',   32-40
*     +'PV19','PV20','DEPV','MWX1','MWX2','MWY1','MWY2','MWZ1','MWZ2',   41-49
**     +'P01','P02','P03','P04','P05','P06','P07','P08','P09','P10',     50-59
*     +'EC1','EC2','EC3','T12','T13','T23','S12','S13','S23','PSQ',      50-59
**    +'A01','A02','A03','A04','A05','A06','A07','A08','A09','A10',      60-69
*     +'PC1','PC2','PC3','LAM','IB','SDP','SDM','TE1','TE2','A10',       60-69
*     +'A11','A12','A13','A14','A15','A16','A17','A18','A19','A20',      70-79
*     +'A21','A22','A23','A24','A25','A26','A27','A28','A29','A30',      80-89
*     +'A31','A32','A33','A34','A35','A36','A37','A38','A39','A40',      90-99
*     +'A41','A42','A43','A44','A45','A46','A47','A48','A49','A50',      100-109
*     +'B01','B02','B03','B04','B05','B06','B07','B08','B09','B10',      110-119
*     +'B11','B12','B13','B14','B15','B16','B17','B18','B19','B20',      120-129
*     +'B21','B22','B23','B24','B25','B26','B27','B28','B29','B30',      130-139
*     +'B31','B32','B33','B34','B35','B36','B37','B38','B39','B40',      140-149
*     +'B41','B42','B43','B44','B45','B46','B47','B48','B49','B50',      150-159
*     +'C01','C02','C03','C04','C05','C06','C07','C08','C09','C10',      160-169
*     +'C11','C12','C13','C14','C15','C16','C17','C18','C19','C20',      170-179
*     +'C21','C22','C23','C24','C25','C26','C27','C28','C29','C30',      180-189
*     +'C31','C32','C33','C34','C35','C36','C37','C38','C39','C40',      190-199
*     +'C41','C42','C43','C44','C45','C46','C47','C48','C49','C50',      200-209
*     +'D01','D02','D03','D04','D05','D06','D07','D08','D09','D10',      210-219
*     +'D11','D12','D13','D14','D15','D16','D17','D18','D19','D20',      220-229
*     +'D21','D22','D23','D24','D25','D26','D27','D28','D29','D30',      230-239
*     +'D31','D32','D33','D34','D35','D36','D37','D38','D39','D40',      240-249
*     +'H01','H02','H03','H04','H05','H06','H07','H08','H09','H10',      250-259
*     +'H11','H12','H13','H14','H15','H16','H17','H18','H19','H20',      260-269
*     +'V01','V02','V03','V04','V05','V06','V07','V08','V09','V10',      270-279
*     +'V11','V12','V13','V14','V15','V16','V17','V18','V19','V20',      280-289
*     +'ECAL','ECAV','CVFR','CVBA','CVTO','CVSL','CVSR','ECVE',          290-297
*     +'TTAR','TDGD','TMPV','TMMW','TCALO','TCALOVET','TCOSMV',          298-304
*     +'WT','SQME','RA','NCL','NSCL','NCLH','NSCH','THT12','HT7',        305-313
*     +'HT8','HT11','WC','NH1','NH2','DH1','DH2','TR','PI0','NEU',       314-323
*     +'GAM','DEG1','DEG2','REG1','REG2','SQM1','SQM2','SQM3','THTC',    324-332
*     +'LT7','LT8','LT11','TDC1','TDC2','SEED1','SEED2','CMAX','ENAI',   333-341
*     +'ENAV','TNAI','TNAV','NPV'/                                       342-345

*yw4f end
*      
C--   Row-wise Ntple Definition
        CALL HBOOKN(101,'PIBETA DETECTOR, True Single Events',
     +              L101,'PIBETA',20000,TAG101)

      IF (ICOINCID.GE.2) THEN
        CALL HBOOKN(102,'PIBETA DETECTOR, Double Coincidences',
     +              L101,'PIBETA',20000,TAG101)
      ENDIF
      IF (ICOINCID.GE.3) THEN
        CALL HBOOKN(103,'PIBETA DETECTOR, Triple Coincidences',
     +              L101,'PIBETA',20000,TAG101)
      ENDIF
      IF (ICOINCID.GE.4) THEN
        CALL HBOOKN(104,'PIBETA DETECTOR, Quad Coincidences',
     +              L101,'PIBETA',20000,TAG101)
      ENDIF
*
      RETURN
      END   

************************************************************************    
*
       SUBROUTINE FILL101
*
*
*      History
*      -------
*
*      111095 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE '../common.inc'
      REAL HRNDM1

*yw4f add parameter anum
      real anum
      parameter (anum=180.0/3.14159)
*yw4f end

      COMMON/QUEST/IQUEST(100)

      COMMON /FCLUSTER/CC(9,60),SCC(6,10),CADC(60),CTDC(60),
     +       FIREDL(60),FIREDH(60),BFIREDL(60),BFIREDH(60),
     +       NFIREDL,NFIREDH,SFIREDL(10),SFIREDH(10),
     +       BSFIREDL(10),BSFIREDH(10),NSFIREDL,
     +       NSFIREDH,CLTHT(60),CLPHI(60),THT12,HTRIGGER(50),
     +       LTRIGGER(50),ICLUST,THT1,PHI1,TDC1,TDC2

      REAL CADC,CTDC,THT1,PHI1,THT2,THT3,THT12,CLTHT,CLPHI,
     +     TDC1,TDC2
      INTEGER CC,SCC,FIREDL,FIREDH,BFIREDL,BFIREDH,NFIREDL,
     +        NFIREDH,SFIREDL,SFIREDH,BSFIREDL,BSFIREDH,NSFIREDL,
     +        NSFIREDH,HTRIGGER,LTRIGGER,ICLUST

      COMMON/SUPERDEP/EDEPS(10),GA1D,GA2D,IGA1D,IGA2D,THTC
      REAL EDEPS,GA1D,GA2D

      REAL COSTHT,THTC
      REAL ECSIMAX,EDEP_OUTER

      INTEGER I,J,L,N,M,IQUEST,IGA1D,IGA2D

      COMMON/CLUMPS/EDEP_CL1,EDEP_CL2,EDEP_CL3,
     +              THT_B12,THT_B13,THT_B23,
     +              SHARE12,SHARE13,SHARE23,PSQ,LAMM
      REAL EDEP_CL1,EDEP_CL2,EDEP_CL3,
     +     THT_B12,THT_B13,THT_B23,
     +     SHARE12,SHARE13,SHARE23,PSQ,LAMM

      COMMON/TENSOR/IB,SDP,SDM,T1,T2
      REAL*8 IB,SDP,SDM,T1,T2

      REAL PV_CLUMP(20)
      INTEGER NPV
*
*     FINAL STATE:
*
*     NR -> REACTION NUMBER, TB -> BEAM ENERGY, IP1,IP2,IP3 -> PARTICLE 
*     INDICES, X0,Y0,Z0 -> BEAM STOP, PX1,PY1,PZ1,T1 -> PARTICLE 1 MOMENTUM
*     AND KINETIC ENERGY, PX2,PY2,PZ2,T2 ...
*
*     ENERGY DEPOSITIONS:
*
*     DETG -> DEP. EN. TARGET, DETG -> DEP. EN. DEGRADER
*
*     P01 -> P10: PENTA, A01 -> A50: HEX-A, B01 -> B50: HEX-B
*     C01 -> C50: HEX-B, D01 -> D40: HEX-D, H01 -> H20: HEX-D/2
*     V01 -> V50: VETO, ECAL  
*     PV01 -> PV20, DEPV: PLASTIC VETO,
*
*     CVFR,CVBA,CVTO,CVSL,CVSR,ECOS -> COSMIC VETO
*     
*     MWX1,MWX2,MWY1,MWY2,MWZ1,MWZ2 -> MWPC HITS
*
*     TMTG -> TARGET TDC, TMDG -> DEGRADER TDC, ...
*
*     Sensitive detectors: CsI           1  ->240
*                          Plastic veto  241->260
*                          Target fibers 261->329
*                          Degrader      330
*                          Cosmic veto   331->335
*
*     Random number generator seeds:     338->339
*
      CALL VZERO(XNTP101,L101)

      IF((WT*SQME).LE.0.) RETURN

      XNTP101(1)=NR
      XNTP101(2)=TINC(1)
      XNTP101(3)=IPARTICLE(1)
      XNTP101(4)=IPARTICLE(2)
      XNTP101(5)=IPARTICLE(3)
      XNTP101(6)=VERTEX(1)
      XNTP101(7)=VERTEX(2)
      XNTP101(8)=VERTEX(3)
      XNTP101(9) =PART(1,1,NR)
      XNTP101(10)=PART(2,1,NR)
      XNTP101(11)=PART(3,1,NR)
      XNTP101(12)=PART(4,1,NR)
      XNTP101(13)=PART(1,2,NR)
      XNTP101(14)=PART(2,2,NR)
      XNTP101(15)=PART(3,2,NR)
      XNTP101(16)=PART(4,2,NR)
      XNTP101(17)=PART(1,3,NR)
      XNTP101(18)=PART(2,3,NR)
      XNTP101(19)=PART(3,3,NR)
      XNTP101(20)=PART(4,3,NR)
      
      XNTP101(298)=1.E6 ! set TDC overflow
      DO I=1,9 ! Sum of 9 target fibers
        L=I+260
        M=I+269
        XNTP101(21)=XNTP101(21)+EDEP(L) 
c nine target fibers ****************************
        IF(I.LE.9) XNTP101(M)=EDEP(L)
        IF (ITDEP(L).GT.0) 
     +     XNTP101(298)=MIN(TDEP(L),XNTP101(298))
      ENDDO
c pion stop smearing
      XNTP101(21)=XNTP101(21)+HRNDM1(600010) 
      
      IF (IGTGT.EQ.1) XNTP101(21)=EDEP(261)
      XNTP101(43)=0.0

      XNTP101(22)=EDEP(330)

      NPV=0
      XNTP101(300)=1.E6 ! set TDC overflow
      DO I=1,20 ! 20 individual PLASTIC VETO STAVES
       J=I+22
       L=I+240
       IF(EDEP(L).GT.0.04) NPV=NPV+1
       XNTP101(J)=EDEP(L)
       XNTP101(43)=XNTP101(43)+EDEP(L) ! Plastic veto energy
        IF (ITDEP(L).GT.0)             ! Plastic veto timing
     +    XNTP101(300)=MIN(TDEP(L),XNTP101(300))
      ENDDO

      IF (NMWPC1.GE.1) THEN
        XNTP101(44)=WPC1(1,1)
        XNTP101(46)=WPC1(2,1)
        XNTP101(48)=WPC1(3,1)
      ELSE
        XNTP101(44)=1.E9
        XNTP101(46)=1.E9
        XNTP101(48)=1.E9
      ENDIF
      IF (NMWPC2.GE.1) THEN
        XNTP101(45)=WPC2(1,1)
        XNTP101(47)=WPC2(2,1)
        XNTP101(49)=WPC2(3,1)
      ELSE
        XNTP101(45)=1.E9
        XNTP101(47)=1.E9
        XNTP101(49)=1.E9
      ENDIF

      IF(ISWIT(4).EQ.1) write(99,66) (EDEP(i), i=1,240)
 66   FORMAT(6F10.2)
      ECSIMAX=0.
      XNTP101(302)=1.E6 ! set TDC overflow
       DO I=1,220 ! 220 individual CsI modules
       J=I+49
       XNTP101(J)=EDEP(I)
       XNTP101(290)=XNTP101(290)+EDEP(I) ! CsI energy sum
       IF (ITDEP(I).GT.0)                ! CsI timing
     +     XNTP101(302)=MIN(TDEP(I),XNTP101(302))
       IF(EDEP(I).GT.ECSIMAX) XNTP101(340)=I
       ECSIMAX=MAX(EDEP(I),ECSIMAX) 
      ENDDO

      XNTP101(303)=1.E6 ! set TDC overflow
      DO I=221,240 ! 20 individual CsI veto modules
c 9 target modules = V01->V09
       J=I+49
       IF(J.GE.280) XNTP101(J)=EDEP(I)
c B0 Counter =V10
       IF(NR.EQ.4) XNTP101(279)=EDEP(500)    
       XNTP101(291)=XNTP101(291)+EDEP(I) ! CsI veto energy sum
       IF (ITDEP(I).GT.0)                ! CsI veto timing
     +     XNTP101(303)=MIN(TDEP(I),XNTP101(303))
       IF(EDEP(I).GT.ECSIMAX) XNTP101(340)=I
       ECSIMAX=MAX(EDEP(I),ECSIMAX) 
      ENDDO

      XNTP101(292)=EDEP(331)
      XNTP101(293)=EDEP(332)
      XNTP101(294)=EDEP(333)
      XNTP101(295)=EDEP(334)
      XNTP101(296)=EDEP(335)
 
      XNTP101(304)=1.E6 ! set TDC overflow
      DO I=1,5
        L=I+330
        XNTP101(297)=XNTP101(297)+EDEP(L)     ! cosmic veto energy
        IF (ITDEP(L).GT.0)                    ! cosmic veto timing
     +     XNTP101(304)=MIN(TDEP(L),XNTP101(304))
      ENDDO

      XNTP101(305)=WT       ! phase space weight
      XNTP101(306)=SQME     ! matrix element, normalization <WT*SQME=1.>

      IF (NR.EQ.6.OR.NR.EQ.8.OR.NR.EQ.11.OR.NR.EQ.25) THEN  ! particles 1,2
          COSTHT=(PART(1,1,NR)*PART(1,2,NR)+
     +    PART(2,1,NR)*PART(2,2,NR)+PART(3,1,NR)*PART(3,2,NR))/
     +    (PART(5,1,NR)*PART(5,2,NR)) 
          IF (ABS(COSTHT).LE.1.) THEN
*yw4f ommit D and add anum
*             XNTP101(307)=ACOSD(COSTHT)
             XNTP101(307)=anum*ACOS(COSTHT)
*yw4f end
          ELSEIF (COSTHT.EQ.-1.) THEN
             XNTP101(307)=180.
          ELSEIF (COSTHT.EQ.1.) THEN
             XNTP101(307)=0.
          ENDIF
      ENDIF 

      XNTP101(308)=NFIREDL     ! Number of clusters fired, LOW
      XNTP101(309)=NSFIREDL    ! Number of superclusters fired, LOW
      XNTP101(310)=NFIREDH     ! Number of clusters fired, HIGH
      XNTP101(311)=NSFIREDH    ! Number of superclusters fired, HIGH      
      XNTP101(312)=THT12       ! calculated THT12
      XNTP101(313)=HTRIGGER(7) ! pi_enu trigger 
      XNTP101(314)=HTRIGGER(8) ! pi_enug trigger
      XNTP101(315)=HTRIGGER(11)! PIBETA trigger
C--   Probability of ONE event in ADC gate
      XNTP101(316)=EXP(-FBEAM*1.E-9*WADC)!*RBRANCH(NR)
      XNTP101(317)=NMWPC1     ! number of HITS in MWPC1
      XNTP101(318)=NMWPC2     ! number of HITS in MWPC2

C--   Distance between double HITS
      IF (NMWPC1.GE.2.AND.
     +   ((WPC1(1,1))**2+(WPC1(2,1))**2+(WPC1(3,1))**2).GT.0..AND.
     +   ((WPC1(1,2))**2+(WPC1(2,2))**2+(WPC1(3,2))**2).GT.0.)THEN
        COSTHT=(WPC1(1,1)*WPC1(1,2)+WPC1(2,1)*WPC1(2,2)+
     +         WPC1(3,1)*WPC1(3,2))/
     +  (SQRT((WPC1(1,1))**2+(WPC1(2,1))**2+(WPC1(3,1))**2)*
     +   SQRT((WPC1(1,2))**2+(WPC1(2,2))**2+(WPC1(3,2))**2))
        IF (ABS(COSTHT).LE.1.) THEN
*yw4f ommit D and add anum
*          XNTP101(319)=ACOSD(COSTHT)
          XNTP101(319)=anum*ACOS(COSTHT)
*yw4f end
        ELSEIF(COSTHT.LT.-1.) THEN
          XNTP101(319)=180.
        ELSEIF(COSTHT.GT.1.) THEN
          XNTP101(319)=0.
        ENDIF
      ELSE
        XNTP101(319)=1.E6
      ENDIF

      IF (NMWPC2.GE.2.AND.
     +   ((WPC2(1,1))**2+(WPC2(2,1))**2+(WPC2(3,1))**2).GT.0..AND.
     +   ((WPC2(1,2))**2+(WPC2(2,2))**2+(WPC2(3,2))**2).GT.0.)THEN
        COSTHT=(WPC2(1,1)*WPC2(1,2)+WPC2(2,1)*WPC2(2,2)+
     +         WPC2(3,1)*WPC2(3,2))/
     +  (SQRT((WPC2(1,1))**2+(WPC2(2,1))**2+(WPC2(3,1))**2)*
     +   SQRT((WPC2(1,2))**2+(WPC2(2,2))**2+(WPC2(3,2))**2))
        IF (ABS(COSTHT).LE.1.) THEN
*yw4f ommit D and add anum
*          XNTP101(320)=ACOSD(COSTHT)
          XNTP101(320)=anum*ACOS(COSTHT)
*yw4f end
        ELSEIF(COSTHT.LT.-1.) THEN
          XNTP101(320)=180.
        ELSEIF(COSTHT.GT.1.) THEN
          XNTP101(320)=0.
        ENDIF
      ELSE
        XNTP101(320)=1.E6
      ENDIF

C--   Target Ring
      XNTP101(321)=EDEP(266)+EDEP(267)+EDEP(268)+EDEP(269)

C--   PI0 Flag, Neutron Flag, Gamma Flag in Hadronic Interactions
      XNTP101(322)=PI0FLAG
      XNTP101(323)=NEUFLAG
      XNTP101(324)=GAMFLAG
      XNTP101(325)=EDEPCAL1
      XNTP101(326)=EDEPCAL2

C--   Reconstructed PI0 gamma energies (poor-man-version)
      XNTP101(327)=GA1D
      XNTP101(328)=GA2D
      XNTP101(329)=SQME1
      XNTP101(330)=SQME2
      XNTP101(331)=SQME3
      XNTP101(332)=THTC
      XNTP101(333)=LTRIGGER(7)
      XNTP101(334)=LTRIGGER(8)
      XNTP101(335)=LTRIGGER(11)
      XNTP101(336)=TDC1
      XNTP101(337)=TDC2      

C--   Save current random seed for this event
      XNTP101(338)=IACTSEED1
      XNTP101(339)=IACTSEED2

C--   Skip cosmics that miss PIBETA calorimeter
      IF (NR.EQ.1.AND.XNTP101(290).LT.0.1) RETURN

C--   NaI Calorimeter
      XNTP101(341)=EDEPNAI
      XNTP101(342)=EDEPNAV

      XNTP101(343)=1.E6 ! set NaI TDC overflow
      DO I=1,68 ! 
        L=I+400
        IF (ITDEP(L).GT.0)
     +     XNTP101(343)=MIN(TDEP(L),XNTP101(343))
      ENDDO

      XNTP101(344)=TDEP(400)
      
C--   OUTER NAI Sum
      IF (ISWIT(1).EQ.1997) THEN
        EDEP_OUTER=0.
        DO I=1,64
         IF (NO_1997NAI_G(I).GT.36)
     &     EDEP_OUTER=EDEP_OUTER+EDEP(I)
        ENDDO
        XNTP101(345)=EDEP_OUTER
      ELSE ! CSI OUTER
        EDEP_OUTER=0.
        EDEP_OUTER=EDEP(116)+EDEP(165)+EDEP(192)+EDEP(125)+
     +             EDEP (75)+EDEP(121)+EDEP(169)+EDEP(196)+
     +             EDEP(130)+EDEP (30)+EDEP (29)+EDEP (78)+
     +             EDEP(207)+EDEP(206)+EDEP(130)+EDEP(205)+
     +             EDEP(204)+EDEP (67)+EDEP (17)+EDEP (16)
C        XNTP101(345)=EDEP_OUTER
      ENDIF 

C Number of PVs Hit
      XNTP101(345)=NPV

      XNTP101(50)=EDEP_CL1
      XNTP101(51)=EDEP_CL2
      XNTP101(52)=EDEP_CL3

      XNTP101(53)=THT_B12
      XNTP101(54)=THT_B13
      XNTP101(55)=THT_B23

      XNTP101(56)=SHARE12
      XNTP101(57)=SHARE13
      XNTP101(58)=SHARE23

      XNTP101(59)=PSQ
      XNTP101(63)=LAMM

      XNTP101(64)=IB
      XNTP101(65)=SDP
      XNTP101(66)=SDM
      XNTP101(67)=T1
      XNTP101(68)=T2

      DO I=1,20
         J=240+I
         PV_CLUMP(I)=EDEP(J)
      ENDDO

      CALL SORT(20,PV_CLUMP)

      XNTP101(60)=PV_CLUMP(1)
      XNTP101(61)=PV_CLUMP(2)
      XNTP101(62)=PV_CLUMP(3)

C--   Fill Row-wise Ntp
      IF(IDEVT.LE.100000) CALL HFN(101,XNTP101)

      RETURN
      END   

      SUBROUTINE SORT(N,RA)
      DIMENSION RA(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
      END




