************************************************************************    
*
*       output.f
*
*       Write event information after each finished event
*
*       History
*       -------
*       16DEC91 KAA created
*       11OCT95 EF  updated
*
************************************************************************    
*
      SUBROUTINE UHINIT  
*   
************************************************************************    
*
*       Book user histograms
*
************************************************************************    
*   
      INCLUDE 'common.inc'

      COMMON/QUEST/IQUEST(100)
      INTEGER IQUEST,ISTAT
*
*-----------------------------------------------------------------------
*   
*     Book histograms, manually (not digitized by routine HITS)
*      
C--   Overide default maximum number of records (4000) 
C--   to 65000 records maximum allowed, 4096 words each

      IQUEST(10) = 65000
*
      IF (IFILE.GT.0) THEN
        CALL HROPEN(2,'PIBETA','geant.rz','NQ',4096,ISTAT)
        CALL HBSET ('BSIZE',4096,ISTAT)

*     NTP Reserved IDs: 100-199
*     Histogram Reserved IDs: 200-999

*     Book Ntples & HISTOGRAMS

        CALL HISTOS
        CALL HBOOK1(7001,'ECAL Histogram',1400,0.,140.,0.)
        CALL HBOOK1(7002,'ECAL Histo Evlt5MeV',1400,0.,140.,0.)
        CALL NTP100
*     NTP 101 is written in RW format
        IF (IFORMAT.EQ.1) CALL NTP101

*     NTP 150 is written in CW format
        IF (IFORMAT.EQ.2) then
         print *,idevt,'call ntuple',ncosv,edepcal
*         CALL NTP150
        endif

*     NTP 199 is for temporay use
*        IF (IFORMAT.EQ.3) CALL NTP199

      ENDIF
*
      END   
*
*=======================================================================
*
************************************************************************    
*
*       Fill histograms
*
************************************************************************    
*
      SUBROUTINE GUOUT  
*   
      IMPLICIT NONE
      INCLUDE 'common.inc'
      CHARACTER*2 CDE(99)
      DATA CDE/'01','02','03','04','05','06','07','08','09',
     +    '10','11','12','13','14','15','16','17','18','19',
     +    '20','21','22','23','24','25','26','27','28','29',
     +    '30','31','32','33','34','35','36','37','38','39',
     +    '40','41','42','43','44','45','46','47','48','49',
     +    '50','51','52','53','54','55','56','57','58','59',
     +    '60','61','62','63','64','65','66','67','68','69',
     +    '70','71','72','73','74','75','76','77','78','79',
     +    '80','81','82','83','84','85','86','87','88','89',
     +    '90','91','92','93','94','95','96','97','98','99'/
*
*-----------------------------------------------------------------------
*
      INTEGER NTBEAM,NTTARG,NUBUF
      REAL UBUF(10),TOFCR,ETYPE,EWEIGHT,MELEM_SQ
      REAL HITS(2,50)
      REAL HRNDM1
      REAL ERANDOM, TRANDOM
      INTEGER I,J,NUMVS(1),ITRACK(1,50),INUMBV(1,50),NHITS
      INTEGER N
      DATA NUMVS/0/
*
      real q_veto,q_calo
      REAL PED_SIG(1:240)
      DATA PED_SIG /1.74, 1.57, 2.61, 1.81, 1.47, 2.40, 2.23, 
     + 1.85, 1.78, 2.86, 
     + 2.96, 2.53, 2.47, 2.36, 2.24, 2.77, 2.55, 2.54, 2.82, 3.23, 
     + 2.84, 2.35, 2.47, 2.69, 2.43, 3.05, 2.41, 2.33, 2.63, 2.82, 
     + 2.28, 2.04, 2.25, 2.38, 2.37, 2.38, 2.46, 2.42, 3.01, 3.04, 
     + 2.70, 2.43, 2.07, 2.47, 2.18, 2.13, 2.47, 2.31, 2.83, 2.84, 
     + 2.45, 2.30, 2.14, 1.91, 2.00, 2.10, 1.84, 2.07, 2.66, 2.84, 
     + 2.89, 1.93, 2.30, 3.56, 2.59, 2.43, 2.22, 1.97, 3.40, 2.67, 
     + 3.04, 2.43, 2.64, 3.50, 2.40, 2.48, 2.20, 2.45, 2.99, 2.90, 
     + 2.74, 2.19, 2.01, 2.13, 2.40, 2.20, 2.02, 2.18, 2.71, 2.50, 
     + 2.59, 2.26, 2.16, 1.89, 2.13, 2.11, 2.35, 2.11, 2.67, 2.16, 
     + 2.43, 1.78, 2.09, 2.13, 1.54, 2.72, 2.36, 2.14, 2.39, 2.52, 
     + 3.35, 2.77, 2.69, 2.21, 2.04, 2.66, 2.24, 2.28, 3.51, 3.05, 
     + 2.83, 1.92, 2.21, 2.15, 1.92, 2.38, 2.07, 2.04, 2.98, 2.81, 
     + 2.50, 2.48, 2.34, 2.14, 2.59, 2.54, 2.07, 2.59, 2.83, 2.70, 
     + 2.77, 2.44, 2.18, 2.05, 1.94, 2.31, 2.35, 2.37, 2.69, 1.85, 
     + 2.55, 1.75, 2.05, 2.19, 2.31, 2.10, 2.04, 2.43, 2.99, 2.68, 
     + 3.02, 2.18, 2.21, 2.44, 2.31, 3.41, 2.55, 2.57, 2.98, 3.29, 
     + 2.91, 2.06, 1.97, 2.06, 2.22, 2.62, 2.60, 2.33, 3.01, 2.95, 
     + 2.59, 2.23, 2.50, 2.38, 2.28, 3.17, 2.58, 2.45, 2.79, 2.74, 
     + 2.55, 2.72, 2.36, 1.98, 2.34, 2.44, 2.56, 2.35, 2.54, 2.62, 
     + 2.86, 2.43, 2.01, 1.96, 2.10, 2.18, 1.95, 1.60, 2.21, 2.23, 
     + 2.64, 2.06, 2.15, 2.37, 1.94, 2.30, 2.21, 2.08, 2.06, 2.15, 
     + 2.89, 2.31, 1.84, 1.77, 2.95, 5.02, 2.19, 2.95, 2.25, 1.96, 
     + 2.38, 2.10, 3.18, 2.46, 1.92, 2.60, 2.61, 2.29, 2.37, 2.88/   

*-----------------------------------------------------------------------
*
*****************************
C-- Temporary addition (T.F.)
*****************************
C-- Apply cuts for radiative decay investigation
C-- cuts specified by: PLANAR 5

c      IF (IPLANAR.EQ.5) THEN
c       do i=1,220
c        Q_calo=Q_calo+edep(i)
c       enddo
c       do i=221,240
c        Q_veto=Q_veto+edep(i)
c       enddo
c       IF (EDEPCAL.LT.26.5.OR.q_veto.GT.q_calo) CALL GUkine
c      ENDIF
*****************************

C--   In case IGHAD Flag set -> skip aborted/non-hadronic events
      IF (IGHAD.EQ.1.AND.HADFLAG.EQ.0.AND.IEOTRI.EQ.1) GOTO 9999
c      IF (IGHAD.EQ.1.AND.
c     +  GAMFLAG.EQ.0.AND.PI0FLAG.EQ.0.AND.NEUFLAG.EQ.0) GOTO 9999
c       IF (IGHAD.EQ.1.AND.PI0FLAG.EQ.0) GOTO 9999

c      DO I=1,20
c        CALL GFHITS('PVET','PV'//CDE(I),
c     +  1,2,50,0,NUMVS,ITRACK,INUMBV,HITS,NHITS)
c      ENDDO

C--   Skip cosmics that miss calorimeter
      IF (NR.EQ.1.AND.EDEPCAL.LT.0.1) GOTO 9999

C--   Do photoelectron statictics for CsI modules

      DO I=1,240

C--    Keep track of CsI Averages
       G_CSI_G(I)=G_CSI_G(I)+EDEP(I)

C--    Scaling factor and 4.0 percent gains smearing for 240 CsI detectors 
C--    scale to data with 67.54 pienu peak 1.0812
       CALL RNORMX(RVEC,ILEN,RANLUX)
       EDEP(I)=1.000*(1.+0.023*RVEC(1))*EDEP(I)*ECSI*GAIN_CSI_G(I)
       
       IF(PHOTOELECTRON(1).GT.0.) THEN
        IF (EDEP(I).GT.0.2) THEN
 888     CALL RNORMX(RVEC,ILEN,RANLUX)
         IF(I.LE.200) THEN
          IF((1.+RVEC(1)/SQRT(PHOTOELECTRON(1)*EDEP(I))).LT.0.)goto 888
          EDEP(I)=EDEP(I)*
     +    (1.+RVEC(1)/SQRT(PHOTOELECTRON(1)*EDEP(I)))
         ELSE
          IF((1.+RVEC(1)/SQRT(PHOTOELECTRON(2)*EDEP(I))).LT.0.)goto 888
          EDEP(I)=EDEP(I)*
     +   (1.+RVEC(1)/SQRT(PHOTOELECTRON(2)*EDEP(I)))
         ENDIF
        ENDIF
       ELSE
        IF (EDEP(I).GT.0.2) THEN
 889      CALL RNORMX(RVEC,ILEN,RANLUX)
          IF((1.+RVEC(1)/SQRT(NP_CSI_G(I)*EDEP(I))).LT.0.)goto 889
c These photoelectron statistics are for 22 degrees Celcius. (penny)
          EDEP(I)=EDEP(I)*
     +    (1.+RVEC(1)/SQRT(0.97*NP_CSI_G(I)*EDEP(I)))
c     +    (1.+RVEC(1)/SQRT(1.0*NP_CSI_G(I)*EDEP(I)))
        ENDIF
       ENDIF
C--   comment: what if EDEP(I)<1.? EF 01/15/9
C--   Add Pedestal Noise
      IF(ISWIT(5).EQ.1) THEN
       CALL RNORMX(RVEC,ILEN,RANLUX) 
       EDEP(I)=EDEP(I)+PED_SIG(I)*RVEC(1)/25.
       IF(EDEP(I).LT.(PED_SIG(I)/25.)) EDEP(I) = 0.
      ENDIF
      ENDDO

c npe smearing of NaI
c        DO J=401,464
c          if (edep(j).gt.0) then
c 890             CALL RNORMX(RVEC,ILEN,RANLUX)
c           IF((1.+RVEC(1)/SQRT(ISWIT(3)*EDEP(J))).LT.0.)
c     +     goto 890
c           EDEP(J)=EDEP(J)*
c     +     (1.+RVEC(1)/SQRT(ISWIT(3)*EDEP(J)))
c          endif
c        ENDDO

c npe smearing of PV
        DO J=241,260
          if (edep(j).gt.0) then
 891       CALL RNORMX(RVEC,ILEN,RANLUX)
           IF((1.+RVEC(1)/SQRT(38.3*EDEP(J))).LT.0.)
     +     goto 891
           EDEP(J)=EDEP(J)*
     +     (1.+RVEC(1)/SQRT(38.3*EDEP(J)))
          endif
        ENDDO

c npe smearing of DEG
        DO J=330,330
          if (edep(j).gt.0) then
 892       CALL RNORMX(RVEC,ILEN,RANLUX)
           IF((1.+RVEC(1)/SQRT(269.*EDEP(J))).LT.0.)
     +     goto 892
           EDEP(J)=EDEP(J)*
     +     (1.+RVEC(1)/SQRT(269.*EDEP(J)))
          endif
        ENDDO

c npe smearing of TGT
        DO J=261,269
c account for high gains in the outer target segment, EF 2002/02/21
c          if (J.GE.266.and.J.LE.269) edep(j)=2.*edep(j)
          if (edep(j).gt.0.1) then
 893         CALL RNORMX(RVEC,ILEN,RANLUX)
           IF((1.+RVEC(1)/SQRT(850.*EDEP(J))).LT.0.)
     +     goto 893
           EDEP(J)=EDEP(J)*
     +     (1.+RVEC(1)/SQRT(500.*EDEP(J)))
          endif
        ENDDO

c npe smearing of B0
        IF(NR.EQ.4) THEN
          if (edep(500).gt.0) then
 896         CALL RNORMX(RVEC,ILEN,RANLUX)
           IF((1.+RVEC(1)/SQRT(102.*EDEP(500))).LT.0.)
     +     goto 896
           EDEP(500)=EDEP(500)*
     +     (1.+RVEC(1)/SQRT(102.*EDEP(500)))
          endif
        ENDIF

 152    FORMAT(I4,F7.2,I4)
 153    FORMAT(I4,F7.2,2x,f8.5)

c do pile-up
c      DO I=1,240
c        EDEP(I)=EDEP(I)+3.*HRNDM1(294005)
c        IF(EDEP(I).LT.0.5) EDEP(I)=0.001 ! clump threshold
c      ENDDO

      READ (38, *) N ! Number of CsI crystals hit in random event
      DO I=1,N
        READ(38,*) J,ERANDOM,TRANDOM  ! Index and the energy of crystal in random event
        J=J+1                         ! Offest between C (analyzer data) and FORTRAN (simulation)
        EDEP(J)=EDEP(J)+ERANDOM/1.0812
      ENDDO

C--   Do (super)clustering analysis
      CALL CLUSTER

C--   Simulate triggers
      CALL GEN_TRIG

C--   Do Clump Analysis
      CALL CLUMP

C--   Fill Ntples & Histograms
      IF (IFILE.GT.0) THEN
        IF (IFORMAT.EQ.1)CALL FILL101
        IF(XNTP101(290).LT.140.)
     +    CALL HFILL(7001,XNTP101(290),0.,WT*SQME)
        IF(XNTP101(290).LT.140..AND.XNTP101(291).LT.5.)
     +    CALL HFILL(7002,XNTP101(290),0.,WT*SQME)
        IF (IFORMAT.EQ.2) CALL FILL150
        IF (IFORMAT.EQ.3) CALL FILL199
        CALL FILLHISTOS
      ENDIF

*     Temporary test code --EF

c      IF(IDEVT.EQ.NEVENT) THEN
c         DO I=1,240
c         IF(CSIANG(I).GT.0.) THEN
c           CSITHT(I)=CSITHT(I)/CSIANG(I)
c           CSIPHI(I)=CSIPHI(I)/CSIANG(I)
c         ENDIF
c         IF(CSIPHI(I).LT.0.)CSIPHI(I)=360.+CSIPHI(I)
c         WRITE (99,*) I,CSIANG(I),CSITHT(I),CSIPHI(I)
c         enddo
c      ENDIF

 9999 CONTINUE

      END
*
*=======================================================================
*
*
      SUBROUTINE UGLAST 
      IMPLICIT NONE
      include 'common.inc'
      INTEGER I,ICYCLE
*   
*     102195 EF Added call to random coincidence generator
*   
************************************************************************    
*
*       Termination routine to print histograms and statistics
*
************************************************************************    
*   
*   
C--   Random coincidences 
      IF(ICOINCID.GE.2)CALL GEN_COINC

C--   Normalization
      CALL HOPERA(202,'/',201,202,1.,1.)  ! CsI CALO
      CALL HOPERA(203,'/',201,203,1.,1.)
      CALL HOPERA(205,'/',204,205,1.,1.)  ! PVETO
      CALL HOPERA(206,'/',204,206,1.,1.)
      CALL HOPERA(208,'/',207,208,1.,1.)  ! TGT
      CALL HOPERA(209,'/',207,209,1.,1.)

      CALL HOPERA(214,'/',218,218,1.,1.)  ! Accept vs THTT, normalized
      CALL HOPERA(215,'/',219,219,1.,1.)  ! Accept vs THT1, normalized

      CALL GLAST    

      IF (IFILE.GT.0) THEN
        CALL HROUT(0,ICYCLE,' ')
        CALL HREND('PIBETA')
      ENDIF

      CLOSE(20)
      CLOSE(2)
      CALL IGEND    
*   
      END   
*
*=======================================================================
*
      INCLUDE 'hbook/ntp100.f'
      INCLUDE 'hbook/ntp101.f'
      INCLUDE 'hbook/ntp150.f'
      INCLUDE 'hbook/ntp199.f'
      INCLUDE 'hbook/histos.f'
      INCLUDE 'electronics/clusters.f'
      INCLUDE 'electronics/clump.f'
      INCLUDE 'coincidences/gen_coinc.f'
      INCLUDE 'triggers/gen_trig.f'

