      PROGRAM GEN_MU_ENUNUG

*     30JUN00 EF
*      
*     ----------------------------------------------------------------- 
*
c      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG
      INTEGER ZEROFLAG
C      common/phase/x,y,c
      INCLUDE '../common.inc'
      REAL ELAB,X,Y,C,COSRA,RELANG
      INTEGER NVERT,NT,LRECL,ICYCLE,I,ISTAT
*       
*     ----------------------------------------------------------------- 
*
*     GENERATE MU+ -> E+ NU NU G
*     REFERENCES: ECKSTEIN AND PRATT, ANN. OF PHYS. 8, 297 (1959)   
*                 BEHRENDS, FINKELSTEIN AND SIRLIN, PHYS. REV. 101, 886 (1956)

      common /pawc/h(1000000)

      lrecl=1024
      call hlimit (1000000)
      call hropen(1,'rmichel','rmichel.rz','n',lrecl,istat)

      call hbook1 (100000,'costh',220,-1.1,1.1,0.)
      call hbook1 (100001,'y=2Eg/MMU',120,-0.1,1.1,0.)

      call hbook2 (300000,'x vs y',110,0.,1.1,110,0.,1.1,0.)

      call hbook2 (900001,'f2/f1 vs xy',16,0.2,1.0,20,0.2,1.2,0.)
      call hbook2 (900002,'f2/f1 vs xy',8,0.2,1.0,10,0.2,1.2,0.)
      call hbook2 (900003,'f2/f1 vs xy',8,0.2,1.0,10,0.2,1.2,0.)

      call hbook2 (910001,'f3/f1 vs xy',16,0.2,1.0,20,0.2,1.2,0.)
      call hbook2 (910002,'f3/f1 vs xy',8,0.2,1.0,10,0.2,1.2,0.)
      call hbook2 (910003,'f3/f1 vs xy',8,0.2,1.0,10,0.2,1.2,0.)

      NR=14

      NP=4
      TECM=0.10567
      MMU=0.10566
      KGENEV=1
      AMASS(1)=0.000511
      AMASS(2)=0.0
      AMASS(3)=0.0
      AMASS(4)=0.0
     
      DO I=1,10000000

c      write(99,*) i

 1111 CALL GENBOD

      IF(ABS(PCM(1,1)).LT.1.E-10.OR.ABS(PCM(2,1)).LT.1.E-10.OR.
     .   ABS(PCM(3,1)).LT.1.E-10.OR.
     .   ABS(PCM(1,4)).LT.1.E-10.OR.ABS(PCM(2,4)).LT.1.E-10.OR.
     .   ABS(PCM(3,4)).LT.1.E-10) GOTO 1111

      COSRA=(PCM(1,1)*PCM(1,4)+PCM(2,1)*PCM(2,4)+
     +  PCM(3,1)*PCM(3,4))/(SQRT(PCM(1,1)**2+PCM(2,1)**2+PCM(3,1)**2)*
     +                     SQRT(PCM(1,4)**2+PCM(2,4)**2+PCM(3,4)**2))
      IF(ABS(COSRA).LE.1.) THEN
        RELANG=ACOSD(COSRA)
      ELSEIF(COSRA.GT.1.) THEN
        RELANG=0.
      ELSEIF(COSRA.LT.-1.) THEN
        RELANG=180.
      ENDIF

      X=2.*PCM(4,1)/0.105658389
      Y=2.*PCM(4,4)/0.105658389
      C=COSRA

C ACCOUNT FOR TRUNCATION/ROUNDING ERRORS

      IF(X.GE.1.) X=0.9999999
      IF(Y.GE.1.) Y=0.9999999
      
c      IF(X.LT.0.4.OR.Y.LT.0.4.OR.RELANG.LT.179.) GOTO 9999
      
c      x=0.8
c      y=0.4
c      c=-0.70710678

*     MATRIX ELEMENT SQUARED
      CALL MATRIX_MU_ENUNUG
C      IF (ZEROFLAG.EQ.1) GOTO 1111

c      print *,x,y,relang,sqme1,sqme2,sqme3

c      if(sqme.lt.0.) print *, i,x,y,relang,sqme
c      IF(SQME.LT.0.) SQME=0.

      CALL HFILL(100000,cosra,0.,1.)
      CALL HFILL(100001,y,0.,sqme1)

      CALL HFILL(300000,X,Y,1.)

c      if(x.gt.0.9.and.y.gt.0.5.and.relang.gt.179) write(6,*) sqme2/sqme1

      R21=SQME2/SQME1
      IF(RELANG.GT.30.) CALL HFILL(900001,X,Y,R21)  ! finner binning
      IF(RELANG.GT.30.) CALL HFILL(900002,X,Y,R21)  ! weights
      IF(RELANG.GT.30.) CALL HFILL(900003,X,Y,1.)   ! number of events

      R31=SQME3/SQME1
      IF(RELANG.GT.30.) CALL HFILL(910001,X,Y,R31)  ! finner binning
      IF(RELANG.GT.30.) CALL HFILL(910002,X,Y,R31)  ! weights
      IF(RELANG.GT.30.) CALL HFILL(910003,X,Y,1.)   ! number of events

 9999 CONTINUE

      ENDDO

      call hopera(900002,'/',900003,900002,1.,1.)
      call hopera(910002,'/',910003,910002,1.,1.)

      call hrout(0,icycle,' ')
      call hrend('rmichel')

      STOP
      END   

      SUBROUTINE MATRIX_MU_ENUNUG

      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG
      INTEGER ZEROFLAG
C      common/phase/x,y,c
      INCLUDE '../common.inc'

      REAL EB,RHO,M_MU,M_E,GMUENU,x1,x2,y1,y2,c1,c2
      REAL RDAL,E_E,P_E,B,DEL,GM1,G0,G1,G2,NV,F1V,F2V,F3V,RM
      REAL PI,AL
      REAL X,Y,C,CMIN
      REAL COSRA,RELANG

      REAL N_SVT1,N_SVT2

      X=2.*PCM(4,1)/0.10566
      Y=2.*PCM(4,4)/0.10566

      COSRA=(PCM(1,1)*PCM(1,4)+PCM(2,1)*PCM(2,4)+
     +  PCM(3,1)*PCM(3,4))/(SQRT(PCM(1,1)**2+PCM(2,1)**2+PCM(3,1)**2)*
     +                     SQRT(PCM(1,4)**2+PCM(2,4)**2+PCM(3,4)**2))
      IF(ABS(COSRA).LE.1.) THEN
        RELANG=ACOSD(COSRA)
      ELSEIF(COSRA.GT.1.) THEN
        RELANG=0.
      ELSEIF(COSRA.LT.-1.) THEN
        RELANG=180.
      ENDIF

      C=COSRA

      EB=0.
      RHO=3./4.

c muon and electron mass in MeV
      M_MU=0.105658389
      M_E=0.000510999

      AL=1./137.036
      PI=3.1415927

c totla branching ratio
      GMUENU=1.0

c integration limits, x=2E_E/M_MU, y=2E_G/M_MU
c minimum x=2*M_E/M_MU, minimum y=0

c R_Dalitz function
      RDAL=((2.*AL)/(3.*PI))*
     .     ( log( ((y*M_MU)/(2.*M_E)) )-(19./12.) ) 

      E_E=M_MU*x/2.
      P_E=SQRT((E_E**2)-(M_E**2))
      B=P_E/E_E
      DEL=1.-B*C

c G-functions
      GM1=8.*((y**2)*(3.-2.*y)+6.*x*y*(1.-y)
     .        +2.*(x**2)*(3.-4.*y)-4.*(x**3))
      G0=8.*((-1.)*x*y*(3.-y-(y**2))-(x**2)*(3.-y-4.*(y**2))
     .        +2.*(x**3)*(1.+2.*y))
      G1=2.*((x**2)*y*(6.-5.*y-2.*(y**2))-2.*(x**3)*y*(4.+3.*y))
      G2=2.*(x**3)*(y**2)*(2.+y)

      NV=4.*(1-(B**2))*( 2.*(DEL**(-2))*x*(x+y)*(2.*(x+y)-3.)
     . +(DEL**(-1))*(x**2)*y*(3.-4.*(x+y))+(x**3)*(y**2) )
     . +(DEL**(-1))*GM1+G0+DEL*G1+(DEL**2)*G2

      N_SVT1=-8.*x*(y**2)*( (DEL**(-1))*x*(1.-(B**2))
     . +2.*(1.-y-2.*x)+DEL*x*(1.+y) )

      N_SVT2=4.*( (DEL**(-1))*2.* ( (y**2)*(3.-4.*y)
     . +6.*x*y*(1.-2.*y)+2.*(x**2)*(3.-8.*y)-8.*(x**3) )
     . +2.*x*( (-1.)*y*(3.-y-6.*(y**2))-x*(3.-5.*y-10.*(y**2))
     . +4.*(x**2)*(1.+2.*y) )
     . +DEL*(x**2)*y*( 1.5*(2.-3.*y-4.*(y**2))-2.*x*(4.+3.*y) )
     . +(DEL**2)*(x**3)*(y**2)*(2.+y)
     . -(1.-(B**2))*( (DEL**(-2))*2.*x*(x+y)*(3.-4.*(x+y))
     . +(DEL**(-1))*(x**2)*y*(2.*(4.*x+5.*y)-3.)-2.*(x**3)*
     . (y**2) ) )

c      IF(RDAL.LT.0.) RDAL=0.

c f-functions
      F1V=(AL/(16.*(PI**2)*y))*(1.-RDAL)*NV

      F2V=(AL/(16.*(PI**2)*y))*(1.-RDAL)*N_SVT1
      F3V=(AL/(16.*(PI**2)*y))*(1.-RDAL)*N_SVT2

c radiative Michel decay probability
      RM=(F1V+EB*F2V+(1.-4.*RHO/3)*F3V)
      RM=RM*2.*PI

      SQME1=F1V
      SQME2=F2V
      SQME3=F3V

      RETURN
      END

      INCLUDE '../generators/genbod.f'



