************************************************************************    
*
*       init.f
*
*       Geant initialization, read data cards, book histograms
*
*       History
*       -------
*       16DEC91 KAA created
*       13JUN95 KAA enlarged
*       4AUG95  SR  Added parameter data cards in /GPARAM/
*                   Added variable seed for random generator
*       04OCT95 EF  Put in data cards for new event generators
*                   
************************************************************************    
*
      SUBROUTINE UGINIT 
*   
************************************************************************    
*
*       Initialize Geant, read data cards
*
************************************************************************    
*   
      IMPLICIT NONE
      INCLUDE 'common.inc'
      COMMON/HADR_PAR/IGHEISHA
      INTEGER IGHEISHA
*   
*-----------------------------------------------------------------------
*   
*             Initialize GEANT  
*   
      CALL GINIT    
*
*             Prints version number 
*
      PRINT *, '**** PIBETA Geant Version ',VERSION,' ****'  
*   
*             Read data cards with FFREAD   
*
      PRINT *, '=================================================='
      PRINT *, 'Type in the data cards now, finish with ''STOP'''
      PRINT *, 'Read in ''geant.inp'' with ''READ 4''.'
      PRINT *, ' '
*
*             Open data card file
*
      OPEN(4,FILE='geant.inp',STATUS='UNKNOWN')
      OPEN(66,FILE=
     + '/fs26/users/pocanic/nheavns/input_phase_space.dat',
     + STATUS='OLD')
*
*             Define user keys
*
*             Hadronic interaction only
*
      CALL FFKEY('IGHAD',   IGHAD,  1, 'INTEGER')

*     Photonuclear reaction switch, GEISHA/FLUKA switch

      CALL FFKEY('IPHNUCL', IPHOTONUCLEAR, 1, 'INTEGER')
      CALL FFKEY('GHEISHA', IGHEISHA,      1, 'INTEGER')
*
*             Ouput format
*
      CALL FFKEY('FILE',    IFILE,   1, 'INTEGER')
      CALL FFKEY('FORMAT',  IFORMAT, 1, 'INTEGER')
*
*             Luxary RANDOM Number Generator Parameters
*
      CALL FFKEY('RLENGTH', ILEN,   1, 'INTEGER')
      CALL FFKEY('RLUXARY', ILUX,   1, 'INTEGER')
      CALL FFKEY('RSTART' , ISTART, 1, 'INTEGER')
      CALL FFKEY('SEQ',     ISEQ,   1, 'INTEGER')
      CALL FFKEY('SED1',    ISEED1, 1, 'INTEGER')
      CALL FFKEY('SED2',    ISEED2, 1, 'INTEGER')
*
*             Geometry flags
*
      CALL FFKEY('GDEGR',   IGDEGR,  1, 'INTEGER')
      CALL FFKEY('GTGT',    IGTGT,   1, 'INTEGER')
      CALL FFKEY('GMWPC',   IGMWPC,  1, 'INTEGER')
      CALL FFKEY('GCALO',   IGCALO,  1, 'INTEGER')
      CALL FFKEY('GCOSM',   IGCOSM,  1, 'INTEGER')
      CALL FFKEY('GPMT',    IPMT,    1, 'INTEGER')
      CALL FFKEY('GKUGEL',  KUGEL,   1, 'INTEGER')

      CALL FFKEY('RCALO',  RCALO, 1, 'REAL')   ! CALO Radius scaling
*
*             Event generator parameter
*
      CALL FFKEY('COSMIC',  WCOSMIC,        2, 'REAL')
      CALL FFKEY('GAMMA',   WGAMMA,         2, 'REAL')
      CALL FFKEY('POSITRON',WPOSITRON,      2, 'REAL')
      CALL FFKEY('PISTOP',  WPISTOP,        2, 'REAL')
      CALL FFKEY('PIMUNU',  WPI_MUNU,       2, 'REAL')
      CALL FFKEY('PIGMUNU', WPI_MUNUG,      2, 'REAL')
      CALL FFKEY('PIENU',   WPI_ENU,        2, 'REAL')
      CALL FFKEY('PIEGNU',  WPI_ENUG,       2, 'REAL')
      CALL FFKEY('PI3ENU',  WPI_3ENU,       2, 'REAL')
      CALL FFKEY('PIE3NU',  WPI_E3NU,       2, 'REAL')
      CALL FFKEY('PIBETA',  WPIBETA,        2, 'REAL')
      CALL FFKEY('PI2EMUNU',WPI_MU2ENU,     2, 'REAL')
      CALL FFKEY('MICHEL',  WMICHEL,        2, 'REAL')
      CALL FFKEY('MUG2NUE', WMU_E2NUG,      2, 'REAL')
      CALL FFKEY('MU2NU3E', WMU_3E2NU,      2, 'REAL')
      CALL FFKEY('MU3E',    WMU_3E,         2, 'REAL')
      CALL FFKEY('MUGE',    WMU_GE,         2, 'REAL')
      CALL FFKEY('MUE2G',   WMU_E2G,        2, 'REAL')
      CALL FFKEY('MUEGG',   WMUE_GG,        2, 'REAL')
      CALL FFKEY('NG',      WPIMP_NG,       2, 'REAL')
      CALL FFKEY('NGG',     WPIMP_NGG,      2, 'REAL')
      CALL FFKEY('PIZN',    WPIMP_PI0N,     2, 'REAL')
      CALL FFKEY('PZP',     WPIPP_PIPPI0P,  2, 'REAL')
      CALL FFKEY('PPN',     WPIPP_PIPPIPN,  2, 'REAL')
      CALL FFKEY('ZZN',     WPIMP_PI0PI0N,  2, 'REAL')
      CALL FFKEY('MZP',     WPIMP_PIMPI0P,  2, 'REAL')
      CALL FFKEY('MPN',     WPIMP_PIMPIPN,  2, 'REAL')

      CALL FFKEY('PLANAR',    IPLANAR,   1, 'INTEGER')
      CALL FFKEY('TGAMMA',    EGAMMA,    2, 'REAL')
      CALL FFKEY('TPOSITRON', EPOSITRON, 2, 'REAL')
      CALL FFKEY('TPION',     TINC,      2, 'REAL')
      CALL FFKEY('ZXCOSMIC',  ZXCOSMIC,  2, 'REAL')
*
*              Event GENERATOR Parameters
*
      CALL FFKEY('HISTO', IHISTO,   1, 'INTEGER')
      CALL FFKEY('MATRIX',IMATRIX, 30, 'INTEGER')
      CALL FFKEY('HCALL', IHCALL,  30, 'INTEGER')
*
*              Beam Parameters PINC,DPINC,DX,DY,DZ,DPX,DPY,DPZ
*
      CALL FFKEY('PBEAM',  BEAM,    8, 'REAL')
      CALL FFKEY('ZBEAM',  ZBEAM,   1, 'REAL')
      CALL FFKEY('DBEAM',  DIVBEAM, 2, 'REAL')
      CALL FFKEY('CBEAM',  CONBEAM, 2, 'REAL')
      CALL FFKEY('FBEAM',  FBEAM,   1, 'REAL')
*
*     CsI crystal and electronics temperature coefficients
*
      CALL FFKEY('CTEMP',  CTEMP,   2, 'REAL')
*
*     Axial and transverse oprical uniformity, number of photoelectrons/MeV
*
      CALL FFKEY('UNIFORMITY',     UNIFORMITY,   2, 'REAL')
      CALL FFKEY('NPHOTOEL',    PHOTOELECTRON,   2, 'REAL')

*              TDC, lower and upper level threshold in MeV

      CALL FFKEY('THRESHOLD',THRESHOLD,3, 'REAL')
*
*              ADC width in ns

      CALL FFKEY('WADC',WADC,1, 'REAL')
*
*     Method of energy averaging in CsI calorimeter
*
      CALL FFKEY('EMETHOD', METHOD, 1, 'INTEGER')
*
*     MWPC Efficiencies
*
      CALL FFKEY('EMWPC', EMWPC, 2, 'REAL')
*
*     Switches to activate different code
*
*     VADCTDC: Version of ADC/TDC simulation
*
      CALL FFKEY('VADCTDC', IADCTDC, 1, 'INTEGER')
*
*     COINCIDENCES: Enables/Disables Coincidence Code 1/0
*
      CALL FFKEY('COINCIDENCES', ICOINCID, 1, 'INTEGER')

*
*             Read data cards
*
      CALL GFFGO
*
      IF (IGHEISHA.EQ.1) THEN
        PRINT *, '**** GHEISHA HADRONIC PACKAGE ****'  
        PRINT *, ' '
      ELSEIF (IGHEISHA.EQ.2) THEN
        PRINT *, '**** FLUKA HADRONIC PACKAGE ****'  
        PRINT *, ' '
      ELSE
        PRINT *, '**** NO HADRONIC PACKAGE DEFINED ****'  
        PRINT *, ' '
        PAUSE
      ENDIF
*             Set seeds for number generator if requested
*
      IF(ISEED1.EQ.0) THEN
        CALL GRNDMQ(IACTSEED1,IACTSEED2,ISEQ,'Q')
        CALL GRNDMQ(IACTSEED1,IACTSEED2,ISEQ,'S')
      ELSE
        CALL GRNDMQ(ISEED1,ISEED2,ISEQ,'S')
      ENDIF
*
*             Set seeds for LUXARY number generator
*
      CALL RLUXGO(ILUX,ISTART,0,0)

*   
*             Initialize GEANT/ZEBRA data structures    
*   
      CALL GZINIT   
*   
*             Initialize graphics package   
*
      IF(INTER.GT.0) THEN  
        CALL GDINIT
      ENDIF   
*
*             Geometry and materials description.   
*   
      CALL GEPIBETA
*   
*             Particle table definition and energy loss initialization. 
*   
      CALL GPART    
      CALL GPHYSI   
*
*             Book histograms and Ntples
*
      CALL UHINIT    

      END   
