************************************************************************    
*
       SUBROUTINE NTP100
*
*      Write User DATA cards into Ntple 100
*
*      History
*      -------
*      101095 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE 'common.inc'
      COMMON/HADR_PAR/IGHEISHA
      INTEGER I,IGHEISHA
*
      DATA TAG100/'W COSMIC','W GAMMA',   'W POSITRON','W PISTOP',    
     +          'W PIMUNU',  'W PIGMUNU', 'W PIENU',   'W PIEGNU',  
     +          'W PI3ENU',  'W PIE3NU',  'W PIBETA',  'W PI2EMUNU',
     +          'W MICHEL',  'W MUGE2NUE','W MU2NU3E', 'W MU3E',    
     +          'W MUGE',    'W MUE2G',   'W MUEGG',   'W NG',      
     +          'W NGG',     'W PIZN',    'W PZP',     'W PPN',     
     +          'W ZZN',     'W MZP',     'W MPN',     
     +          'P COSMIC',  'P GAMMA',   'P POSITRON','P PISTOP',    
     +          'P PIMUNU',  'P PIGMUNU', 'P PIENU',   'P PIEGNU',  
     +          'P PI3ENU',  'P PIE3NU',  'P PIBETA',  'P PI2EMUNU',
     +          'P MICHEL',  'P MUGE2NUE','P MU2NU3E', 'P MU3E',    
     +          'P MUGE',    'P MUE2G',   'P MUEGG',   'P NG',      
     +          'P NGG',     'P PIZN',    'P PZP',     'P PPN',     
     +          'P ZZN',     'P MZP',     'P MPN',     
     +          'TGAMMA', 'DTGAMMA','TPOSITR','DTPOSITR',
     +          'TINC',   'DTINC',  'DZCOSMIC', 'DXCOSMIC',
     +          'RLENGTH','RLUXARY','RSTART','HISTO','PINC','DPINC',
     +          'DX0','DY0','DZ0','DPX0','DPY0','DPZ0',
     +          'ZBEAM','DBX','DBY','CMUON','CPOSITRON','FBEAM',
     +          'CTEMP1','CTEMP2',
     +          'TRIG','HADR','COMP','PAIR','BREM','ANNI','DCAY',
     +          'DRAY','LOSS','PHOT','CUTGAM','MULS',
     +          'NONH','PHNU','GHEI','IPMT','KUGE','RCAL','AUNI',
     +          'TUNI','NPHO','WADC','EMTH','EMW1','EMW2','IADC',
     +          'ICOI','THR1','THR2','THR3'/
*      
C--   Row-wise Ntple Definition
      CALL HBOOKN(100,'USER CARDS',L100,'PIBETA',2000,TAG100)

      XNTP100(1)=WCOSMIC(1)
      XNTP100(2)=WGAMMA(1)
      XNTP100(3)=WPOSITRON(1)
      XNTP100(4)=WPISTOP(1)
      XNTP100(5)=WPI_MUNU(1)
      XNTP100(6)=WPI_MUNUG(1)
      XNTP100(7)=WPI_ENU(1)
      XNTP100(8)=WPI_ENUG(1)
      XNTP100(9)=WPI_3ENU(1)
      XNTP100(10)=WPI_E3NU(1)
      XNTP100(11)=WPIBETA(1)
      XNTP100(12)=WPI_MU2ENU(1)
      XNTP100(13)=WMICHEL(1)
      XNTP100(14)=WMU_E2NUG(1)
      XNTP100(15)=WMU_3E2NU(1)
      XNTP100(16)=WMU_3E(1)
      XNTP100(17)=WMU_GE(1)
      XNTP100(18)=WMU_E2G(1)
      XNTP100(19)=WMUE_GG(1)
      XNTP100(20)=WPIMP_NG(1)
      XNTP100(21)=WPIMP_NGG(1)
      XNTP100(22)=WPIMP_PI0N(1)
      XNTP100(23)=WPIPP_PIPPI0P(1)
      XNTP100(24)=WPIPP_PIPPIPN(1)
      XNTP100(25)=WPIMP_PI0PI0N(1)
      XNTP100(26)=WPIMP_PIMPI0P(1)
      XNTP100(27)=WPIMP_PIMPIPN(1)

C--   Store branching ratio in RBRANCH array      
      DO I=1,27
        RBRANCH(I)=XNTP100(I)
      ENDDO

      XNTP100(28)=WCOSMIC(2)
      XNTP100(29)=WGAMMA(2)
      XNTP100(30)=WPOSITRON(2)
      XNTP100(31)=WPISTOP(2)
      XNTP100(32)=WPI_MUNU(2)
      XNTP100(33)=WPI_MUNUG(2)
      XNTP100(34)=WPI_ENU(2)
      XNTP100(35)=WPI_ENUG(2)
      XNTP100(36)=WPI_3ENU(2)
      XNTP100(37)=WPI_E3NU(2)
      XNTP100(38)=WPIBETA(2)
      XNTP100(39)=WPI_MU2ENU(2)
      XNTP100(40)=WMICHEL(2)
      XNTP100(41)=WMU_E2NUG(2)
      XNTP100(42)=WMU_3E2NU(2)
      XNTP100(43)=WMU_3E(2)
      XNTP100(44)=WMU_GE(2)
      XNTP100(45)=WMU_E2G(2)
      XNTP100(46)=WMUE_GG(2)
      XNTP100(47)=WPIMP_NG(2)
      XNTP100(48)=WPIMP_NGG(2)
      XNTP100(49)=WPIMP_PI0N(2)
      XNTP100(50)=WPIPP_PIPPI0P(2)
      XNTP100(51)=WPIPP_PIPPIPN(2)
      XNTP100(52)=WPIMP_PI0PI0N(2)
      XNTP100(53)=WPIMP_PIMPI0P(2)
      XNTP100(54)=WPIMP_PIMPIPN(2)

      XNTP100(55)=EGAMMA(1)
      XNTP100(56)=EGAMMA(2)
      XNTP100(57)=EPOSITRON(1)
      XNTP100(58)=EPOSITRON(2)
      XNTP100(59)=TINC(1)
      XNTP100(60)=TINC(2)
      XNTP100(61)=ZXCOSMIC(1)
      XNTP100(62)=ZXCOSMIC(2)
      XNTP100(63)=ILEN
      XNTP100(64)=ILUX
      XNTP100(65)=ISTART
      XNTP100(66)=IHISTO
      XNTP100(67)=BEAM(1)
      XNTP100(68)=BEAM(2)
      XNTP100(69)=BEAM(3)
      XNTP100(70)=BEAM(4)
      XNTP100(71)=BEAM(5)
      XNTP100(72)=BEAM(6)
      XNTP100(73)=BEAM(7)
      XNTP100(74)=BEAM(8)
      XNTP100(75)=ZBEAM
      XNTP100(76)=DIVBEAM(1)
      XNTP100(77)=DIVBEAM(2)
      XNTP100(78)=CONBEAM(1)
      XNTP100(79)=CONBEAM(2)
      XNTP100(80)=FBEAM
      XNTP100(81)=CTEMP(1)
      XNTP100(82)=CTEMP(2)

      XNTP100(83)=NEVENT
      XNTP100(84)=IHADR
      XNTP100(85)=ICOMP
      XNTP100(86)=IPAIR
      XNTP100(87)=IBREM
      XNTP100(88)=IANNI
      XNTP100(89)=IDCAY
      XNTP100(90)=IDRAY
      XNTP100(91)=ILOSS
      XNTP100(92)=IPHOT
      XNTP100(93)=PCUTGA
      XNTP100(94)=IMULS

      XNTP100(95)=IGHAD
      XNTP100(96)=IPHOTONUCLEAR
      XNTP100(97)=IGHEISHA
      XNTP100(98)=IPMT
      XNTP100(99)=KUGEL
      XNTP100(100)=RCALO
      XNTP100(101)=UNIFORMITY(1)
      XNTP100(102)=UNIFORMITY(2)
      XNTP100(103)=PHOTOELECTRON(1)
      XNTP100(104)=WADC
      XNTP100(105)=METHOD
      XNTP100(106)=EMWPC(1)
      XNTP100(107)=EMWPC(2)
      XNTP100(108)=IADCTDC
      XNTP100(109)=ICOINCID      
      XNTP100(110)=THRESHOLD(1)
      XNTP100(111)=THRESHOLD(2)
      XNTP100(112)=THRESHOLD(3)

C--   Fill Row-wise Ntp
      CALL HFN(100,XNTP100)      

      RETURN
      END   
