************************************************************************    
*
       SUBROUTINE NTP101
*
*      History
*      -------
*
*      101195 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE 'common.inc'

      DATA TAG101/'THTC','EDEP1','EDEP2','EMIN','EV','ES1',
     +            'EG1','EG2','THT','ES2'/
*      
C--   Row-wise Ntple Definition
      CALL HBOOKN(101,'PIBETA DETECTOR, True Single Events',
     +              L101,'PIBETA',20000,TAG101)

      RETURN
      END   

************************************************************************    
*
       SUBROUTINE FILL101
*
*      History
*      -------
*
*      111095 EF created
*
************************************************************************    
*
      IMPLICIT NONE

      INCLUDE 'common.inc'

      COMMON/QUEST/IQUEST(100)
      INTEGER IQUEST

      REAL COSTHT,THT
      REAL P0

      CALL VZERO(XNTP101,L101)

      COSTHT=PCM(3,1)/SQRT(PCM(1,1)**2+
     +       PCM(2,1)**2+PCM(3,1)**2)

      THT=ACOSD(COSTHT)
      XNTP101(1)=THT
      XNTP101(2)=EDEPCAL1
      XNTP101(3)=EDEPCAL2
      XNTP101(4)=MIN(EDEPCAL1,EDEPCAL2)
      XNTP101(5)=EDEP(500)

      COSTHT=(PART(1,1,NR)*PART(1,2,NR)+
     +PART(2,1,NR)*PART(2,2,NR)+PART(3,1,NR)*PART(3,2,NR))/
     +(PART(5,1,NR)*PART(5,2,NR)) 
      IF (ABS(COSTHT).LE.1.) THEN
        XNTP101(6)=ACOSD(COSTHT)
      ELSEIF (COSTHT.EQ.-1.) THEN
        XNTP101(6)=180.
      ELSEIF (COSTHT.EQ.1.) THEN
        XNTP101(6)=0.
      ENDIF
       
      XNTP101(6)=EDEPTOT

      XNTP101(7)=PART(4,1,NR)
      XNTP101(8)=PART(4,2,NR)

C cosine of relative angle between gamma1 and gamma2
      THT=(PART(1,1,NR)*PART(1,2,NR)+PART(2,1,NR)*PART(2,2,NR)+
     +       PART(3,1,NR)*PART(3,2,NR))/
     +       (PART(4,1,NR)*PART(4,2,NR))

      COSTHT=(PART(3,1,NR)+PART(3,2,NR))/
     +       SQRT(PART(4,1,NR)**2+PART(4,2,NR)**2-2.*
     +       PART(4,1,NR)*PART(4,2,NR)*THT)

      IF (ABS(COSTHT).LE.1.) THEN
        XNTP101(9)=ACOSD(COSTHT)
      ELSEIF (COSTHT.EQ.-1.) THEN
        XNTP101(9)=180.
      ELSEIF (COSTHT.EQ.1.) THEN
        XNTP101(9)=0.
      ENDIF

      XNTP101(10)=EDEPCAL

C
      P0=SQRT(TINC(1)*TINC(1)+2.*TINC(1)*MPP)
      IF (TINC(1).GT.0.) THEN
         TECM=SQRT(MPP*MPP+MPR*MPR+2.*(MPP+TINC(1))*MPR)
      ELSE
         TECM=MPP+MPR
      ENDIF
      IF (TINC(1).NE.0.) ! pion beam in z-direction
     +   CALL BOOST(TECM,0.,0.,P0,PCM(4,1),PCM(1,1),PCM(2,1),PCM(3,1))
      COSTHT=PCM(3,1)/SQRT(PCM(1,1)**2+
     +       PCM(2,1)**2+PCM(3,1)**2)
      THT=ACOSD(COSTHT)
      XNTP101(9)=THT
C

C--   Fill Row-wise Ntp
      IF (EDEPCAL1.GT.1..AND.EDEPCAL2.GT.1.0
     +   .AND.EDEPTOT.GT.0.1.AND.EDEPCAL.GT.0.1) 
     +    CALL HFN(101,XNTP101)

      RETURN
      END   
