      PROGRAM GEN_PI_ENUG

*     04OCT95 EF
*      
*     ----------------------------------------------------------------- 
*
c      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG
      INTEGER ZEROFLAG
      COMMON/TENSOR/sqme,sqme1,sqme2,sqme3,T_1,T_2

c      INCLUDE '../common.inc'
      COMMON/GENIN/NP,TECM,AMASS(18),KGENEV
      COMMON/GENOUT/PCM(5,18),WT
      REAL TECM,AMASS,PCM,WT
      INTEGER NP,KGENEV

      REAL ELAB,X0,Y0,Z0,R0,PLAB(3),UBUF(10),
     +     COSRA,RELANG,LAMBDA
      INTEGER NVERT,NT,LRECL,ICYCLE,I,ISTAT,NEV1

      REAL T1MAX,T2MAX,X,Y,X1MAX,Y1MAX
      REAL V1,V2,V3,V4

      REAL MPP,MEP
*
*     ----------------------------------------------------------------- 
*
*     GENERATE PI + -> E+ NU G
*     REFERENCE: BRYMAN,D.A., DEPOMMIER,P., LEROY,C.: PHYS. REP. 88, 3 (1982)
*                BROWN,S.G., BLUDMAN,S.A.: PHYS. REV. 136B, 1160 (1964)

      common /pawc/h(1000000)

      lrecl=1024
      call hlimit (1000000)
      call hropen(1,'tensor','tensor.rz','n',lrecl,istat)

      call hbook1 (100000,'lam distr V-A xgt09', 110,-0.1,1.1,0.)
      call hbook1 (100001,'lam distr V-A+T xgt09', 110,-0.1,1.1,0.)
      call hbook1 (100002,'lam distr V-A Bry82', 110,-0.1,1.1,0.)

      call hbook1 (100010,'lam distr V-A xgt09', 11,-0.1,1.1,0.)
      call hbook1 (100011,'lam distr V-A+T xgt09', 11,-0.1,1.1,0.)
      call hbook1 (100012,'lam distr Number of Events', 11,-0.1,1.1,0.)

      call hbook1 (100020,'costh distr V-A xgt09', 22,-1.1,1.1,0.)
      call hbook1 (100021,'costh distr V-A+T xgt09', 22,-1.1,1.1,0.)
      call hbook1 (100022,'costh distr No of Evts', 22,-1.1,1.1,0.)

      call hbook1 (200000,'lam distr all x', 110,-0.1,1.1,0.)
      call hbook1 (200001,'lam distr all x', 110,-0.1,1.1,0.)

      call hbook2 (300000,'Eg vs Ee',100,0.,100.,100,0.,100.,0.)

      call hbook1 (300001,'RA EG>63 EE>15', 100,0.,190.,0.)
      call hbook1 (300002,'lam distr EG>63 EE>15', 110,-0.1,1.1,0.)
      call hbook1 (300003,'RA EG>63 EE>15 l>.2', 100,0.,190.,0.)

      call hbook2 (400000,'x vs y',100,0.,2.,100,0.,2.,0.)

      call hbook1 (500001,'x IB', 100,0.,1.,0.)
      call hbook1 (500002,'x SD', 100,0.,1.,0.)
      call hbook1 (500003,'x T1', 100,0.,1.,0.)
      call hbook1 (500004,'x T2', 100,0.,1.,0.)

      T1MAX=0.
      T2MAX=0.

      NEV1=0

      DO I=1,100000

      NP=3
      TECM=0.13956995
      MPP= 0.13956995
      KGENEV=1
      AMASS(1)=0.000510999  !  pi+ -> e+ nu g decay
c      AMASS(1)=0.10566 !  pi+ -> mu+ nu g decay
      AMASS(2)=0.0
      AMASS(3)=0.0

 1111 CALL GENBOD
*     MATRIX ELEMENT SQUARED
      CALL MATRIX_PI_ENUG
      IF(ZEROFLAG.EQ.1) GOTO 1111
      X=2.*PCM(4,3)/MPP
      Y=2.*PCM(4,1)/MPP

      PLAB(1)=PCM(1,1)
      PLAB(2)=PCM(2,1)
      PLAB(3)=PCM(3,1)
      ELAB=PCM(4,1)
*
      COSRA=(PCM(1,1)*PCM(1,3)+PCM(2,1)*PCM(2,3)+
     +  PCM(3,1)*PCM(3,3))/(SQRT(PCM(1,1)**2+PCM(2,1)**2+PCM(3,1)**2)*
     +  SQRT(PCM(1,3)**2+PCM(2,3)**2+PCM(3,3)**2)) 
      IF(ABS(COSRA).LE.1.) THEN
         RELANG=57.29578*ACOS(COSRA)
      ELSEIF(COSRA.GE.1.) THEN
         RELANG=0.
      ELSEIF(COSRA.LE.-1.)THEN
         RELANG=180.
      ENDIF

      IF(X.GT.0.) LAMBDA=(X+Y-1.)/X

      IF( (2.*PCM(4,3)/MPP).GT.0.9.and.lambda.gt.0.2) THEN
c      IF( (2.*PCM(4,3)/MPP).GT.0.21.and. (2.*PCM(4,1)/MPP).GT.0.9
c     .    .and.relang.gt.30.) THEN
c      IF( (2.*PCM(4,3)/MPP).GT.0.9.and.(2.*PCM(4,1)/MPP).GT.0.9) THEN
c     .     .and.lambda.gt.0.2) THEN
        NEV1=NEV1+1
        CALL HFILL(100000,LAMBDA,0.,SQME1+SQME2)
        CALL HFILL(100001,LAMBDA,0.,SQME1+SQME2+SQME3)
        CALL HFILL(100010,LAMBDA,0.,SQME1+SQME2)
        CALL HFILL(100011,LAMBDA,0.,SQME1+SQME2+SQME3)
        CALL HFILL(100012,LAMBDA,0.,1.)       

        CALL HFILL(100020,COSRA,0.,SQME1+SQME2)
        CALL HFILL(100021,COSRA,0.,SQME1+SQME2+SQME3)
        CALL HFILL(100022,COSRA,0.,1.)       
      ENDIF
c      IF(NEV1.GT.10000) goto 9999

      IF(PCM(4,3).gt.0.048.and.PCM(4,1).gt.0.048)
     .  CALL HFILL(100002,LAMBDA,0.,SQME1)
 
      CALL HFILL(200000,LAMBDA,0.,SQME1+SQME2)
      CALL HFILL(200001,LAMBDA,0.,SQME1+SQME2+sqme3)

c      print *, x,y,sqme
c      print *, sqme3
c      IF(SQME3.GE.T1MAX) THEN
c         T1MAX=SQME3
c         X1MAX=X
c         Y1MAX=Y
c      ENDIF

      IF(PCM(4,3).GT.0.06281) THEN
        CALL HFILL(300001,RELANG,0.,1.)
        CALL HFILL(300002,LAMBDA,0.,SQME)
      ENDIF

      V3=real(T_1)
      V4=real(T_2)
      IF(LAMBDA.GT.0.1) THEN
        CALL HFILL(500001,X,0.,SQME1)
        CALL HFILL(500002,X,0.,SQME2)
        CALL HFILL(500003,X,0.,abs(T_1))
        CALL HFILL(500004,X,0.,abs(T_2))
      ENDIF

c     IF(PCM(4,1).GT.0.0147.AND.PCM(4,3).GT.0.06281.
c    +   AND.LAMBDA.GT.0.2) THEN
c       CALL HFILL(300003,RELANG,0.,SQME)
c     ENDIF

      CALL HFILL(400000,X,Y,1.)

      ENDDO

c      print *,T1MAX,X1MAX,Y1MAX

 9999 call hrout(0,icycle,' ')
      call hrend('tensor')

      STOP
      END   

      SUBROUTINE MATRIX_PI_ENUG

      IMPLICIT NONE
      COMMON/PIENUGBLOCK/ZEROFLAG
      INTEGER ZEROFLAG
      COMMON/TENSOR/sqme,sqme1,sqme2,sqme3,T_1,T_2
      REAL sqme,sqme1,sqme2,sqme3,T_1,T_2

      COMMON/GENIN/NP,TECM,AMASS(18),KGENEV
      COMMON/GENOUT/PCM(5,18),WT
      REAL TECM,AMASS,PCM,WT
      INTEGER NP,KGENEV

      REAL X,Y,LAM
      REAL F_V,F_A,G,F_T
      REAL M_PI,M_E,R,F_PI,AL,PI,GPIENU
      REAL X1,Y1,X2,Y2
      REAL IB,SDP,SDM,SD,INTP,INTM,INT,T1,T2,T
      REAL G_RAD_IB,G_RAD_SD,G_RAD_INT,G_RAD_T,G_RAD_T1,G_RAD_T2

C Constants are calculated from the 1990 Review of
C Particle properties

      F_V=0.0259
      F_A=0.01295
      G=F_A/F_V
      F_T=0.0 ! -5.6E-3

      M_PI=139.57018
      M_E=0.5109989
      R=(M_E/M_PI)**2
      F_PI=130.7

      AL=1./137.036
      PI=3.14159
      GPIENU=1.230E-4

      X=(2.*1000.*PCM(4,3)/M_PI)
      Y=(2.*1000.*PCM(4,1)/M_PI)

C     Test all denominators, skip event if division by ZERO

      ZEROFLAG=0
      IF (X.LE.0..OR.Y.LE.0..OR.(X+Y-1.).EQ.0..OR.(x+y-1.-R).LE.0.) THEN
        ZEROFLAG=1
        write(6,*) 'zero'
        RETURN
      ENDIF

      LAM=(X+Y-1.0)/X

C--   Matrix element with Tensor force,
C--   A. V. Chernyshev et al., Modern Physics Letters A, Vol. 12, 1669
C--   (1997)

      IB= ( (1.-y+R)/((x**2)*(x+y-1.-R)) )*
     . ( (x**2)+2.*(1.-x)*(1.-R)+(2.*x*R*(1.-R))/(x+y-1.-R) )

      SDP= (x+y-1.-R)*((x+y-1.)*(1.-x)-R)

      SDM= (1.-y+R)*((1.-x)*(1.-y)+R)

      SD= ((1.+G)**2)*SDP+((1.-G)**2)*SDM
      SD= ( ((F_V*M_PI**2)/(2.*F_PI*M_E))**2 )*SD

      INTP= ((1.-y+R)/(x*(x+y-1.-R)))*
     . ((1.-x)*(1.-x-y)+R)

      INTM= ((1.-y+R)/(x*(x+y-1.-R)))*
     . ((x**2)-(1.-x)*(1.-x-y)-R)

      INT=(1.+G)*INTP+(1.-G)*INTM
      INT=(F_V*M_PI/F_PI)*INT

      T1= (1.-y)/x
      T1= ((2.*F_T*M_PI**2)/(F_PI*M_E))*T1

      T2= (1.-y)*(x+y-1.)
      T2= ( ((F_T*M_PI**2)/(F_PI*M_E))**2 )*T2

      T=T1+T2

      G_RAD_IB=AL/(2.*PI)*GPIENU*IB
      G_RAD_SD=AL/(2.*PI)*GPIENU*SD
      G_RAD_INT=AL/(2.*PI)*GPIENU*INT
 
      G_RAD_T=AL/(2.*PI)*GPIENU*T
      G_RAD_T1=AL/(2.*PI)*GPIENU*T1
      G_RAD_T2=AL/(2.*PI)*GPIENU*T2

      SQME1=G_RAD_IB
      SQME2=G_RAD_SD
      SQME3=G_RAD_T
      SQME=SQME1+SQME2+SQME3
      T_1=G_RAD_T1
      T_2=G_RAD_T2

 999  CONTINUE

      RETURN
      END

      include 'genbod.f'








