************************************************************************    
*
       SUBROUTINE GEN_TRIG
*
*
*      History
*      -------
*
*      112695 EF created
*
************************************************************************    
*
      IMPLICIT NONE
      INCLUDE '../common.inc'
      INTEGER  LVMAX
      EXTERNAL LVMAX

*yw4f add parameter anum
      real anum
      parameter (anum=180.0/3.14159)
*yw4f end
      COMMON /FCLUSTER/CC(9,60),SCC(6,10),CADC(60),CTDC(60),
     +       FIREDL(60),FIREDH(60),BFIREDL(60),BFIREDH(60),
     +       NFIREDL,NFIREDH,SFIREDL(10),SFIREDH(10),
     +       BSFIREDL(10),BSFIREDH(10),NSFIREDL,
     +       NSFIREDH,CLTHT(60),CLPHI(60),THT12,HTRIGGER(50),
     +       LTRIGGER(50),ICLUST,THT1,PHI1,TDC1,TDC2

      REAL CADC,CTDC,THT1,THT2,THT3,THT12,CLTHT,CLPHI,PHI1,PHI2,
     +     TDC1,TDC2
      INTEGER CC,SCC,FIREDL,FIREDH,BFIREDL,BFIREDH,NFIREDL,
     +        NFIREDH,SFIREDL,SFIREDH,BSFIREDL,BSFIREDH,
     +        NSFIREDL,NSFIREDH,HTRIGGER,LTRIGGER,ICLUST
     
      COMMON/SUPERDEP/EDEPS(10),GA1D,GA2D,IGA1D,IGA2D,THTC
      REAL EDEPS,GA1D,GA2D,THTC

      REAL IPASS,A(6),B(6),C(60)
      INTEGER I,J,K,IGA1D,IGA2D

C--   SuperCluster Definitions
*
* THT /  PHI
*          ____________________________________________
* 160deg   |      |      |      |      |       |       |
*          | SCL6 | SCL7 | SCL8 | SCL9 | SCL10 | SCL6  |
*          |----------------------------------------------
*             | SCL1 | SCL2 | SCL3 | SCL4 |  SCL5 | SCL1 |
* 20deg       |      |      |      |      |       |      |
*             --------------------------------------------
*             0deg                           360deg
*
C--   Conjugate hemisphere indices

      INTEGER OHMSPH(5,10)
      DATA OHMSPH/ 3,  4,  8,  9, 10,
     +             4,  5,  9, 10,  6,
     +             5,  1, 10,  6,  7,
     +             1,  2,  6,  7,  8,
     +             2,  3,  7,  8,  9,
     +             8,  9,  2,  3,  4,
     +             9, 10,  3,  4,  5,
     +            10,  6,  4,  5,  1,
     +             6,  7,  5,  1,  2,
     +             7,  8,  1,  2,  3/

C--   Nearest-neighbor hemisphere indices

      INTEGER NHMSPH(5,10)
      DATA NHMSPH/ 1, 2,7,6,5,  2, 3,8,7,1,  3, 4,9,8,2, 
     +             4, 5,10,9,3, 5, 1,6,10,4, 6, 7,1,5,10,
     +             7, 8,2,1,6,  8, 9,3,2,7,  9, 10,4,3,8,
     +            10, 6,5,4,9/

C--   Zero HL and LL TRIGGER Flags
      DO I=1,50
        HTRIGGER(I)=0
        LTRIGGER(I)=0
      ENDDO
      
      TDC1=0.
      TDC2=0.

C--   PI_ENU trigger:    AT LEAST ONE supercluster fires (HL, LL)
C--   PI_PI0ENU trigger: ONE supercluster plus opposing hemisphere fires (HL, LL)

C--   HL TRIGGER
      GA1D=0.
      GA2D=0.
      DO I=1,10
        IPASS=0
        DO J=1,5
          IF (BSFIREDH(I).EQ.1.AND.BSFIREDH(OHMSPH(J,I)).EQ.1) THEN
C--         Assign the PI0 detected gamma energies
            HTRIGGER(11)=1                     ! HL pi_pi0enu trigger
            GA1D=MAX(EDEPS(I),GA1D)
            IF (EDEPS(I).EQ.GA1D) THEN
              IPASS=IPASS+1
              IGA1D=I                          ! Set gamma1 SuperCluster
              IF (IPASS.EQ.1) GA2D=0.          ! Zero conjugate SuperCluster
              GA2D=MAX(EDEPS(OHMSPH(J,I)),GA2D)! Set gamma2 SuperCluster
              IF (EDEPS(OHMSPH(J,I)).EQ.GA2D) IGA2D=OHMSPH(J,I)
            ENDIF
          ENDIF
        ENDDO
        IF (BSFIREDH(I).EQ.1) HTRIGGER(7)=1   ! HL pi_enu trigger
      ENDDO

C--   LL TRIGGER
      DO I=1,10
        DO J=1,5
          IF (BSFIREDL(I).EQ.1.AND.BSFIREDL(OHMSPH(J,I)).EQ.1) THEN
            LTRIGGER(11)=1                    ! pi_pi0enu LL trigger
          ENDIF
        ENDDO
        IF (BSFIREDL(I).EQ.1) LTRIGGER(7)=1   ! LL pi_enu trigger
      ENDDO

C 3-Cluster Low Trigger

      IF((BSFIREDL(1)*BSFIREDL(3)*BSFIREDL(10).EQ.1).OR.
     +   (BSFIREDL(1)*BSFIREDL(4)*BSFIREDL(8).EQ.1).OR.
     +   (BSFIREDL(1)*BSFIREDL(8)*BSFIREDL(10).EQ.1).OR.
     +   (BSFIREDL(2)*BSFIREDL(4)*BSFIREDL(6).EQ.1).OR.
     +   (BSFIREDL(2)*BSFIREDL(5)*BSFIREDL(9).EQ.1).OR.
     +   (BSFIREDL(2)*BSFIREDL(6)*BSFIREDL(9).EQ.1).OR.
     +   (BSFIREDL(3)*BSFIREDL(5)*BSFIREDL(7).EQ.1).OR.
     +   (BSFIREDL(3)*BSFIREDL(7)*BSFIREDL(10).EQ.1).OR.
     +   (BSFIREDL(4)*BSFIREDL(6)*BSFIREDL(8).EQ.1).OR.
     +   (BSFIREDL(5)*BSFIREDL(7)*BSFIREDL(9).EQ.1))
     +     LTRIGGER(15)=1                       ! 3-cluster trigger


C--   Find HIGH Clusters fired by (MU+,G), (E+,G) or PI0=(G1,G2)
      IF (HTRIGGER(11).EQ.1) THEN

      DO I=1,6
        A(I)=CADC(6*(IGA1D-1)+I)
        B(I)=CADC(6*(IGA2D-1)+I)
      ENDDO

C--   Find the most energetic cluster in set Supercluster
      ICLUST=6*(IGA1D-1)+LVMAX(A,6)

      TDC1=CTDC(ICLUST) ! Timing of FIRST gamma
      CALL DIRECTION    ! Direction of FIRST gamma
      THT1=CLTHT(1)
      PHI1=CLPHI(1)
      
      ICLUST=6*(IGA2D-1)+LVMAX(B,6)

      TDC2=CTDC(ICLUST) ! Timing of SECOND gamma
      CALL DIRECTION    ! Direction of SECOND gamma
      THT2=CLTHT(1)
      PHI2=CLPHI(1)

C--   At least two particles in final state
      IF (NR.EQ.6.OR.NR.EQ.8.OR.NR.EQ.9.OR.NR.EQ.11.OR.
     +    NR.EQ.14.OR.NR.EQ.15) THEN
C--   Check PI0 gamma ordering correct
*yw4f ommit D and add anum
*        IF ( ((SIND(THT1)*COSD(PHI1)*PART(1,1,NR)+
*     +         SIND(THT1)*SIND(PHI1)*PART(2,1,NR)+
*     +         COSD(THT1)*PART(3,1,NR))/PART(5,1,NR)).LT.
*     +       ((SIND(THT1)*COSD(PHI1)*PART(1,2,NR)+
*     +         SIND(THT1)*SIND(PHI1)*PART(2,2,NR)+
*     +         COSD(THT1)*PART(3,2,NR))/PART(5,2,NR)) ) THEN
*            IF(EDEPS(IGA2D).GT.0.)GA1D=EDEPS(IGA2D)
*            IF(EDEPS(IGA1D).GT.0.)GA2D=EDEPS(IGA1D)
*            THT1=THT2
*        ENDIF

        IF ( ((SIN(THT1/anum)*COS(PHI1/anum)*PART(1,1,NR)+
     +         SIN(THT1/anum)*SIN(PHI1/anum)*PART(2,1,NR)+
     +         COS(THT1/anum)*PART(3,1,NR))/PART(5,1,NR)).LT.
     +       ((SIN(THT1/anum)*COS(PHI1/anum)*PART(1,2,NR)+
     +         SIN(THT1/anum)*SIN(PHI1/anum)*PART(2,2,NR)+
     +         COS(THT1/anum)*PART(3,2,NR))/PART(5,2,NR)) ) THEN
            IF(EDEPS(IGA2D).GT.0.)GA1D=EDEPS(IGA2D)
            IF(EDEPS(IGA1D).GT.0.)GA2D=EDEPS(IGA1D)
            THT1=THT2
        ENDIF
*yw4f end
      ENDIF

      ENDIF ! IF HIGH TRIGGER=1

C--   Find Clusters fired by first particle (most energetic cluster)
      IF (HTRIGGER(7).EQ.1) THEN
        DO I=1,60
          C(I)=CADC(I)
        ENDDO
C--   Find the most energetic cluster in CALORIMETER
        ICLUST=LVMAX(C,60)
        CALL DIRECTION    ! Direction of first particle
        THT1=CLTHT(1)
        PHI1=CLPHI(1)
        GA1D=CADC(ICLUST)
      ENDIF

*yw4f ommit D and add anum
*      THT12=COSD(THT1)*COSD(THT2)+SIND(THT1)*SIND(THT2)*
*     +      COSD(PHI1-PHI2)
      THT12=COS(THT1/anum)*COS(THT2/anum)
     +      +SIN(THT1/anum)*SIN(THT2/anum)*
     +      COS((PHI1-PHI2)/anum)
*yw4f end
      IF(NR.EQ.1.OR.NR.EQ.2.OR.NR.EQ.3) THEN
        THT2= PART(3,1,NR)/SQRT(PART(1,1,NR)**2+PART(2,1,NR)**2
     +                                         +PART(3,1,NR)**2)
*yw4f ommit D and add anum
*        PHI2= ATAN2D(PART(2,1,NR),PART(1,1,NR))
        PHI2= anum*ATAN2(PART(2,1,NR),PART(1,1,NR))
*yw4f end
        IF(PHI2.LT.0.) PHI2=PHI2+360.
        IF(ABS(THT2).LE.1.) THEN
*yw4f ommit D and add anum
*          THT2=ACOSD(THT2)
          THT2=anum*ACOS(THT2)
*yw4f end
        ELSEIF(THT2.GT.1.)  THEN
          THT2=0.
        ELSE
          THT2=180.
        ENDIF
        IF(LTRIGGER(7).EQ.1) THEN
*yw4f ommit D and add anum
*          THT12=COSD(THT1)*COSD(THT2)+SIND(THT1)*SIND(THT2)*
*     +    COSD(PHI1-PHI2)
          THT12=COS(THT1/anum)*COS(THT2/anum)
     +          +SIN(THT1/anum)*SIN(THT2/anum)*
     +    COS((PHI1-PHI2)/anum)
*yw4f end
        ELSE
          THT12=181.
        ENDIF
      ENDIF

      IF (ABS(THT12).LE.1.) THEN
*yw4f ommit D and add anum
*        THT12=ACOSD(THT12)
        THT12=anum*ACOS(THT12)
*yw4f end
      ELSEIF (THT12.LT.-1.) THEN
        THT12=180.
      ELSEIF (THT12.GT. 1.) THEN
        THT12=0.
      ENDIF

      RETURN
      END   
