      FUNCTION MATRIX_PI_ENUEE(P,FIN,AIN,RIN)

C************************************************************************
C
C  MATRIXELEMENT OF PI->3ENU DECAY					
C  P = four momenta of the final state particles from GENBOD
C  FIN = vector form factor
C  AIN = first axial vector form factor
C  RIN = second axial vector form factor
C
C************************************************************************

      INTEGER SP,SPP,SPM,SK2
      REAL*4 FIN,AIN,RIN
      REAL*4 QG,QH,PPM,PPP,PPPM,PG,PH,GG,HH,HAMPL,EPS(2,2),P(5,18)
      REAL*4 M,ME,MPROTON,MMU,GF,PI,F,A,FPI,R,ALPHA,FACTOR,GAMMA
      REAL*4 NENN1,NENN2,NENN1S,NENN2S,NORM,GEWFAC(10)
      COMPLEX*8 I,AMPA,AMPAS,AMPF,AMPFS,AMPR,AMPRS,AMPB,AMPBS,ANS1
      COMPLEX*8 FPSU(2,2),FPSO(2,2),CPCO(2,2),CPCU(2,2)
      COMPLEX*8 FPPSU(2,2),FPPSO(2,2),CPPCO(2,2),CPPCU(2,2)
      COMPLEX*8 FPMSU(2,2),FPMSO(2,2),CPMCO(2,2),CPMCU(2,2)
      COMPLEX*8 FK2SU(2,2),FK2SO(2,2),CK2CO(2,2),CK2CU(2,2)
      COMPLEX*8 Q(2,2),QD(2,2),G(2,2),GD(2,2),H(2,2),HD(2,2)
      COMPLEX*8 C1,C2,C3,C4

      COMMON/CGEW/GEWFAC

      LOGICAL FIRST
      DATA FIRST/.TRUE./

      IF (FIRST) THEN
	FIRST=.FALSE.
        I = CMPLX(0.0,1.0) 
        M = 139.5673
	MMU=105.659
        ME= SQRT(ABS(P(4,1)*P(4,1)-P(1,1)*P(1,1)-P(2,1)*P(2,1)-
     .               P(3,1)*P(3,1)))
        FPI = 0.944*M
        PI= 3.141592653589793238
	MPROTON=938.28
	GF=1.02D-5/MPROTON**2
	ALPHA=1./137.03604
	FACTOR=2*GF**2/(2*PI)**11*(ALPHA/2/PI)**2
	FACTOR=FACTOR*(2*PI)**7/(2*M)
	GAMMA=(GF*FPI*MMU)**2*(M**2-MMU**2)**2/(8*PI*M**3)
	FACTOR=FACTOR/GAMMA		!FINAL RESULT EXPRESSED AS BRANCHING
      ENDIF				!RATIO

      F = FIN/M
      A = AIN/M
      R = RIN/M/FPI

C CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC C
C									      C
C                    BERECHNUNG DES AMPLITUDENQUADRATES VON                   C
C                            PI+ > E+ NU E+ E-                                C
C									      C
C CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC C
C
C       DIFFERENTIAL DECAYWIDTH=(2*PI)**3/(2*MPI)*|T|**2*PHASESPACEVOLUME
C	(UNIT=MeV)
C      
C               3    3       3
C        4   ( D P1 D P2    D P4  4
C       R =  | ---- ---- ...---- D(QM-P1-P2-P3-P4)
C            ) 2*E1 2*E2    2*E4
C				    4
C       PHASESPACEVOLUME=(2*PI)**4*R
C
C       IMPULSE AUS DER FOWL-ROUTINE:         KOMPONENTEN:
C            P(I,1) > P   POSITRON1           P(1,J) > PX
C            P(I,2) > PM  ELEKTRON            P(2,J) > PY
C            P(I,3) > PP  POSITRON2           P(3,J) > PZ
C                                             P(4,J) > E=SQRT(M**2+P**2)
C            P(I,4) > K2  E-NEUTRINO          P(5,J) > |P|
C       PHP,PHPP,PHPM...SIND DIE POLARWINKEL DER IMPULSVEKTOREN
C       THP,THPP,THPM...SIND DIE AZIMUTHWINKEL DER IMPULSVEKTOREN 
C
C       DIE BEZEICHNUNG DER SPINOREN HAT FOLGENDE SYNTAX:
C         {'C'HI ODER 'F'HI SPINOR}{IMPULSLABEL 'QM','P','PP'...}
C         {'C'APITAL ODER 'S'MALL VAN-DER-WAERDEN-INDEX}
C         {INDEX 'O'BEN ODER 'U'NTEN}
C          ( SPINORINDEX MIT WERT 1 ODER 2 , SPINEINSTELLUNG )
C       BEISPIEL:  FQMSU(2,1)
C       SQM,SP,SPP...SIND DIE INDIZES DER SPINOREINSTELLUNG
C
C       EPS(I,J) IST DER TOTAL ANTISYMM.TENSOR DER SPINORALGEBRA
C       G(I,J),H(I,J),Q(I,J) SIND DIE SL(2,C) KOVARIANTEN
C         TENSOREN DER IMPULSE PP+PM,P+PM,QM MIT INDEX UNTEN
C       GD(I,J),HD(I,J),QD(I,J) SIND DIE SL(2,C) KOVARIANTEN
C         TENSOREN DER IMPULSE PP+PM,P+PM,QM MIT INDEX OBEN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C           
C     EINIGE KOVARIANTEN AUS DEN 4-VEKTOREN
C
      QG = M*P(4,3)+M*P(4,2)             ! NUR IM RUHESYSTEM DES PIONS
      QH = M*P(4,1)+M*P(4,2)
      PPM  =P(4,1)*P(4,2)-P(1,1)*P(1,2)-P(2,1)*P(2,2)-P(3,1)*P(3,2)
      PPP  =P(4,1)*P(4,3)-P(1,1)*P(1,3)-P(2,1)*P(2,3)-P(3,1)*P(3,3)
      PPPM =P(4,3)*P(4,2)-P(1,3)*P(1,2)-P(2,3)*P(2,2)-P(3,3)*P(3,2)
      PG =PPP+PPM 
      PPH =ME**2+PPPM
      GG =2.0*(ME**2+PPPM)
      HH =2.0*(ME**2+PPM)
      NENN1 = 1./(2.*PG+GG)
      NENN1S= NENN1
      NENN2=1./(2.*QG-GG)
      NENN2S=1./(2.*QH-HH)
C
C     2-SPINOREN DES POSITRONS1
C
      NORM=1.0/SQRT( 2.0*( P(4,1)+ME ))
      FPSU(1,1)=NORM*( -P(1,1) + I*P(2,1)  )
      FPSU(2,1)=NORM*(-ME - P(4,1) + P(3,1))
      FPSU(1,2)=NORM*(-ME - P(4,1) - P(3,1))
      FPSU(2,2)=NORM*( -P(1,1) - I*P(2,1)  )
      CPCO(1,1)=NORM*(  P(1,1) - I*P(2,1)  )
      CPCO(2,1)=NORM*(-ME - P(4,1) - P(3,1))
      CPCO(1,2)=NORM*(-ME - P(4,1) + P(3,1))
      CPCO(2,2)=NORM*(  P(1,1) + I*P(2,1)  )
C
C     2-SPINOREN DES POSITRONS2
C
      NORM=1.0/SQRT( 2.0*( P(4,3)+ME ) )
      FPPSU(1,1)=NORM*( -P(1,3) + I*P(2,3)  )
      FPPSU(2,1)=NORM*(-ME - P(4,3) + P(3,3))
      FPPSU(1,2)=NORM*(-ME - P(4,3) - P(3,3))
      FPPSU(2,2)=NORM*( -P(1,3) - I*P(2,3)  )
      CPPCO(1,1)=NORM*(  P(1,3) - I*P(2,3)  )
      CPPCO(2,1)=NORM*(-ME - P(4,3) - P(3,3))
      CPPCO(1,2)=NORM*(-ME - P(4,3) + P(3,3))
      CPPCO(2,2)=NORM*(  P(1,3) + I*P(2,3)  )
C
C     2-SPINOREN DES ELEKTRONS
C
      NORM=1.0/SQRT( 2.0*( P(4,2)+ME ) )
      FPMSU(1,1)=NORM*( ME + P(4,2) + P(3,2))
      FPMSU(2,1)=NORM*(  P(1,2) + I*P(2,2)  )
      FPMSU(1,2)=NORM*(  P(1,2) - I*P(2,2)  )
      FPMSU(2,2)=NORM*( ME + P(4,2) - P(3,2))
      CPMCO(1,1)=NORM*( ME + P(4,2) - P(3,2))
      CPMCO(2,1)=NORM*( -P(1,2) - I*P(2,2)  )
      CPMCO(1,2)=NORM*( -P(1,2) + I*P(2,2)  )
      CPMCO(2,2)=NORM*( ME + P(4,2) + P(3,2))
C
C     2-SPINOREN DES ELEKTRONNEUTRINOS
C
      IF(P(4,4).LE.0.)THEN
        NORM=0.
      ELSE
        NORM=1.0/SQRT( 2.0*P(4,4) )
      ENDIF
      FK2SU(1,1)=NORM*(  P(4,4) + P(3,4)    )
      FK2SU(2,1)=NORM*(  P(1,4) + I*P(2,4)  )
      FK2SU(1,2)=NORM*(  P(1,4) - I*P(2,4)  )
      FK2SU(2,2)=NORM*(  P(4,4) - P(3,4)    )
      CK2CO(1,1)=NORM*(  P(4,4) - P(3,4)    )
      CK2CO(2,1)=NORM*( -P(1,4) - I*P(2,4)  )
      CK2CO(1,2)=NORM*( -P(1,4) + I*P(2,4)  )
      CK2CO(2,2)=NORM*(  P(4,4) + P(3,4)    )
C
C     HEBEN UND SENKEN DER SPINORINDIZES
C
      EPS(1,1)=0.0
      EPS(1,2)=1.0
      EPS(2,1)=-1.0
      EPS(2,2)=0.0
      DO 29 K=1,2
        DO 19 II=1,2
            FPSO(II,K)=0.0
            CPCU(II,K)=0.0
            FPPSO(II,K)=0.0
            CPPCU(II,K)=0.0
            FPMSO(II,K)=0.0
            CPMCU(II,K)=0.0
            FK2SO(II,K)=0.0
            CK2CU(II,K)=0.0
   19   CONTINUE
   29 CONTINUE
      DO 30 K=1,2
        DO 20 II=1,2
          DO 10 J=1,2
            FPSO(II,K)=FPSO(II,K)+EPS(II,J)*FPSU(J,K)
            CPCU(II,K)=CPCU(II,K)+EPS(II,J)*CPCO(J,K)
            FPPSO(II,K)=FPPSO(II,K)+EPS(II,J)*FPPSU(J,K)
            CPPCU(II,K)=CPPCU(II,K)+EPS(II,J)*CPPCO(J,K)
            FPMSO(II,K)=FPMSO(II,K)+EPS(II,J)*FPMSU(J,K)
            CPMCU(II,K)=CPMCU(II,K)+EPS(II,J)*CPMCO(J,K)
            FK2SO(II,K)=FK2SO(II,K)+EPS(II,J)*FK2SU(J,K)
            CK2CU(II,K)=CK2CU(II,K)+EPS(II,J)*CK2CO(J,K)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
C     SL(2,C) KOVARIANTE TENSOREN
C
C
C     DES PIONS
C
      Q(1,1) = M
      Q(1,2) = 0.0
      Q(2,1) = 0.0
      Q(2,2) = M

      QD(1,1) = M
      QD(1,2) = 0.0
      QD(2,1) = 0.0
      QD(2,2) = M
C
C     DES POSITRONS2 PLUS ELEKTRONS:
C
      G(1,1) = P(4,3) + P(3,3) + P(4,2) + P(3,2) 
      G(1,2) = P(1,3)-I*P(2,3) + P(1,2)-I*P(2,2)
      G(2,1) = P(1,3)+I*P(2,3) + P(1,2)+I*P(2,2)
      G(2,2) = P(4,3) - P(3,3) + P(4,2) - P(3,2)

      GD(1,1) = P(4,3) - P(3,3) + P(4,2) - P(3,2) 
      GD(1,2) =-P(1,3)+I*P(2,3) - P(1,2)+I*P(2,2)
      GD(2,1) =-P(1,3)-I*P(2,3) - P(1,2)-I*P(2,2)
      GD(2,2) = P(4,3) + P(3,3) + P(4,2) + P(3,2)
C
C DES POSITRONS1 PLUS ELEKTRON:
C
      H(1,1) = P(4,1) + P(3,1) + P(4,2) + P(3,2) 
      H(1,2) = P(1,1)-I*P(2,1) + P(1,2)-I*P(2,2)
      H(2,1) = P(1,1)+I*P(2,1) + P(1,2)+I*P(2,2)
      H(2,2) = P(4,1) - P(3,1) + P(4,2) - P(3,2)

      HD(1,1) = P(4,1) - P(3,1) + P(4,2) - P(3,2) 
      HD(1,2) =-P(1,1)+I*P(2,1) - P(1,2)+I*P(2,2)
      HD(2,1) =-P(1,1)-I*P(2,1) - P(1,2)-I*P(2,2)
      HD(2,2) = P(4,1) + P(3,1) + P(4,2) + P(3,2)
C
C CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC C
C								 C
C                BERECHNUNG DER AMPLITUDE                        C
C								 C
C CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC C
C
C     UEBER DIE SPINEINSTELLUNGEN VON P,PP,PM,QM WIRD SUMMIERT
C
      DO INDEX=1,10
	GEWFAC(INDEX)=0.
      ENDDO
      HAMPL = 0.0
      DO 4000 SK2=1,2
        DO 3000 SP=1,2
          DO 2000 SPP=1,2
            DO 1000 SPM=1,2 
C
C     DIESE SCHLEIFEN FUEHREN DIE MATRIZENMULTIPLIKATION AUS
C
      AMPA = 0.0
      AMPF = 0.0
      AMPR = 0.0
      AMPB = 0.0
      AMPAS = 0.0
      AMPFS = 0.0
      AMPRS = 0.0
      AMPBS = 0.0
C
      ANS1 = 1*(
     . -2.*(CONJG(CK2CO(1,SK2))*G(1,1)*CPCO(1,SP)+
     .      CONJG(CK2CO(1,SK2))*G(1,2)*CPCO(2,SP)+
     .      CONJG(CK2CO(2,SK2))*G(2,1)*CPCO(1,SP)+
     .      CONJG(CK2CO(2,SK2))*G(2,2)*CPCO(2,SP))*
     .  (CONJG(FPMSU(1,SPM))*QD(1,1)*FPPSU(1,SPP)+
     .   CONJG(FPMSU(2,SPM))*QD(2,2)*FPPSU(2,SPP))
     . -2.*(CONJG(CK2CO(1,SK2))*G(1,1)*CPCO(1,SP)+
     .      CONJG(CK2CO(1,SK2))*G(1,2)*CPCO(2,SP)+
     .      CONJG(CK2CO(2,SK2))*G(2,1)*CPCO(1,SP)+
     .      CONJG(CK2CO(2,SK2))*G(2,2)*CPCO(2,SP))*
     .   (CONJG(CPMCO(1,SPM))*Q(1,1)*CPPCO(1,SPP)+
     .    CONJG(CPMCO(2,SPM))*Q(2,2)*CPPCO(2,SPP))   )
      AMPA = AMPA + ANS1 + 1*(
     . -4.*(FPPSU(1,SPP)*CONJG(CK2CO(1,SK2))+
     .      FPPSU(2,SPP)*CONJG(CK2CO(2,SK2)))*
     .     (CPCO(1,SP)*CONJG(FPMSU(1,SPM))+
     .      CPCO(2,SP)*CONJG(FPMSU(2,SPM)))*GG
     . +4.*(FPPSU(1,SPP)*CONJG(CK2CO(1,SK2))+
     .      FPPSU(2,SPP)*CONJG(CK2CO(2,SK2)))*
     .     (CPCO(1,SP)*CONJG(FPMSU(1,SPM))+
     .      CPCO(2,SP)*CONJG(FPMSU(2,SPM)))*QG
     . -4.*(CPPCU(1,SPP)*CPCO(1,SP)+CPPCU(2,SPP)*CPCO(2,SP))*
     .     (CONJG(CK2CO(1,SK2))*CONJG(CPMCU(1,SPM))+
     .      CONJG(CK2CO(2,SK2))*CONJG(CPMCU(2,SPM)))*GG
     . +4.*(CPPCU(1,SPP)*CPCO(1,SP)+CPPCU(2,SPP)*CPCO(2,SP))*
     .     (CONJG(CK2CO(1,SK2))*CONJG(CPMCU(1,SPM))+
     .      CONJG(CK2CO(2,SK2))*CONJG(CPMCU(2,SPM)))*QG     )
      ANS1 =  - 2.*(
     . -(CONJG(CK2CO(1,SK2))*Q(1,1)*CONJG(FPMSO(1,SPM))+
     .   CONJG(CK2CO(2,SK2))*Q(2,2)*CONJG(FPMSO(2,SPM)))*
     .  (CPCU(1,SP)*GD(1,1)*FPPSU(1,SPP)+
     .   CPCU(1,SP)*GD(1,2)*FPPSU(2,SPP)+
     .   CPCU(2,SP)*GD(2,1)*FPPSU(1,SPP)+
     .   CPCU(2,SP)*GD(2,2)*FPPSU(2,SPP))
     . +(CONJG(CK2CO(1,SK2))*G(1,1)*CONJG(FPMSO(1,SPM))+
     .   CONJG(CK2CO(1,SK2))*G(1,2)*CONJG(FPMSO(2,SPM))+
     .   CONJG(CK2CO(2,SK2))*G(2,1)*CONJG(FPMSO(1,SPM))+
     .   CONJG(CK2CO(2,SK2))*G(2,2)*CONJG(FPMSO(2,SPM)))*
     .  (CPCU(1,SP)*QD(1,1)*FPPSU(1,SPP)+
     .   CPCU(2,SP)*QD(2,2)*FPPSU(2,SPP))
     . -(CONJG(CPMCO(1,SPM))*Q(1,1)*CPCO(1,SP)+
     .   CONJG(CPMCO(2,SPM))*Q(2,2)*CPCO(2,SP))*
     .  (CPPCU(1,SPP)*GD(1,1)*CONJG(CK2CU(1,SK2))+
     .   CPPCU(1,SPP)*GD(1,2)*CONJG(CK2CU(2,SK2))+
     .   CPPCU(2,SPP)*GD(2,1)*CONJG(CK2CU(1,SK2))+
     .   CPPCU(2,SPP)*GD(2,2)*CONJG(CK2CU(2,SK2)))    )
      AMPF = AMPF + ANS1 - 2.*(
     . +(CPPCU(1,SPP)*QD(1,1)*CONJG(CK2CU(1,SK2))+
     .   CPPCU(2,SPP)*QD(2,2)*CONJG(CK2CU(2,SK2)))*
     .  (CONJG(CPMCO(1,SPM))*G(1,1)*CPCO(1,SP)+
     .   CONJG(CPMCO(1,SPM))*G(1,2)*CPCO(2,SP)+
     .   CONJG(CPMCO(2,SPM))*G(2,1)*CPCO(1,SP)+
     .   CONJG(CPMCO(2,SPM))*G(2,2)*CPCO(2,SP))     )
      AMPR = AMPR + FPI*GG*(
     . -2.*(CONJG(CK2CO(1,SK2))*FPSU(1,SP)+
     .      CONJG(CK2CO(2,SK2))*FPSU(2,SP))*
     .     (CONJG(FPMSU(1,SPM))*QD(1,1)*FPPSU(1,SPP)+
     .      CONJG(FPMSU(2,SPM))*QD(2,2)*FPPSU(2,SPP))*ME*NENN2
     . -2.*(CONJG(CK2CO(1,SK2))*FPSU(1,SP)+
     .      CONJG(CK2CO(2,SK2))*FPSU(2,SP))*
     .     (CONJG(CPMCO(1,SPM))*Q(1,1)*CPPCO(1,SPP)+
     .      CONJG(CPMCO(2,SPM))*Q(2,2)*CPPCO(2,SPP))*ME*NENN2
     . +4.*(CONJG(CK2CO(1,SK2))*FPPSU(1,SPP)+
     .      CONJG(CK2CO(2,SK2))*FPPSU(2,SPP))*
     .     (CPCO(1,SP)*CONJG(FPMSU(1,SPM))+
     .      CPCO(2,SP)*CONJG(FPMSU(2,SPM)))
     . +4.*(CPPCU(1,SPP)*CPCO(1,SP)+
     .      CPPCU(2,SPP)*CPCO(2,SP))*
     .     (CONJG(CK2CO(1,SK2))*CONJG(CPMCU(1,SPM))+
     .      CONJG(CK2CO(2,SK2))*CONJG(CPMCU(2,SPM)))    )
      AMPB = AMPB + 2.*FPI*ME*(
     . -2.*(CONJG(CK2CO(1,SK2))*Q(1,1)*CONJG(FPMSO(1,SPM))+
     .      CONJG(CK2CO(2,SK2))*Q(2,2)*CONJG(FPMSO(2,SPM)))*
     .     (FPSO(1,SP)*FPPSU(1,SPP)+FPSO(2,SP)*FPPSU(2,SPP))*NENN1
     . +2.*(CONJG(CK2CO(1,SK2))*Q(1,1)*CPPCO(1,SPP)+
     .      CONJG(CK2CO(2,SK2))*Q(2,2)*CPPCO(2,SPP))*
     .     (CONJG(CPMCO(1,SPM))*FPSU(1,SP)+
     .      CONJG(CPMCO(2,SPM))*FPSU(2,SP))*NENN1
     . -2.*(CONJG(CK2CO(1,SK2))*FPSU(1,SP)+
     .      CONJG(CK2CO(2,SK2))*FPSU(2,SP))*
     .     (CONJG(FPMSU(1,SPM))*QD(1,1)*FPPSU(1,SPP)+
     .      CONJG(FPMSU(2,SPM))*QD(2,2)*FPPSU(2,SPP))*NENN2
     . -2.*(CONJG(CK2CO(1,SK2))*FPSU(1,SP)+
     .      CONJG(CK2CO(2,SK2))*FPSU(2,SP))*
     .     (CONJG(CPMCO(1,SPM))*Q(1,1)*CPPCO(1,SPP)+
     .      CONJG(CPMCO(2,SPM))*Q(2,2)*CPPCO(2,SPP))*NENN2      )
C
C
      ANS1 = 1*(
     . -2.*(CONJG(CK2CO(1,SK2))*H(1,1)*CPPCO(1,SPP)+
     .      CONJG(CK2CO(1,SK2))*H(1,2)*CPPCO(2,SPP)+
     .      CONJG(CK2CO(2,SK2))*H(2,1)*CPPCO(1,SPP)+
     .      CONJG(CK2CO(2,SK2))*H(2,2)*CPPCO(2,SPP))*
     .  (CONJG(FPMSU(1,SPM))*QD(1,1)*FPSU(1,SP)+
     .   CONJG(FPMSU(2,SPM))*QD(2,2)*FPSU(2,SP))
     . -2.*(CONJG(CK2CO(1,SK2))*H(1,1)*CPPCO(1,SPP)+
     .      CONJG(CK2CO(1,SK2))*H(1,2)*CPPCO(2,SPP)+
     .      CONJG(CK2CO(2,SK2))*H(2,1)*CPPCO(1,SPP)+
     .      CONJG(CK2CO(2,SK2))*H(2,2)*CPPCO(2,SPP))*
     .  (CONJG(CPMCO(1,SPM))*Q(1,1)*CPCO(1,SP)+
     .   CONJG(CPMCO(2,SPM))*Q(2,2)*CPCO(2,SP))   )
      AMPAS = AMPAS + ANS1 + 1*(
     . -4.*(FPSU(1,SP)*CONJG(CK2CO(1,SK2))+
     .      FPSU(2,SP)*CONJG(CK2CO(2,SK2)))*
     .     (CPPCO(1,SPP)*CONJG(FPMSU(1,SPM))+
     .      CPPCO(2,SPP)*CONJG(FPMSU(2,SPM)))*HH
     . +4.*(FPSU(1,SP)*CONJG(CK2CO(1,SK2))+
     .      FPSU(2,SP)*CONJG(CK2CO(2,SK2)))*
     .     (CPPCO(1,SPP)*CONJG(FPMSU(1,SPM))+
     .      CPPCO(2,SPP)*CONJG(FPMSU(2,SPM)))*QH
     . -4.*(CPCU(1,SP)*CPPCO(1,SPP)+
     .      CPCU(2,SP)*CPPCO(2,SPP))*
     .     (CONJG(CK2CO(1,SK2))*CONJG(CPMCU(1,SPM))+
     .      CONJG(CK2CO(2,SK2))*CONJG(CPMCU(2,SPM)))*HH
     . +4.*(CPCU(1,SP)*CPPCO(1,SPP)+
     .      CPCU(2,SP)*CPPCO(2,SPP))*
     .     (CONJG(CK2CO(1,SK2))*CONJG(CPMCU(1,SPM))+
     .      CONJG(CK2CO(2,SK2))*CONJG(CPMCU(2,SPM)))*QH      )
      ANS1 = - 2.*(
     . -(CONJG(CK2CO(1,SK2))*Q(1,1)*CONJG(FPMSO(1,SPM))+
     .   CONJG(CK2CO(2,SK2))*Q(2,2)*CONJG(FPMSO(2,SPM)))*
     .  (CPPCU(1,SPP)*HD(1,1)*FPSU(1,SP)+
     .   CPPCU(1,SPP)*HD(1,2)*FPSU(2,SP)+
     .   CPPCU(2,SPP)*HD(2,1)*FPSU(1,SP)+
     .   CPPCU(2,SPP)*HD(2,2)*FPSU(2,SP))
     . +(CONJG(CK2CO(1,SK2))*H(1,1)*CONJG(FPMSO(1,SPM))+
     .   CONJG(CK2CO(1,SK2))*H(1,2)*CONJG(FPMSO(2,SPM))+
     .   CONJG(CK2CO(2,SK2))*H(2,1)*CONJG(FPMSO(1,SPM))+
     .   CONJG(CK2CO(2,SK2))*H(2,2)*CONJG(FPMSO(2,SPM)))*
     .  (CPPCU(1,SPP)*QD(1,1)*FPSU(1,SP)+
     .   CPPCU(2,SPP)*QD(2,2)*FPSU(2,SP))
     . -(CONJG(CPMCO(1,SPM))*Q(1,1)*CPPCO(1,SPP)+
     .   CONJG(CPMCO(2,SPM))*Q(2,2)*CPPCO(2,SPP))*
     .  (CPCU(1,SP)*HD(1,1)*CONJG(CK2CU(1,SK2))+
     .   CPCU(1,SP)*HD(1,2)*CONJG(CK2CU(2,SK2))+
     .   CPCU(2,SP)*HD(2,1)*CONJG(CK2CU(1,SK2))+
     .   CPCU(2,SP)*HD(2,2)*CONJG(CK2CU(2,SK2)))   )
      AMPFS = AMPFS + ANS1 - 2.*(
     . +(CONJG(CPMCO(1,SPM))*H(1,1)*CPPCO(1,SPP)+
     .   CONJG(CPMCO(1,SPM))*H(1,2)*CPPCO(2,SPP)+
     .   CONJG(CPMCO(2,SPM))*H(2,1)*CPPCO(1,SPP)+
     .   CONJG(CPMCO(2,SPM))*H(2,2)*CPPCO(2,SPP))*
     .  (CPCU(1,SP)*QD(1,1)*CONJG(CK2CU(1,SK2))+
     .   CPCU(2,SP)*QD(2,2)*CONJG(CK2CU(2,SK2)))   )
      AMPRS = AMPRS + FPI*HH*(
     . -2.*(CONJG(CK2CO(1,SK2))*FPPSU(1,SPP)+
     .      CONJG(CK2CO(2,SK2))*FPPSU(2,SPP))*
     .     (CONJG(FPMSU(1,SPM))*QD(1,1)*FPSU(1,SP)+
     .      CONJG(FPMSU(2,SPM))*QD(2,2)*FPSU(2,SP))*ME*NENN2S
     . -2.*(CONJG(CK2CO(1,SK2))*FPPSU(1,SPP)+
     .      CONJG(CK2CO(2,SK2))*FPPSU(2,SPP))*
     .     (CONJG(CPMCO(1,SPM))*Q(1,1)*CPCO(1,SP)+
     .      CONJG(CPMCO(2,SPM))*Q(2,2)*CPCO(2,SP))*ME*NENN2S
     . +4.*(CONJG(CK2CO(1,SK2))*FPSU(1,SP)+
     .      CONJG(CK2CO(2,SK2))*FPSU(2,SP))*
     .     (CPPCO(1,SPP)*CONJG(FPMSU(1,SPM))+
     .      CPPCO(2,SPP)*CONJG(FPMSU(2,SPM)))
     . +4.*(CPCU(1,SP)*CPPCO(1,SPP)+CPCU(2,SP)*CPPCO(2,SPP))*
     .     (CONJG(CK2CO(1,SK2))*CONJG(CPMCU(1,SPM))+
     .      CONJG(CK2CO(2,SK2))*CONJG(CPMCU(2,SPM)))     )
      AMPBS = AMPBS + 2.*FPI*ME*(
     . -2.*(CONJG(CK2CO(1,SK2))*Q(1,1)*CONJG(FPMSO(1,SPM))+
     .      CONJG(CK2CO(2,SK2))*Q(2,2)*CONJG(FPMSO(2,SPM)))*
     .     (FPPSO(1,SPP)*FPSU(1,SP)+FPPSO(2,SPP)*FPSU(2,SP))*NENN1S
     . +2.*(CONJG(CK2CO(1,SK2))*Q(1,1)*CPCO(1,SP)+
     .      CONJG(CK2CO(2,SK2))*Q(2,2)*CPCO(2,SP))*
     .     (CONJG(CPMCO(1,SPM))*FPPSU(1,SPP)+
     .      CONJG(CPMCO(2,SPM))*FPPSU(2,SPP))*NENN1S
     . -2.*(CONJG(CK2CO(1,SK2))*FPPSU(1,SPP)+
     .      CONJG(CK2CO(2,SK2))*FPPSU(2,SPP))*
     .     (CONJG(FPMSU(1,SPM))*QD(1,1)*FPSU(1,SP)+
     .      CONJG(FPMSU(2,SPM))*QD(2,2)*FPSU(2,SP))*NENN2S
     . -2.*(CONJG(CK2CO(1,SK2))*FPPSU(1,SPP)+
     .      CONJG(CK2CO(2,SK2))*FPPSU(2,SPP))*
     .     (CONJG(CPMCO(1,SPM))*Q(1,1)*CPCO(1,SP)+
     .      CONJG(CPMCO(2,SPM))*Q(2,2)*CPCO(2,SP))*NENN2S      )
C
C     FUER JEDE SPINKONFIGURATION WIRD DIE HELIZITAETSAMPLITUDE BERECHNET
C     DIE BEITRAEGE DER HELIZITAETSAMPLITUDEN WERDEN AUFSUMMIERT
C     
      C1=(AMPA/GG-AMPAS/HH)*0.5
      C2=(AMPF/GG-AMPFS/HH)*0.5
      C3=(AMPR/GG-AMPRS/HH)*0.5
      C4=(AMPB/GG-AMPBS/HH)*0.5

      GEWFAC(1)=GEWFAC(1)+ABS(C1)**2			!*A*A
      GEWFAC(2)=GEWFAC(2)+ABS(C2)**2			!*F*F
      GEWFAC(3)=GEWFAC(3)+ABS(C3)**2			!*R*R
      GEWFAC(4)=GEWFAC(4)+ABS(C4)**2			!*1
      GEWFAC(5)=GEWFAC(5)+2*REAL(C1*CONJG(C2))		!*A*F
      GEWFAC(6)=GEWFAC(6)+2*REAL(C1*CONJG(C3))		!*A*R
      GEWFAC(7)=GEWFAC(7)+2*REAL(C2*CONJG(C3))		!*R*F
      GEWFAC(8)=GEWFAC(8)+2*REAL(C1*CONJG(C4))		!*A
      GEWFAC(9)=GEWFAC(9)+2*REAL(C2*CONJG(C4))		!*F
      GEWFAC(10)=GEWFAC(10)+2*REAL(C3*CONJG(C4))	!*R

      HAMPL=HAMPL+ABS(0.5*(A*AMPA+F*AMPF+R*AMPR+AMPB)/GG
     .                -0.5*(A*AMPAS+F*AMPFS+R*AMPRS+AMPBS)/HH )**2
C
 1000       CONTINUE
 2000     CONTINUE
 3000   CONTINUE
 4000 CONTINUE

      PI3ENU = FACTOR*HAMPL
      DO INDEX=1,10
	GEWFAC(INDEX)=GEWFAC(INDEX)*FACTOR
      ENDDO

      RETURN
      END    
